2011-02-06  John W. Eaton  <jwe@octave.org>

	* PermMatrix.cc (operator*): Fix mixed row/column permutation
	case.  Bug #32346.

2010-02-04  Rik  <octave@nomad.inbox5.com>

	* Makefile.am: Undo accidental checkin

2011-02-03  John W. Eaton  <jwe@octave.org>

	* cmd-hist.cc (gnu_history::do_process_histcontrol):
	Rename from command_history::do_process_histcontrol.
	(gnu_history::do_histcontrol): Rename from
	command_history::do_histcontrol.
	* cmd-hist.h (command_history::do_histcontrol): Provide dummy version.
	* cmd-hist.cc (command_history::do_process_histcontrol): Likewise.
	Bug #32325.

2011-02-02  John W. Eaton  <jwe@octave.org>

	* Range.cc (Range::Range (double, double, octave_idx_type)):
	Correctly compute limit from base, increment and number of
	elements.  Bug #32321.

2011-01-31  John W. Eaton  <jwe@octave.org>

	* Sparse.cc (Sparse<T>::assign (const idx_vector&, const idx_vector&,
	const Sparse<T>&)): Handle case of LHS originally empty, and
	with non-colon indices.  Fix typo in previous change.  Bug #32263.

2011-01-30  Pascal Dupuis  <Pascal.Dupuis@worldonline.be>

	* lo-sysdep.cc (opendir): On error, free allocated DIR object
	before returning.

2011-01-28  John W. Eaton  <jwe@octave.org>

	* eigs-base.cc: Remove #endif corresponding to "#ifdef HAVE_ARPACK",
	not the one that matched "#if !defined (CXX_NEW_FRIEND_TEMPLATE_DECL)".

2011-01-28  John W. Eaton  <jwe@octave.org>

	* eigs-base.cc (EigsRealNonSymmetricFunc,
	EigsRealNonSymmetricMatrix, EigsRealNonSymmetricMatrixShift):
	Initialize eig_vec2 to 0 before calling dneupd.

2011-01-28  John W. Eaton  <jwe@octave.org>

	* eigs-base.cc: Assume we have ARPACK.

2011-01-27  John W. Eaton  <jwe@octave.org>

	* Sparse.cc (Sparse<T>::assign (const idx_vector&, const idx_vector&,
	const Sparse<T>&)): Allow 0x0 LHS with colon dimensions to
	inherit dimensions from RHS.  Fix tests.  Bug #32263.

2011-01-26  John W. Eaton  <jwe@octave.org>

	* oct-refcount.h: Strip trailing whitespace.

2011-01-24  Pascal Dupuis  <Pascal.Dupuis@worldonline.be>

	* SparseQR.h (class SparseQR::SparseQR_reps): Disallow copying.
	* Array.cc (class rec_permute_helper, class rec_index_helper,
	class  rec_resize_helper): Likewise.
	* cmd-edit.cc (class default_command_editor): Likewise.

2011-01-22  Jaroslav Hajek  <highegg@gmail.com>

	* oct-refcount.h: New source.
	* Makefile.am: Add it here.

	* Array.h: Use octave_refcount for refcounting.
	* Sparse.h: Ditto.
	* SparseCmplxQR.h: Ditto.
	* SparseQR.h: Ditto.
	* idx-vector.h: Ditto.
	* oct-shlib.h: Ditto.
	* sparse-base-chol.h: Ditto.

2011-01-21  Pascal Dupuis  <Pascal.Dupuis@worldonline.be>

	* oct-fftw.h (class octave_fftw_planner): Disallow copying
	(class octave_float_fftw_planner): Likewise.
	* oct-sort.h (class octave_sort): Likewise.
	(struct oct_sort::MergeState): Likewise.
	* SparseCmplxQR.h (class SparseComplexQR::SparseComplexQR_rep):
	Likewise.
	* sparse-base-chol.h (class sparse_base_cho::sparse_base_chol_rep):
	Likewise.

2011-01-21  John W. Eaton  <jwe@octave.org>

	* CMatrix.cc (xgemm): Initialize output matrix for call to ZHERK.
	* fCMatrix.cc (xgemm): Initialize output matrix for call to CHERK.

2011-01-20  John W. Eaton  <jwe@octave.org>

	* Array-b.cc, Array-d.cc, Array-f.cc, Array-util.cc,
	Array-util.h, Array.cc, Array.h, Array3.h, CColVector.cc,
	CColVector.h, CDiagMatrix.cc, CDiagMatrix.h, CMatrix.cc,
	CMatrix.h, CNDArray.cc, CNDArray.h, CSparse.cc, CSparse.h,
	CmplxAEPBAL.cc, CmplxAEPBAL.h, CmplxCHOL.cc, CmplxGEPBAL.cc,
	CmplxGEPBAL.h, CmplxHESS.cc, CmplxLU.h, CmplxQR.cc, CmplxQR.h,
	CmplxSCHUR.cc, CmplxSVD.h, CollocWt.cc, CollocWt.h, DASPK.cc,
	DASPK.h, DASRT.cc, DASRT.h, DASSL.cc, DASSL.h, DET.h,
	DiagArray2.h, EIG.cc, LSODE.cc, MArray.cc, MArray.h,
	MDiagArray2.cc, MDiagArray2.h, MSparse.cc, MSparse.h,
	MatrixType.cc, MatrixType.h, ODESFunc.h, PermMatrix.cc,
	PermMatrix.h, Quad.cc, Range.cc, Sparse.cc, Sparse.h,
	SparseCmplxCHOL.cc, SparseCmplxCHOL.h, SparseCmplxLU.cc,
	SparseCmplxLU.h, SparseCmplxQR.cc, SparseCmplxQR.h, SparseQR.cc,
	SparseQR.h, SparsedbleCHOL.cc, SparsedbleCHOL.h,
	SparsedbleLU.cc, SparsedbleLU.h, base-aepbal.h, base-de.h,
	base-lu.cc, base-lu.h, boolNDArray.cc, boolNDArray.h,
	boolSparse.cc, boolSparse.h, bsxfun-defs.cc, chMatrix.cc,
	chNDArray.cc, chNDArray.h, cmd-edit.cc, cmd-edit.h, cmd-hist.cc,
	dColVector.h, dDiagMatrix.cc, dDiagMatrix.h, dMatrix.cc,
	dMatrix.h, dNDArray.cc, dNDArray.h, dSparse.cc, dSparse.h,
	dbleAEPBAL.h, dbleCHOL.cc, dbleCHOL.h, dbleGEPBAL.cc,
	dbleGEPBAL.h, dbleQR.cc, dbleQR.h, dbleSCHUR.h, dbleSVD.h,
	dim-vector.cc, dim-vector.h, dir-ops.cc, eigs-base.cc,
	f2c-main.c, fCColVector.cc, fCColVector.h, fCDiagMatrix.cc,
	fCDiagMatrix.h, fCMatrix.cc, fCMatrix.h, fCNDArray.cc,
	fCNDArray.h, fCRowVector.cc, fCRowVector.h, fCmplxAEPBAL.cc,
	fCmplxAEPBAL.h, fCmplxCHOL.cc, fCmplxGEPBAL.cc, fCmplxGEPBAL.h,
	fCmplxHESS.cc, fCmplxLU.h, fCmplxQR.cc, fCmplxQR.h,
	fCmplxQRP.cc, fCmplxSCHUR.cc, fCmplxSVD.h, fColVector.h,
	fDiagMatrix.cc, fDiagMatrix.h, fEIG.cc, fMatrix.cc, fMatrix.h,
	fNDArray.cc, fNDArray.h, file-ops.cc, file-stat.cc,
	floatAEPBAL.cc, floatAEPBAL.h, floatCHOL.cc, floatCHOL.h,
	floatGEPBAL.cc, floatGEPBAL.h, floatLU.h, floatQR.cc, floatQR.h,
	floatQRP.cc, floatSCHUR.h, floatSVD.h, idx-vector.cc,
	idx-vector.h, intNDArray.cc, intNDArray.h, kpse.cc,
	lo-array-gripes.cc, lo-array-gripes.h, lo-cieee.c, lo-ieee.h,
	lo-mappers.cc, lo-mappers.h, lo-specfun.cc, mx-defs.h,
	mx-inlines.cc, oct-binmap.h, oct-convn.cc, oct-env.cc,
	oct-fftw.cc, oct-fftw.h, oct-glob.cc, oct-group.h,
	oct-inttypes.cc, oct-inttypes.h, oct-locbuf.cc, oct-locbuf.h,
	oct-md5.cc, oct-mem.h, oct-norm.cc, oct-norm.h, oct-rand.cc,
	oct-rand.h, oct-rl-hist.c, oct-shlib.cc, oct-shlib.h,
	oct-sort.cc, oct-sort.h, oct-spparms.cc, oct-spparms.h,
	oct-syscalls.cc, oct-time.cc, randgamma.c, randmtzig.c,
	randmtzig.h, randpoisson.c, regex-match.cc, regex-match.h,
	sparse-base-chol.cc, sparse-base-chol.h, sparse-base-lu.cc,
	sparse-base-lu.h, sparse-dmsolve.cc, sparse-sort.cc,
	sparse-sort.h, sparse-util.h, tempname.c:
	Strip trailing whitespace.

2011-01-20  John W. Eaton  <jwe@octave.org>

	* Array.h, Array.cc
	(Array<T>::resize2 (octave_idx_type, octave_idx_type, const T&)):
	New private function.
	(Array<T>::resize (octave_idx_type, octave_idx_type, const T&)):
	Deprecate.  Call resize2 to do the work.  Remove all uses from
	Octave.

	* CMatrix.h (ComplexMatrix::resize (octave_idx_type,
	octave_idx_type, const Complex&)): New function.
	* dMatrix.h (Matrix::resize (octave_idx_type,
	octave_idx_type, double)): New function.
	* fCMatrix.h (FloatComplexMatrix::resize (octave_idx_type,
	octave_idx_type, const FloatComplex&)): New function.
	* fMatrix.h (FloatMatrix::resize (octave_idx_type,
	octave_idx_type, const float)): New function.

2011-01-20  David Bateman  <dbateman@free.fr>

	* Sparce.cc (template <class T> Sparse<T>::Sparse (const Array<T>&,
	const idx_vector&, const idx_vector&, octave_idx_type,
	octave_idx_type, bool, octave_idx_type): Fix off by one error in the
	construction of sparse column vectors. Fix indexing issue in
	construction of sparse row vectors.
	* boolSparse.cc (SparseBoolMatrix SparseBoolMatrix::any (int) const):
	Fully initialize cidx for any called on the first dimension.

2011-01-19  John W. Eaton  <jwe@octave.org>

	* Array.h (explicit Array (octave_idx_type, const T&)):
	Restore constructor, but mark as deprecated.
	(explicit Array (octave_idx_type, octave_idx_type)): Delete.
	(Array (const Array<T>&, octave_idx_type, octave_idx_type)): Delete.
	Fix all uses in Octave.
	* Array3.h: Deprecate header file.  Remove all uses from Octave.

2011-01-19  John W. Eaton  <jwe@octave.org>

	* file-stat.cc (mode_as_string): Declare buffer as an array of
	12 characters, not 11.  Don't set buf[10] to '\0'; strmode
	NUL-terminates the array.

2011-01-14  David Grundberg  <individ@acc.umu.se>

	* SparseQR.cc (SparseQR_rep::SparseQR_rep) [HAVE_CXSPARSE]:
	Make initialization list depend on macro. Fixes compile error when
	macro isn't defined.
	* SparseCmplxQR.cc (SparseComplexQR_rep::SparseComplexQR_rep)
	[HAVE_CXSPARSE]: Ditto.

2011-01-14  John W. Eaton  <jwe@octave.org>

	* lo-mappers.cc (xfloor): Move function body here from
	lo-mappers.h to avoid exposing gnulib:: in a header file.

2011-01-14  John W. Eaton  <jwe@octave.org>

	* file-stat.cc (mode_as_string): Call strmode instead of mode_string.

	* filemode.h, filemode.c: Delete.
	* Makefile.am (INCS): Remove filemode.h from the list.
	(LIBOCTAVE_C_SOURCES): Remove filemode.c from the list.

2011-01-14  John W. Eaton  <jwe@octave.org>

	* Update copyright notices for 2011.

2011-01-13  John W. Eaton  <jwe@octave.org>

	* CColVector.cc, CMatrix.cc, CRowVector.cc, CSparse.cc,
	CmplxAEPBAL.cc, CmplxCHOL.cc, CmplxLU.cc, CmplxQR.cc,
	CmplxQRP.cc, EIG.cc, Quad.cc, dColVector.cc, dMatrix.cc,
	dRowVector.cc, dSparse.cc, dbleAEPBAL.cc, dbleCHOL.cc,
	dbleLU.cc, dbleQR.cc, dbleQRP.cc, eigs-base.cc, fCColVector.cc,
	fCMatrix.cc, fCNDArray.cc, fCRowVector.cc, fCmplxAEPBAL.cc,
	fCmplxCHOL.cc, fCmplxLU.cc, fCmplxQR.cc, fCmplxQRP.cc,
	fCmplxSVD.cc, fColVector.cc, fEIG.cc, fMatrix.cc, fNDArray.cc,
	fRowVector.cc, floatAEPBAL.cc, floatCHOL.cc, floatLU.cc,
	floatQR.cc, floatQRP.cc, lo-specfun.cc, oct-convn.cc:
	Style fixes.

2011-01-13  John W. Eaton  <jwe@octave.org>

	* CMatrix.cc (get_blas_trans_arg): Return char, not char *.
	Change all uses.
	* dMatrix.cc (get_blas_trans_arg): Likewise.
	* fCMatrix.cc (get_blas_trans_arg): Likewise.
	* fMatrix.cc (get_blas_trans_arg): Likewise.
	Suggested by Pascal Dupuis <Pascal.Dupuis@worldonline.be>.

2011-01-13  John W. Eaton  <jwe@octave.org>

	* filemode.c: Use prototypes for function definitions.  Reorder
	functions to eliminate need for forward declarations.
	* filemode.h: New file.
	* file-stat.cc: Include filemode.h instead of using local extern
	declarations.
	* Makefile.am (INCS): Add filemode.h to the list.

	* lo-cutils.h: New file.
	(octave_qsort, octave_strcasecmp, octave_strncasecmp,
	octave_w32_library_search, octave_waitpid): Move decls here from
	lo-utils.h.
	* Makefile.am (INCS): Add lo-cutils.h to the list.
	* lo-utils.h: Include cutils.h.
	* lo-cutils.c: Include cutils.h.

2011-01-13  John W. Eaton  <jwe@octave.org>

	* SparseCmplxQR.cc
	(SparseComplexQR::SparseComplexQR_rep::SparseComplexQR_rep):
	Correct order of member initialization.
	* SparseQR.cc (SparseQR::SparseQR_rep::SparseQR_rep): Likewise.

2011-01-13  John W. Eaton  <jwe@octave.org>

	* oct-fftw.cc (octave_fftw_planner::octave_fftw_planner,
	octave_float_fftw_planner::octave_float_fftw_planner):
	Avoid duplicate initializations.  Correctly initialize RN to
	empty dim_vector.

2011-01-13  John W. Eaton  <jwe@octave.org>

	* Sparse.cc (Sparse::Sparse): Initialize all data members in
	initialization lists.

2011-01-13  John W. Eaton  <jwe@octave.org>

	* Array.cc (rec_permute_helper::rec_permute_helper,
	rec_index_helper::rec_index_helper,
	rec_resize_helper::rec_resize_helper): Initialize all data
	members in initialization lists.

	* Array.h, Array.cc (Array::Array): Initialize slice_data and
	slice_len in memeber initialization lists.
	(Array::~Array): Now virtual.

2011-01-13  John W. Eaton  <jwe@octave.org>

	* oct-locbuf.h (octave_chunk_buffer::~octave_chunk_buffer):
	Now virtual.
	(class octave_local_buffer, class octave_chunk_buffer):
	Don't allow copying or assignment.

	* file-stat.h (base_file_stat::~base_file_stat):
	Now protected and virtual.

2011-01-13  John W. Eaton  <jwe@octave.org>

	* base-lu.h (base_lu::base_lu): Initialize all data members in
	initialization lists.
	* base-qr.h (base_qr::base_qr): Likewise.
	* DET.h (base_det::base_det): Likewise.
	* sparse-base-lu.h (sparse_base_lu::sparse_base_lu): Likewise.
	* sparse-base-chol.h (sparse_base_chol::sparse_base_chol): Likewise.

	* base-lu.h (base_lu::~base_lu): Explicitly define virtual destrutor.
	* base-qr.h (base_qr::~base_qr): Likewise.
	* base-aepbal.h (base_aepbal::~base_aepval): Likewise.
	* sparse-base-lu.h (sparse_base_lu::~sparse_base_lu): Likewise.
	* sparse-base-chol.h (sparse_base_chol::~sparse_base_chol): Likewise.

2011-01-13  John W. Eaton  <jwe@octave.org>

	* DAE.h (DAE::~DAE): Now virtual.
	* DAERT.h (DAERT::~DAERT): Likewise.
	* ODE.h (ODE::~ODE): Likewise.
	* DAEFunc.h (DAEFunc::~DAEFunc): Likewise.
	* DAERTFunc.h (DAEFunc::~DAEFunc): Likewise.
	* ODEFunc.h (ODE::~ODE): Likewise.
	* ODESFunc.h (ODESFunc::~ODESFunc): Likewise.

2011-01-13  John W. Eaton  <jwe@octave.org>

	* idx-vector.h (idx_vector_rep::idx_vector_rep,
	idx_vector::idx_mask_rep::idx_mask_rep):
	Initialize all data members in initialization lists.

	* idx-vector.cc (idx_vector::idx_scalar_rep::idx_scalar_rep):
	Initialize data in member initialization list.
	(class idx_base_rep, class idx_colon_rep, class idx_range_rep,
	class idx_scalar_rep, class idx_vector_rep, class idx_mask_rep):
	Don't allow assignment.

2011-01-13  John W. Eaton  <jwe@octave.org>

	* LSODE.h (class LSODE): Delete pointer data members.
	(LSODE::LSODE): Initialize all data members in initialization lists.
	* LSODE.cc (LSODE::integrate): Extract pointers to data from
	array data members at each call.

	* DASPK.h (class DASPK): Delete pointer data members.
	(DASPK::DASPK): Initialize all data members in initialization lists.
	* DASPK.cc (DASPK::integrate): Extract pointers to data from
	array data members at each call.

	* DASSL.h (class DASSL): Delete pointer data members.
	(DASSL::DASSL): Initialize all data members in initialization lists.
	* DASSL.cc (DASSL::integrate): Extract pointers to data from
	array data members at each call.

	* DASRT.h (class DASRT): Delete pointer data members.
	(DASRT::DASRT): Initialize all data members in initialization lists.
	* DASRT.cc (DASRT::integrate): Extract pointers to data from
	array data members at each call.

2011-01-13  John W. Eaton  <jwe@octave.org>

	* kpse.cc (struct str_llist_elt, struct cache_entry):
	Explicitly define constructor and destructor.

	* Quad.h (Quad::Quad, IndefQuad::IndefQuad,
	FloatIndefQuad::FloatIndefQuad): Initialize all data members in
	initialization lists.
	* CollocWt.h (CollocWt::CollocWt): Likewise.
	* oct-time.h (octave_strptime::octave_strptime): Likewise.
	* oct-time.cc (octave_time::octave_time): Likewise.
	* pathsearch.h (dir_path::dir_path): Likewise.
	* regex-match.h (regex_match::regex_match): Likewise.
	* oct-sort.h (octave_sort::MergeState::MergeState): Likewise.
	* oct-shlib.h, oct-shlib.cc (octave_shlib::shlib_rep::shlib_rep,
	octave_shlib::octave_shlib): Likewise.
	* oct-mutex.h, oct-mutex.cc (octave_mutex::octave_mutex): Likewise.
	* MatrixType.cc (MatrixType::MatrixType): Likewise.
	* oct-fftw.cc (octave_fftw_planner::octave_fftw_planner,
	octave_float_fftw_planner::octave_float_fftw_planner): Likewise.

	* mach-info.h, mach-info.cc (oct_mach_info::oct_mach_info):
	Initialize all data members in initialization lists.
	(ten_little_endians): Rename from oct_mach_info::ten_little_endians.
	Now static instead of private member function
	(get_float_format): Rename from oct_mach_info::init_float_format.
	Now static instead of private member function.

	* dir-ops.h, dir-ops.cc (dir_entry::copy): Delete.
	(dir_entry::dir_entry): Initialize all data members in
	initialization lists.
	(dir_entry::operator =): Copy elements directly here instead of
	calling copy.

2011-01-13  John W. Eaton  <jwe@octave.org>

	* cmd-hist.h, cmd-hist.cc: Sprinkle with const.

2011-01-13  John W. Eaton  <jwe@octave.org>

	* CmplxCHOL.h (ComplexCHOL::ComplexCHOL): Initialize all data
	members in constructor initialization lists.
	* CmplxGEPBAL.h (ComplexGEPBALANCE::ComplexGEPBALANCE): Likewise.
	* CmplxHESS.h (ComplexHESS::ComplexHESS): Likewise.
	* CmplxSCHUR.h, CmplxSCHUR.cc (ComplexSCHUR::ComplexSCHUR): Likewise.
	* CmplxSVD.h (ComplexSVD::ComplexSVD): Likewise.
	* DET.h (base_det::base_det): Likewise.
	* EIG.h (EIG::EIG): Likewise.
	* SparseCmplxQR.cc
	(SparseComplexQR::SparseComplexQR_rep::SparseComplexQR_rep):
	Likewise.
	* SparseQR.cc (SparseQR::SparseQR_rep::SparseQR_rep): Likewise.
	* dbleCHOL.h (CHOL::CHOL): Likewise.
	* dbleGEPBAL.h (GEPBALANCE::GEPBALANCE): Likewise.
	* dbleHESS.h (HESS::HESS): Likewise.
	* dbleSCHUR.h, dbleSCHUR.cc (SCHUR::SCHUR): Likewise.
	* dbleSVD.h (SVD::SVD): Likewise.
	* fCmplxCHOL.h (FloatComplexCHOL::FloatComplexCHOL): Likewise.
	* fCmplxGEPBAL.h
	(FloatComplexGEPBALANCE::FloatComplexGEPBALANCE): Likewise.
	* fCmplxHESS.h (FloatComplexHESS::FloatComplexHESS): Likewise.
	* fCmplxSCHUR.h, fCmplxSCHUR.cc
	(FloatComplexSCHUR::FloatComplexSCHUR): Likewise.
	* fCmplxSVD.h (FloatComplexSVD::FloatComplexSVD):
	Likewise.
	* fEIG.h (FloatEIG::FloatEIG): Likewise.
	* floatCHOL.h (FloatCHOL::FloatCHOL): Likewise.
	* floatGEPBAL.h (FloatGEPBALANCE::FloatGEPBALANCE): Likewise.
	* floatHESS.h (FloatHESS::FloatHESS): Likewise.
	* floatSCHUR.h, floatSCHUR.cc (FloatSCHUR::FloatSCHUR): Likewise.
	* floatSVD.h (FloatSVD::FloatSVD): Likewise.

2011-01-13  John W. Eaton  <jwe@octave.org>

	* LSODE.cc, DASSL.cc, DASRT.cc, DASPK.cc, CmplxSVD.cc,
	CmplxSCHUR.cc, CmplxHESS.cc, CmplxGEPBAL.cc, CmplxCHOL.cc,
	EIG.cc, dbleCHOL.cc, dbleGEPBAL.cc, dbleHESS.cc, dbleSCHUR.cc,
	dbleSVD.cc, fCmplxCHOL.cc, fCmplxGEPBAL.cc, fCmplxHESS.cc,
	fCmplxSCHUR.cc, fCmplxSVD.cc, fEIG.cc, floatCHOL.cc,
	floatGEPBAL.cc, floatHESS.cc, floatSCHUR.cc, floatSVD.cc:
	Style fixes.

2011-01-12  John W. Eaton  <jwe@octave.org>

	* oct-rl-hist.c (hc_erasedups): Avoid GCC warning.

2011-01-12  Jordi Gutiérrez Hermoso  <jordigh@gmail.com>

	* oct-rl-hist.h: Replace macros with an enum

2011-01-12  Pascal Dupuis  <Pascal.Dupuis@worldonline.be>
	    John W. Eaton  <jwe@octave.org>

	* cmd-hist.cc (command_history::process_histcontrol,
	command_history::hist_control, command_history::process_histcontrol,
	command_history::hist_control): New functions.
	(command_history::initialize, command_history::do_initialize):
	New arg, control_arg.
	* cmd-hist.cc (gnu_history::do_add): Pass history_control to
	octave_add_history.
	* cmd-hist.h (command_history::process_histcontrol,
	command_history::hist_control, command_history::process_histcontrol,
	command_history::hist_control): Provide decls.
	(command_history::history_control): New data member.

	* oct-rl-hist.c (octave_add_history): New arg, history_control.
	Return int, not void.
	(check_history_control, hc_erasedups): New static functions
	borrowed from Bash.
	* oct-rl-hist.h (octave_add_history): Fix decl.
	(HC_IGNSPACE, HC_IGNDUPS, HC_ERASEDUPS): New #defined constants.

2011-01-06  John W. Eaton  <jwe@octave.org>

	* oct-md5.cc (oct_md5_file): Tag call to fclose with gnulib::.
	* Range.cc (tfloor): Tag calls to floor with gnulib::.
	* lo-mappers.h (xfloor): Tag call to floor with gnulib::

2010-12-20  John W. Eaton  <jwe@octave.org>

	* lo-mappers.h (xrem, xmod): Declare temporary result from
	multiplication volatile.

2010-12-15  John W. Eaton  <jwe@octave.org>

	Bug #31883.

	* cmd-hist.cc (command_history::do_clean_up_and_save,
	command_history::do_truncate_file,
	command_history::do_append, command_history::do_write,
	gnu_history::do_clean_up_and_save, gnu_history::do_truncate_file,
	gnu_history::do_append, gnu_history::do_write,
	gnu_history::do_read_range):
	Don't do anything if not initialized.

	* cmd-hist.cc, cmd-hist.h (command_history::initialize,
	command_history::is_initialized): New static functions.
	(command_history::do_initialize,
	command_history::do_is_initialized): New member functions.

	* cmd-hist.h (command_history::initialized): New data member.
	(comand_history::command_history): Initialize it.

2010-12-14  John W. Eaton  <jwe@octave.org>

	* lo-mappers.h (xcopysign (double)): Call copysign, not copysignf.
	(xmod): Call X_NINT, not D_NINT.  Call xfloor, not floor.
	Bug #31872.

2010-12-13  John W. Eaton  <jwe@octave.org>

	* CMatrix.cc (operator * (const Matrix& m, const ComplexMatrix&	a)):
	Fix cut and paste error.  Bug #31869.

2010-12-09  Marco Atzeri  <marco_atzeri@yahoo.it>

	* lo-specfun.cc (xgamma): Also handle negative integer values as
	special cases when using tgamma.  Bug #31772.

2010-11-25  John W. Eaton  <jwe@octave.org>

	* Sparse.cc (Sparse<T>::assign): Use correct endpoint for
	destination range when making room for new elements.
	Bug #31734.

2010-11-23  John W. Eaton  <jwe@octave.org>

	* oct-md5.cc (oct_md5_result_to_str): Avoid buffer overrun in
	call to sprintf.  Replace loop with a single call to sprintf.
	Bug #31689.

2010-11-23  John W. Eaton  <jwe@octave.org>

	* oct-md5.cc (oct_md5_file): Close file after reading.

2010-11-22  John W. Eaton  <jwe@octave.org>

	* boolSparse.cc (SparseBoolMatrix::sum, SparseBoolMatrix::any):
	Cast integer idx_vector argument to octave_idx_type.

2010-11-18  John W. Eaton  <jwe@octave.org>

	* chMatrix.cc (charMatrix::row_as_string): Never strip trailing
	nul characters.  Bug #31689.

2010-11-12  John W. Eaton  <jwe@octave.org>

	* Makefile.am (LIBOCTAVE_SOURCES): Delete variable.
	(liboctave_la_SOURCES): Include $(LIBOCTAVE_CXX_SOURCES) and
	$(LIBOCTAVE_C_SOURCES) in this list instead of
	$(LIBOCTAVE_SOURCES).
	(nodist_liboctave_la_SOURCES): New variable.
	(octinclude_HEADERS): Don't include $(BUILT_INCS) in the list.
	(noinst_octinclude_HEADERS): New variable.
	(PRIVATE_INCS): Delete variable.
	(INCS): Include oct-glob.h in the list.
	(liboctave_la_SOURCES): Don't include $(PRIVATE_INCS) in the
	list.
	(LIBOCT_PATHSEARCH_CXX_SOURCES, LIBOCT_PATHSEARCH_C_SOURCES,
	LIBOCT_PATHSEARCH_SOURCES): Delete variables.
	(LIBOCTAVE_CXX_SOURCES): Include pathsearch.cc in the list.

2010-11-12  John W. Eaton  <jwe@octave.org>

	* Array.cc (Array<T>::cat): Simplify previous change.

2010-11-11  John W. Eaton  <jwe@octave.org>

	* Array.cc (Array<T>::cat): New special case for concatenating
	empty matrices.  Bug #31615.

2010-11-11  John W. Eaton  <jwe@octave.org>

	* lo-mappers.cc (xtrunc, xround): Move definitions here from
	lo-mappers.h.

2010-11-10  John W. Eaton  <jwe@octave.org>

	* kpse-xfns.c: Delete.
	* kpse-xfns.h: Delete.  Move defintions to kpse.cc.
	* Makefile.am (INCS): Remove kpse-xfns.h from the list.
	(LIBOCT_PATHSEARCH_SOURCES): Define to pathsearch.cc.
	(LIBOCT_PATHSEARCH_CXX_SOURCES,	LIBOCT_PATHSEARCH_C_SOURCES):
	Delete variables.

2010-11-10  John W. Eaton  <jwe@octave.org>

	* lo-cieee.c Eliminate special cases for SCO.

2010-11-10  John W. Eaton  <jwe@octave.org>

	* lo-ieee.cc (octave_ieee_init): Don't initialize octave_Inf,
	octave_NaN, and octave_NA to DBL_MAX.  Don't initialize
	octave_Float_Inf, octave_Float_NaN, and octave_Float_NA to FLT_MAX.
	(octave_ieee_init): Simplify using std::numeric_limits template.

2010-11-10  John W. Eaton  <jwe@octave.org>

	* syswait.h: Delete special cases for NeXT systems.

2010-11-10  John W. Eaton  <jwe@octave.org>

	* lo-sysdep.cc (octave_chdir): Delete special case for __EMX__.
	* oct-env.cc (octave_env::do_make_absolute): Likewise.

2010-11-10  John W. Eaton  <jwe@octave.org>

	* lo-ieee.h: Eliminate special cases for SCO.
	* lo-ieee.cc (octave_ieee_init): Eliminate special cases for SCO.

2010-11-09  John W. Eaton  <jwe@octave.org>

	* lo-mappers.h (xmod, xrem): Don't copy sign if result is zero.

2010-11-09  John W. Eaton  <jwe@octave.org>

	* lo-mappers.cc, lo-mappers.h (xisnan, xisinf, xfinite, xmod,
	xrem, floor, ceil, xround, xroundb, signum): Move definitions
	from lo-mappers.cc to lo-mappers.h and convert to templates.
	(xtrunc): Move definitions from lo-mappers.cc to lo-mappers.h.
	* lo-mappers.cc (fix): Use xtrunc.  Move definitions to
	lo-mappers.cc from lo-mappers.h.
	(real, imag, conj) Move definitions to lo-mappers.h and declare inline.
	(round): Move definitions to lo-mappers.h and declare inline.
	Use roundf for float version.
	(arg): Move definitions to lo-mappers.h and declare inline.
	Use atan2f for float version.
	* lo-mappers.h (xceil): New functions.
	(X_NINT): New template function.
	(D_NINT, F_NINT): Define in terms of X_NINT.
	* lo-utils.h, lo-utils.cc (D_NINT, F_NINT): Delete.
	* lo-mappers.h, lo-mappers.cc (NINTbig,	NINT): Move from
	lo-utils.cc and lo-utils.h.

2010-11-09  John W. Eaton  <jwe@octave.org>

	* Array.cc (Array<T>::sort, Array<T>::is_sorted,
	Array<T>::is_sorted_rows): Use comparisons to sortmode values
	instead of testing mode directly.

2010-11-09  John W. Eaton  <jwe@octave.org>

	* lo-mappers.cc (xmod, xrem): New functions.
	(mod): Delete.
	* lo-mappers.h (xmod, xrem): Provide decls.

2010-10-31  Michael Goffioul  <michael.goffioul@gmail.com>

	* dim-vector.h (class dim_vector): tag with OCTAVE_API.

2010-10-21  John W. Eaton  <jwe@octave.org>

	* Makefile.am (INCS): Include lo-array-gripes.h in the list.
	(LIBOCTAVE_CXX_SOURCES): Include lo-array-gripes.cc in the list.

	* lo-array-gripes.h: New file.  Move gripe function decls here
	from Array-util.h.
	* lo-array-gripes.c: New file.  Move gripe function definitions
	here from Array-util.cc.

	* CMatrix.cc (ComplexMatrix::operator !): Gripe if any element is NaN.
	* CNDArray.cc (ComplexNDArray::operator !): Likewise.
	* CSparse.cc (SparseComplexMatrix::operator !): Likewise.
	* dMatrix.cc (Matrix::operator !): Likewise.
	* dNDArray.cc (NDArray::operator !): Likewise.
	* dSparse.cc (SparseMatrix::operator !): Likewise.
	* fCMatrix.cc (FloatComplexMatrix::operator !): Likewise.
	* fCNDArray.cc (FloatComplexNDArray::operator !): Likewise.
	* fMatrix.cc (FloatMatrix::operator !): Likewise.
	* fNDArray.cc (FloatNDArray::operator !): Likewise.

2010-10-21  John W. Eaton  <jwe@octave.org>

	* Array-util.cc (gripe_nan_to_character_conversion): New function.
	* Array-util.h: Provide decl.

2010-10-19  John W. Eaton  <jwe@octave.org>

	* Makefile.am (INCS): Add caseless-str.h to the list.

2010-10-01  John W. Eaton  <jwe@octave.org>

	* caseless-str.h: New file, extracted from src/graphics.h.in.

2010-09-22  Jaroslav Hajek  <highegg@gmail.com>

	* lo-utils.cc (xis_int_or_inf_or_nan): Fix typos.

2010-09-21  Jaroslav Hajek  <highegg@gmail.com>

	* Array.h (Array::test, Array::test_all, Array::test_any): New
	overloaded template methods.
	* lo-mappers.h (xisinteger, xnegative_sign): New bool mappers.
	* dNDArray.cc (NDArray::any_element_is_negative,
	NDArray::all_integers): Simplify.
	* fNDArray.cc (FloatNDArray::any_element_is_negative,
	FloatNDArray::all_integers): Simplify.

	* lo-utils.cc (xis_int_or_inf_or_nan, xis_one_or_zero,
	xis_zero, xtoo_large_for_float): New utility functions.

	* dNDArray.cc (NDArray::any_element_is_negative,
	NDArray::all_integers, NDArray::all_elements_are_zero,
	NDArray::all_elements_are_int_or_inf_or_nan,
	NDArray::any_element_not_one_or_zero,
	NDArray::too_large_for_float): Simplify.

	* fNDArray.cc (FloatNDArray::any_element_is_negative,
	FloatNDArray::all_integers, FloatNDArray::all_elements_are_zero,
	FloatNDArray::all_elements_are_int_or_inf_or_nan,
	FloatNDArray::any_element_not_one_or_zero,
	FloatNDArray::too_large_for_float): Simplify.

2010-09-21  Jaroslav Hajek  <highegg@gmail.com>

	* dNDArray.cc (NDArray::any_element_is_negative,
	NDArray::any_element_is_nan,
	NDArray::any_element_is_inf_or_nan): Simplify.
	* fNDArray.cc (FloatNDArray::any_element_is_negative,
	FloatNDArray::any_element_is_nan,
	FloatNDArray::any_element_is_inf_or_nan): Simplify.
	* dMatrix.cc (Matrix::any_element_is_negative,
	Matrix::any_element_is_nan,
	Matrix::any_element_is_inf_or_nan): Simplify.
	* fMatrix.cc (FloatMatrix::any_element_is_negative,
	FloatMatrix::any_element_is_nan,
	FloatMatrix::any_element_is_inf_or_nan): Simplify.
	* CNDArray.cc (ComplexNDArray::any_element_is_negative,
	ComplexNDArray::any_element_is_nan,
	ComplexNDArray::any_element_is_inf_or_nan): Simplify.
	* fCNDArray.cc (FloatComplexNDArray::any_element_is_negative,
	FloatComplexNDArray::any_element_is_nan,
	FloatComplexNDArray::any_element_is_inf_or_nan): Simplify.
	* CMatrix.cc (ComplexMatrix::any_element_is_negative,
	ComplexMatrix::any_element_is_nan,
	ComplexMatrix::any_element_is_inf_or_nan): Simplify.
	* fCMatrix.cc (FloatComplexMatrix::any_element_is_negative,
	FloatComplexMatrix::any_element_is_nan,
	FloatComplexMatrix::any_element_is_inf_or_nan): Simplify.

2010-09-21  John W. Eaton  <jwe@octave.org>

	* oct-env.cc (do_get_host_name): Call gnulib::gethostname
	instead of octave_gethostname.

	* lo-utils.h, lo-cutils.c (octave_gethostname): Delete.

2010-09-20  John W. Eaton  <jwe@octave.org>

	* oct-time.cc (octave_time::octave_time, octave_strptime::init):
	Call gnulib::mktime instead of mktime (may fix bug #31079).

2010-09-15  Jaroslav Hajek  <highegg@gmail.com>

	* dSparse.h (SparseMatrix::SparseMatrix (const Sparse<double>&)):
	New ctor.
	* CSparse.h (SparseComplexMatrix::SparseComplexMatrix
	(const Sparse<Complex>&)): New ctor.
	* boolSparse.cc (SparseBoolMatrix::sum): New method.
	* boolSparse.h: Declare it.

2010-09-15  Jaroslav Hajek  <highegg@gmail.com>

	* boolSparse.cc (SparseBoolMatrix::any): Optimize.

2010-08-24  Jaroslav Hajek  <highegg@gmail.com>

	* Array-ch.cc: Inline basic sorts.

2010-08-21  Rik  <octave@nomad.inbox5.com>

	* CmplxQRP.cc, CmplxQRP.h, dbleQRP.cc, dbleQRP.h, fCmplxQRP.cc,
	fCmplxQRP.h, floatQRP.cc, floatQRP.h: Declare Pvec as RowVector,
	not ColumnVector.  Bug #30832.

2010-08-18  Jaroslav Hajek  <highegg@gmail.com>

	* mx-inlines.cc (mx_inline_all_finite): New check.
	* Sparse-op-defs.h (SPARSE_SMS_BIN_OP_1, SPARSE_SMS_BIN_OP_2,
	SPARSE_SSM_BIN_OP_1, SPARSE_SSM_BIN_OP_2): Use unchecked access where
	appropriate.
	(SPARSE_SMM_BIN_OP_1, SPARSE_MSM_BIN_OP_1): Simplify.
	(SPARSE_SMM_BIN_OP_2, SPARSE_MSM_BIN_OP_2): Use optimized code path
	if all values are finite.
	(SPARSE_MSM_BIN_OPS): Use SPARSE_MSM_BIN_OP_1 for division.

2010-07-31  Rik  <octave@nomad.inbox5.com>

	* DASPK-opts.in, DASRT-opts.in, DASSL-opts.in, LSODE-opts.in,
	Quad-opts.in: Grammarcheck .cc files

2010-07-29  Jaroslav Hajek  <highegg@gmail.com>

	* dim-vector.cc (dim_vector::dim_max (void)): Turn it into a function.
	(dim_vector::safe_numel): Update usage.
	* dim-vector.h: Update declaration.

2010-07-27  Jaroslav Hajek  <highegg@gmail.com>

	* dbleSCHUR.cc (SCHUR::SCHUR (const Matrix&, const Matrix&)):
	New ctor.
	* dbleSCHUR.h: Declare it.
	* floatSCHUR.cc (FloatSCHUR::FloatSCHUR (const FloatMatrix&, const
	FloatMatrix&)): New ctor.
	* floatSCHUR.h: Declare it.
	* CmplxSCHUR.cc (ComplexSCHUR::ComplexSCHUR (const ComplexMatrix&,
	const ComplexMatrix&),
	ComplexSCHUR::ComplexSCHUR (const SCHUR&)): New ctors.
	* CmplxSCHUR.h: Declare them.
	* fCmplxSCHUR.cc (FloatComplexSCHUR::FloatComplexSCHUR
	(const FloatComplexMatrix&, const FloatComplexMatrix&),
	FloatComplexSCHUR::FloatComplexSCHUR (const FloatSCHUR&)): New ctors.
	* fCmplxSCHUR.h: Declare them.

2010-07-22  Jaroslav Hajek  <highegg@gmail.com>

	* dMatrix.cc (Matrix::lssolve): Fix decision test for workaround.
	* fMatrix.cc (FloatMatrix::lssolve): Ditto.
	* CMatrix.cc (ComplexMatrix::lssolve): Ditto.
	* fCMatrix.cc (FloatComplexMatrix::lssolve): Ditto.

2010-07-20  Jaroslav Hajek  <highegg@gmail.com>

	* dim-vector.cc (dim_vector::dim_max): New static const member.
	* dim-vector.h: Declare it.

2010-07-20  Jaroslav Hajek  <highegg@gmail.com>

	* dMatrix.cc (Matrix::extract, Matrix::extract_n): Reimplement using
	index.
	* fMatrix.cc (FloatMatrix::extract, FloatMatrix::extract_n): Ditto.
	* CMatrix.cc (ComplexMatrix::extract, ComplexMatrix::extract_n): Ditto.
	* fCMatrix.cc (FloatComplexMatrix::extract, FloatComplexMatrix::extract_n): Ditto.

2010-07-13  Jaroslav Hajek  <highegg@gmail.com>

	* MSparse.h (MSparse<T>::index): Remove overloads.
	* dSparse.h (SparseMatrix::index): Likewise.
	* dSparse.cc (SparseMatrix::index): Likewise.
	* CSparse.h (SparseComplexMatrix::index): Likewise.
	* CSparse.cc (SparseComplexMatrix::index): Likewise.

2010-07-09  Jaroslav Hajek  <highegg@gmail.com>

	* CMatrix.cc (ComplexMatrix::lssolve (const ComplexMatrix&)):
	Undo 10708:2786b7ae3f80, implement proper correction.
	* fCMatrix.cc (FloatComplexMatrix::lssolve (const FloatComplexMatrix&)):
	Ditto.

2010-06-28  Jaroslav Hajek  <highegg@gmail.com>

	* dim-vector.h (dim_vector::scalar_1x1): New method.
	* lo-traits.h (equal_types): Fix.

2010-06-21  Jaroslav Hajek  <highegg@gmail.com>

	* Array.cc (Array<T>::cat): Implement the loose horzcat/vertcat rules
	under dim=-1/-2.
	* Sparse.cc (Array<T>::cat): Implement the loose horzcat/vertcat rules
	under dim=-1/-2.
	* Array.h, Sparse.h: Document it.

2010-06-17  Jaroslav Hajek  <highegg@gmail.com>

	* dim-vector.cc (dim_vector::hvcat): New method.
	* dim-vector.h (dim_vector::hvcat, dim_vector::cat): Update decls.
	(dim_vector::empty_2d): New method.

2010-06-17  Jaroslav Hajek  <highegg@gmail.com>

	* MatrixType.cc (matrix_real_probe): Use OCTAVE_LOCAL_BUFFER for
	temporary array.
	(matrix_complex_probe): Parametrize by real type. Use
	OCTAVE_LOCAL_BUFFER for temporary array.

2010-06-16  Rik  <octave@nomad.inbox5.com>

	* DASSL-opts.in: Periodic grammar check on documentation.

2010-06-16  David Bateman  <dbateman@free.fr>

	* oct-rand.cc (void octave_rand:do_reset (void),
	void octave_rand:do_reset (const std::string&)): New functions
	* oct-rand.h (void octave_rand:do_reset (void),
	void octave_rand:do_reset (const std::string&)): Declare them
	(void octave_rand:reset (void),
	void octave_rand:reset (const std::string&)): New functions.

2010-06-16  Jaroslav Hajek  <highegg@gmail.com>

	* CMatrix.cc (ComplexMatrix::lssolve (const ComplexMatrix&)):
	Workaround LAPACK bug.
	* fCMatrix.cc (FloatComplexMatrix::lssolve (const FloatComplexMatrix&)):
	Ditto.

2010-06-14  Jaroslav Hajek  <highegg@gmail.com>

	* Array.cc (Array::sort, Array::nth_element): Fix behavior when
	trailing singleton dim is specified.
	* Sparse.cc (Sparse::sort): Ditto.

2010-06-14  Jaroslav Hajek  <highegg@gmail.com>

	* idx-vector.cc (idx_vector::copy_data): Handle class_mask case.
	(idx_vector::increment): Fix class_colon and add class_mask.

2010-06-06  Michael Goffioul  <michael.goffioul@gmail.com>

	* mx-op-defs.h (MNANCHK): Add matrix element type argument and use it
	to specify template argument for mx_inline_any_nan.
	(MS_BOOL_OP, SM_BOOL_OP, MM_BOOL_OP, NDS_BOOL_OP, SND_BOOL_OP,
	NDND_BOOL_OP): Specify new MNANCHK argument.

2010-06-04  Jaroslav Hajek  <highegg@gmail.com>

	* dim-vector.cc: New source.
	* Makefile.am: Add it.
	* dim-vector.h (dim_vector::chop_all_singletons,
	dim_vector::str, dim_vector::num_ones, dim_vector::safe_numel,
	dim_vector::squeeze, dim_vector::concat, dim_vector::redim):
	Move bodies to dim_vector.cc.
	(dim_vector::concat): Rewrite.
	* Array.cc (Array::cat): Fix dim_vector concatenation. Don't use 0x0
	as neutral element, because it isn't with dim > 1.

2010-06-01  Jaroslav Hajek  <highegg@gmail.com>

	* Array.cc (Array<T>::optimize_dimensions): New method.
	* Array.h: Declare it.

2010-06-01  Jaroslav Hajek  <highegg@gmail.com>

	* Array.cc (Array<T>::maybe_delete_dims): Remove method (makes no
	longer sense).
	* Array.h: Update decls.

2010-05-20  Jaroslav Hajek  <highegg@gmail.com>

	* dim-vector.h (dim_vector::compute_index (const octave_idx_type *,
	int)): New method overload.
	(dim_vector::compute_index, dim_vector::cum_compute_index,
	dim_vector::increment_index): Add missing const qualifiers.

	* Array-util.cc (compute_index (..., const dim_vector&)): Rewrite,
	add new overloads. Move code from Array<T>::checkelem here.
	* Array-util.h: Update decls.
	* Array.h (Array<T>::compute_index): Forward to the above.
	(Array<T>::compute_index_unchecked): New method.
	(Array<T>::elem, Array<T>::xelem): Call it here.

	* Array.cc (Array<T>::checkelem): Use compute_index where suitable.

2010-05-19  Jaroslav Hajek  <highegg@gmail.com>

	* mx-inlines.cc (mx_inline_cumcount): Fix 2D version instantiation.

2010-05-14  Jaroslav Hajek  <highegg@gmail.com>

	* Array.cc (Array<T>::linearize): Remove.
	* Array.h (Array<T>::linearize): Remove decl.

2010-05-13  Jaroslav Hajek  <highegg@gmail.com>

	* dMatrix.cc (Matrix::lssolve): Remove warnings about rank.
	* fMatrix.cc (FloatMatrix::lssolve): Ditto.
	* CMatrix.cc (ComplexMatrix::lssolve): Ditto.
	* fCMatrix.cc (FloatComplexMatrix::lssolve): Ditto.

2010-05-11  Jaroslav Hajek  <highegg@gmail.com>

	* idx-vector.cc (idx_vector::unmask): Fix off-by-1 bug. Add tests.

2010-05-06  Jaroslav Hajek  <highegg@gmail.com>

	* Array.cc (Array::delete_elements (const idx_vector&)): Only call
	resize1 when deleting the last element of a vector.

2010-05-06  Jaroslav Hajek  <highegg@gmail.com>

	* oct-norm.h: Fix include guard.

2010-05-06  Jaroslav Hajek  <highegg@gmail.com>

	* dbleSCHUR.cc (SCHUR::init): Handle empty matrix case.
	Use clear rather than resize to realloc matrix.
	* floatSCHUR.cc (FloatSCHUR::init): Ditto.
	* CmplxSCHUR.cc (ComplexSCHUR::init): Ditto.
	* fCmplxSCHUR.cc (FloatComplexSCHUR::init): Ditto.

2010-05-04  John W. Eaton  <jwe@octave.org>

	* CollocWt.cc (diff, jcobi, dfopr): New functions, based on
	Fortran functions in libcruft/villad.
	(jcobi): Handle iteration failure at large N.
	(CollocWt::init): Call them instead of Fortran code.
	* CollocWt.h (CollocWt::initialized): Declare as bool, not int.
	Change all uses.
	Addresses bug #29473.

2010-05-03  Jaroslav Hajek  <highegg@gmail.com>

	* dbleSVD.h (SVD::driver): New enum.
	(SVD::SVD, SVD::init): Add driver option.
	* floatSVD.h (FloatSVD::FloatSVD, FloatSVD::init): Add driver option.
	* CmplxSVD.h (ComplexSVD::ComplexSVD, ComplexSVD::init):
	Add driver option.
	* fCmplxSVD.h (FloatComplexSVD::FloatComplexSVD,
	FloatComplexSVD::init): Add driver option.
	* dbleSVD.cc (SVD::init): Optionally use xGESDD driver.
	* floatSVD.cc (FloatSVD::init): Ditto.
	* CmplxSVD.cc (ComplexSVD::init): Ditto.
	* fCmplxSVD.cc (FloatComplexSVD::init): Ditto.

2010-04-28  John W. Eaton  <jwe@octave.org>

	* dim-vector.h (dim_vector (const octave_idx_type *, size_t)): Delete.
	* Sparse.cc (Sparse<T>::assign): Cast 0 to octave_idx_type in
	call to Sparse<T> constructor.
	Addresses bug #29692.

2010-04-27  John W. Eaton  <jwe@octave.org>

	* intNDArray.cc (intNDArray<T>::abs, intNDArray<T>::signum):
	Create new vector for return values.  Fixes bug #29685.

2010-04-23  Jaroslav Hajek  <highegg@gmail.com>

	* Sparse.cc (Sparse<T>::assign): Fix typos.

2010-04-20  Jaroslav Hajek  <highegg@gmail.com>

	* Sparse.h (::assign, ::assign1): Remove declarations.

2010-04-19  Jaroslav Hajek  <highegg@gmail.com>

	* Array.cc (Array<T>::cat): Fast return for single array case.
	* Sparse.cc (Sparse<T>::cat): Ditto.

2010-04-19  Jaroslav Hajek  <highegg@gmail.com>

	* Array.cc (Array<T>::cat): Miscellaneous fixes.
	* Sparse.cc (Sparse<T>::cat): Ditto.

2010-04-18  Jaroslav Hajek  <highegg@gmail.com>

	* Array.cc (Array<T>::cat): New method.
	* Array.h: Declare it.
	* Sparse.cc (Sparse<T>::cat): New method.
	* Sparse.h: Declare it.

2010-04-16  David Bateman  <dbateman@free.fr>

	* Sparse.cc (template <class T> Sparse<T>::Sparse (const Array<T>&,
	const idx_vector&, const idx_vector&, octave_idx_type,
	octave_idx_type, bool, octave_idx_type)): Add argument defining the
	minimum storage to allocate for the sparse matrix.
	* Sparse.h (template <class T> Sparse (const Array<T>&,
	const idx_vector&, const idx_vector&, octave_idx_type,
	octave_idx_type, bool, octave_idx_type)): ditto.
	* MSparse.h : ditto
	* CSparse.h : ditto
	* dSparse.h : ditto
	* boolSparse.h : ditto

2010-04-14  Jaroslav Hajek  <highegg@gmail.com>

	* Sparse.cc: Update failing tests.

2010-04-13  Jaroslav Hajek  <highegg@gmail.com>

	* Sparse.cc (Sparse<T>::index): If S is a sparse column vector,
	forward S(I,1) and S(I,:) to 1D indexing. Handle permutation indexing
	in the 1D case.
	(Sparse<T>::assign): If S is a sparse column vector,
	forward S(I,1) = X and S(I,:) =X to 1D indexed assignment.
	* idx-vector.cc (idx_vector::inverse_permutation): Add missing break.

2010-04-13  Jaroslav Hajek  <highegg@gmail.com>

	* Array-util.cc (gripe_invalid_assignment_size,
	gripe_assignment_dimension_mismatch): Move funcs here from Array.cc
	* Array-util.h: Declare them.
	* Array.cc: Remove them.

	* Sparse.cc (Sparse<T>::assign): New overloaded method.
	(Sparse<T>::operator =): Update.
	(Sparse<T>::resize1): Rewrite to match sparse assignment specifics.
	(Sparse<T>::set_index, Sparse<T>::clear_index, Sparse<T>::index_count,
	Sparse<T>::value): Remove methods.
	(::assign1, ::assign): Remove funcs.

	(INSTANTIATE_SPARSE): Move here from Sparse.h.

	* Sparse.h (Sparse<T>::idx, Sparse<T>::idx_count): Remove member
	fields. Remove initializations from all ctors.
	(Sparse<T>::get_idx): Remove.
	(Sparse<T>::assign): Add decls.
	(INSTANTIATE_SPARSE_ASSIGN, INSTANTIATE_SPARSE_AND_ASSIGN): Remove.
	(INSTANTIATE_SPARSE): Move to Sparse.cc

	* Sparse-C.cc, Sparse-d.cc, Sparse-b.cc: Only call INSTANTIATE_SPARSE.

	* idx-vector.cc (idx_vector::inverse_permutation): New method.
	* idx-vector.h: Declare it.

2010-04-12  Jaroslav Hajek  <highegg@gmail.com>

	* Sparse.cc (Sparse<T>::Sparse (const Array<T>&, const idx_vector&,
	const idx_vector&, ...)): Call maybe_compress after matrix is created.

2010-04-09  Jaroslav Hajek  <highegg@gmail.com>

	* Sparse.cc (Sparse<T>::diag): Change nzmax to nnz where appropriate.
	* MatrixType.cc (MatrixType::MatrixType): Ditto.
	* SparseQR.cc: Ditto.
	* SparseCmplxQR.cc: Ditto.
	* boolSparse.cc: Ditto.

2010-04-08  Jaroslav Hajek  <highegg@gmail.com>

	* Sparse.cc (Sparse<T>::resize (octave_idx_type, octave_idx_type)):
	Rewrite. Be smarter esp. when resizing to more columns.

2010-04-08  Jaroslav Hajek  <highegg@gmail.com>

	* dim-vector.h (dim_vector::concat): Ignore zero_by_zero, but not
	all_zero arrays in concatenation (like Matlab).

2010-04-07  Jaroslav Hajek  <highegg@gmail.com>

	* Sparse.cc (Sparse<T>::index (const idx_vector&, bool)): Use shallow
	copy when column is indexed by colon.

2010-04-07  Jaroslav Hajek  <highegg@gmail.com>

	* Sparse.cc (lblookup): Move in front of Sparse<T>::delete_elements.

2010-04-07  Jaroslav Hajek  <highegg@gmail.com>

	* str-vec.h (string_vector::string_vector (const Array<std::string>)):
	New constructor.

2010-04-06  Jaroslav Hajek  <highegg@gmail.com>

	* idx-vector.cc (idx_vector::complement): Rewrite.

2010-04-06  Jaroslav Hajek  <highegg@gmail.com>

	* Sparse.cc (Sparse<T>::maybe_delete_elements): Rename to
	delete_elements. Use const reference arguments.
	(Sparse<T>::delete_elements (const idx_vector&, const idx_vector&)):
	Rewrite.
	(Sparse<T>::maybe_delete_elements (int dim, const idx_vector&)): New
	overload.
	(Sparse<T>::maybe_delete_elements (Array<idx_vector>&)): Remove
	overload.

2010-04-06  Jaroslav Hajek  <highegg@gmail.com>

	* idx-vector.cc, Array-util.h, Array-util.cc: Reverse effects of
	4e64fbbd5c58.

2010-04-02  John W. Eaton  <jwe@octave.org>

	* Array-util.cc, idx-vector.cc, idx-vector.h: Style fixes.

2010-04-02  John W. Eaton  <jwe@octave.org>

	* idx-vector.cc (idx_vector::idx_vector (const Range&)):
	Move here from idx-vector.h.  Allow non-integer values in ranges,
	but warn by default (for Matlab compatibility).
	* Array-util.h, Array-util.cc (gripe_invalid_index): New arg, ERR.
	If ERR is false, generate warning instead of error.

2010-04-02  Jaroslav Hajek  <highegg@gmail.com>

	* Sparse.cc (Sparse<T>::maybe_delete_elements): Rewrite. Optimize for
	sparse column vectors.

2010-04-01  Jaroslav Hajek  <highegg@gmail.com>

	* mx-inlines.cc: Declare all loops as throw (). Ditto for
	corresponding applier arguments.
	(do_mx_check): New applier.
	(logical_value): Do not throw exceptions.
	* mx-op-defs.h (SNANCHK, MNANCHK): New helper macros.
	(MS_BOOL_OP, SM_BOOL_OP, MM_BOOL_OP, NDS_BOOL_OP, SND_BOOL_OP,
	NDND_BOOL_OP): Use them here.

2010-03-31  Jaroslav Hajek  <highegg@gmail.com>

	* Sparse.cc (Sparse<T>::Sparse (const Array<T>&,
	const Array<octave_idx_type>&, ...), Sparse<T>::Sparse (const Array<T>&,
	const Array<double>&, ...)):
	Remove old constructors.
	* Sparse.h: Ditto.
	* MSparse.h: Ditto.
	* dSparse.h: Ditto.
	* CSparse.h: Ditto.
	* boolSparse.h: Ditto.

2010-03-31  Jaroslav Hajek  <highegg@gmail.com>

	* idx-vector.cc (idx_vector::idx_range_rep::as_array): Fix typo.
	(idx_vector::raw): Use unchecked constructor.
	* Sparse.cc (Sparse<T>::Sparse (const Array<T>&, const idx_vector&,
	const idx_vector&, ...)): New ctor.
	* Sparse.h: Declare it.

2010-03-30  John W. Eaton  <jwe@octave.org>

	* str-vec.cc (string_vector::string_vector (const char * const *)):
	Create empty string_vector object if arg is NULL.
	Fixes bug #29386.

2010-03-29  Jaroslav Hajek  <highegg@gmail.com>

	* idx-vector.cc (idx_vector::raw): New method.
	* idx-vector.h: Declare it.

2010-03-27  David Bateman  <dbateman@free.fr>

	* oct-openmp.h: New file.
	* Makefile.am (INCS): Add it here.

2010-03-26  Jaroslav Hajek  <highegg@gmail.com>

	* Sparse.cc (Sparse<T>::index (const idx_vector&, const	idx_vector&,
	bool)): Specialize for contiguous row range, row permutation,
	and implement general case through double index-transpose.

2010-03-25  John W. Eaton  <jwe@octave.org>

	* eigs-base.cc (EigsComplexNonSymmetricFunc): Avoid warning
	about deprecated Array constructor.

2010-03-25  John W. Eaton  <jwe@octave.org>

	* cmd-edit.cc, file-ops.cc, lo-math.h, lo-utils.cc, oct-env.cc,
	dir-ops.cc, file-stat.cc, cmd-hist.cc, oct-time.cc, oct-time.h,
	oct-uname.cc: Revert changes from 2010-03-24 and 2010-03-25.

2010-03-25  Jaroslav Hajek  <highegg@gmail.com>

	* lo-mappers.cc	(fix (double)): Forward to gnulib::trunc.
	(fix (float)): Forward to gnulib::truncf.
	(xround (double)): Forward to gnulib::round.
	(xround (float)): Forward to gnulib::roundf.
	(xtrunc (double)): Forward to gnulib::trunc.
	(xtrunc (float)): Forward to gnulib::truncf.

2010-03-25  David Grundberg  <davidg@cs.umu.se>

	* oct-time.h (octave_time): Revert ::modf to std::modf again now
	that cmath is included again.

2010-03-25  Jaroslav Hajek  <highegg@gmail.com>

	* lo-math.h: Include both "math.h" and "cmath".

2010-03-24  David Grundberg  <davidg@cs.umu.se>

	* cmd-edit.cc: Include gnulib stdlib.h/string.h instead of C++
	headers.
	* file-ops.cc: Include gnulib stdlib.h/stdio.h/string.h instead of
	C++ headers.
	* lo-math.h: Include gnulib math.h instead of C++ headers.
	* lo-utils.cc: Include gnulib stdlib.h instead of C++ headers.
	* oct-env.cc, dir-ops.cc, file-stat.cc, cmd-hist.cc: Include
	gnulib string.h instead of C++ headers.
	* oct-time.cc: Include gnulib time.h instead of C++ headers.
	* oct-time.h (octave_time): Use default namespace ::modf instead
	of std::modf.
	* oct-uname.cc: Include gnulib string.h instead of C++ headers.

2010-03-24  Jaroslav Hajek  <highegg@gmail.com>

	* Sparse.cc (lblookup): New helper func.
	(Sparse<T>::index (const idx_vector&, bool)): Use it here for lookups.
	(Sparse<T>::index (const idx_vector&, const idx_vector&, bool)):
	Specialize for scalar row index.

2010-03-23  John W. Eaton  <jwe@octave.org>

	* config-ops.sh: Work properly for "all" cases.

2010-03-23  Jaroslav Hajek  <highegg@gmail.com>

	* oct-inttypes.h (octave_int_arith_base::rem, octave_int_base::mod):
	New methods.
	(rem, mod): New template functions.
	* lo-mappers.cc (rem, mod): New overloaded functions.
	* lo-mappers.h: Declare them.

2010-03-23  Jaroslav Hajek  <highegg@gmail.com>

	* oct-binmap.h: New source.
	* Makefile.am: Include it here.

2010-03-22  John W. Eaton  <jwe@octave.org>

	* config-ops.sh: Accept additional arguments.
	* Makefile.am ($(srcdir)/vx-op-inc.mk, $(srcdir)/mx-op-inc.mk
	$(srcdir)/smx-op-inc.mk, $(srcdir)/vx-op-src.mk, $(srcdir)/mx-op-src.mk
	$(srcdir)/smx-op-src.mk): Pass additional arguments to config-ops.sh.

2010-03-22  Jaroslav Hajek  <highegg@gmail.com>

	* Sparse.cc (Sparse<T>::index (const idx_vector&, const idx_vector&,
	bool)): Handle resize_ok in advance. Optimize colon as the first index.
	(Sparse<T>::index (const idx_vector&, bool)): Small fixes.

2010-03-22  Jaroslav Hajek  <highegg@gmail.com>

	* dSparse.cc (SparseMatrix::matrix_value): Simplify.
	* CSparse.cc (SparseComplexMatrix::matrix_value): Simplify.

2010-03-19  Jaroslav Hajek  <highegg@gmail.com>

	* Array-util.cc (gripe_invalid_resize): Move here from Array.cc.
	* Array-util.h: Declare it.
	* Array.cc: Use it.

	* idx-vector.cc (idx_vector::idx_mask_rep::unconvert): Fix non-owned
	case.
	(idx_vector::idx_mask_rep::as_array): New method.
	* idx-vector.h: Declare it.

	* Sparse.cc (Sparse<T>::index (const idx_vector&, bool)): Rewrite.
	(Sparse<T>::array_value): New method.
	(Sparse<T>::resize1): New method.
	(Sparse<T>::resize): Move resize_no_fill bodies in here.
	(Sparse<T>::resize_no_fill): Remove.
	* Sparse.h: Update decls.

2010-03-18  Jaroslav Hajek  <highegg@gmail.com>

	* Sparse.h (Sparse<T>::index): Use const references. Use bool for
	resize_ok. Remove Array<idx_vector> overload.
	* MSparse.h (MSparse<T>::index): Ditto.
	* dSparse.h, dSparse.cc (SparseMatrix::index): Ditto.
	* CSparse.h, CSparse.cc (SparseComplexMatrix::index): Ditto.
	* boolSparse.h, boolSparse.cc (SparseBoolMatrix::index): Ditto.
	* Sparse.cc (Sparse<T>::index): Ditto. Redim index to 2 dimensions.
	Don't use non-const methods. Use gripe_index_out_of_range.

2010-03-17  John W. Eaton  <jwe@octave.org>

	* dim-vector.h (dim_vector): Also use DIM_VECTOR macro for 2 and
	3 dimensions.

2010-03-17  Jaroslav Hajek  <highegg@gmail.com>

	* lo-macros.h: New source.
	* dim-vector.h: Use the macro magic to define constructors
	generically.

2010-03-17  Jaroslav Hajek  <highegg@gmail.com>

	* dim-vector.h: Provide constructors up to order 7.

2010-03-16  Jaroslav Hajek  <highegg@gmail.com>

	* lo-specfun.cc: Substitute cbrt and cbrtf if needed.
	* lo-specfun.h: Declare cbrt and cbrtf if needed.
	* configure.ac: Check for cbrt and cbrtf.

2010-03-15  John W. Eaton  <jwe@octave.org>

	* oct-glob.cc (octave_glob): Tag calls to glob and globfree with
	gnulib::.

	* kpse.cc (DEBUG_START, DEBUGF, FATAL_PERROR, FATAL, KPSE_DEBUG,
	log_search, find_first_of): Tag calls to
	fputs with gnulib::.
	(DEBUGF1, DEBUGF2, DEBUGF3, DEBUGF4, log_search, find_first_of,
	kpse_element_dirs): Tag calls to fprintf with gnulib::.
	(hash_lookup, search, find_first_of, kpse_element_dirs):
	Tag calls to putc with gnulib::.
	(do_subdir): Tag call to opendir with gnulib::.
	(xclosedir): Tag call to closedir with gnulib::.  Assume closedir
	returns int value.

	* cmd-hist.cc (gnu_history::do_append): Tag calls to open and
	close with gnulib::.
	(command_history::error): Tag call to strerror with gnulib::.

	* cmd-edit.cc (gnu_readline::command_generator,
	gnu_readline::command_quoter, gnu_readline::command_dequoter):
	Tag call to malloc with gnulib::.
	(default_command_editor::do_readline): Tag call to fputs with gnulib::.
	(command_editor::error): Tag call to strerror with gnulib::.

	* sparse-util.cc (SparseCholPrint): Tag call to vfprintf with gnulib::.

	* oct-uname.cc (octave_uname::init): Tag call to strerror with gnulib::.

	* oct-time.cc (octave_time::stamp): Tag call to gettimeofday
	with gnulib::.
	(octave_strptime::init): Tag call to strptime with gnulib::.

	* oct-syscalls.cc (octave_syscalls::dup2,
	octave_syscalls::execvp, octave_syscalls::fork,
	octave_syscalls::vfork, octave_syscalls::getpgrp,
	octave_syscalls::pipe, octave_syscalls::waitpid,
	octave_syscalls::kill, octave_fcntl):
	Tag call to strerror with gnulib::.
	(octave_syscalls::dup2): Tag call to dup2 with gnulib::.
	(octave_syscalls::popen2): Tag calls to close with gnulib::.
	(octave_fcntl): Tag call to fcntl with gnulib::.

	* oct-env.cc (octave_env::error): Tag call to strerror with gnulib::.

	* lo-utils.cc (octave_putenv): Tag call to malloc with gnulib::.
	(octave_fgets): Tag calls to malloc and realloc with gnulib::.

	* lo-sysdep.cc (octave_getcwd): Tag call to getcwd with gnulib::.

	* lo-mappers.cc (xround): Tag call to round with gnulib::.

	* file-stat.cc (file_stat::update_internal): Tag calls to lstat
	and strerror with gnulib::.
	(file_fstat::update_internal): Tag calls to fstat and strerror
	with gnulib::.

	* file-ops.cc (octave_mkdir): Tag call to mkdir with gnulib::.
	(octave_mkfifo): Tag call to mkfifo with gnulib::.
	(octave_link): Tag call to link with gnulib::.
	(octave_symlink): Tag call to symlink with gnulib::.
	(octave_readlink): Tag call to readlink with gnulib::.
	(octave_rename): Tag call to rename with gnulib::.
	(octave_rmdir): Tag call to rmdir with gnulib::.
	(octave_unlink): Tag call to unlink with gnulib::.
	(octave_canonicalize_file_name): Tag call to
	canonicalize_file_name with gnulib::.
	(octave_mkdir, octave_mkfifo, octave_link, octave_symlink,
	octave_readlink, octave_rename, octave_rmdir, octave_unlink,
	octave_tempnam, octave_canonicalize_file_name): Tag calls to
	strerror with gnulib::.

	* dir-ops.cc (dir_entry::close): Tag closedir call with gnulib::.
	(dir_entry::open): Tag opendir and strerror calls with gnulib::.

2010-03-09  Jaroslav Hajek  <highegg@gmail.com>

	* oct-inttypes.h (octave_int_base::ftrunc, octave_int_base::fnon_int,
	octave_int_base::fnan, octave_int_base::get_trunc_flag,
	octave_int_base::get_nan_flag,
	octave_int_base::get_non_int_flag,
	octave_int_base::get_math_trunc_flag,
	octave_int_base::clear_conv_flags): Remove.
	Remove occurences of ftrunc, fnon_int and fnan eveywhere.
	* oct-inttypes.cc: Ditto last sentence. Remove warning tests.

2010-03-07  Soren Hauberg  <hauberg@gmail.com>

	* dim-vector.h: New constructor accepting a C array of dimensions.

2010-03-05  Jaroslav Hajek  <highegg@gmail.com>

	* MArray.cc (MArray<T>::idx_add_nd): New method.
	* MArray.h: Declare it.

2010-03-04  Jaroslav Hajek  <highegg@gmail.com>

	* lo-specfun.cc (erfcx, erfcx_impl): New functions.
	* lo-specfun.h: Declare erfcx.

2010-03-03  John W. Eaton  <jwe@octave.org>

	* oct-convn.cc (convolve): Cast int constant to octave_idx_type in
	call to std::max.

2010-03-03  Jaroslav Hajek  <highegg@gmail.com>

	* oct-convn.cc (convolve_2d_axpy_kernel, convolve_2d_axpy): Remove.
	(convolve_2d): Forward to Fortran implementations, add inner flag.
	(convolve_nd): Handle inner-convolution case.
	(convolve): Ditto.

2010-03-02  Jaroslav Hajek  <highegg@gmail.com>

	* oct-convn.h, oct-convn.cc: New sources.
	* Makefile.am: Include them.

2010-03-01  David Bateman  <dbateman@free.fr>

	* Sparse.cc (Sparse<T>::maybe_delete_elements (idxx_vector&)):
	Special case the deletion of elements in sparse vectors.
	(Sparse<T>::index (idx_vector&, int) const): Special case indexing
	of sparse matrices with ranges with a step of 1.
	* Sparse.h: Include oct-mem.h for the copy_or_memcpy declaration.

2010-02-28  John W. Eaton  <jwe@octave.org>

	* Makefile.am ($(srcdir)/vx-op-inc.mk, $(srcdir)/mx-op-inc.mk,
	$(srcdir)/smx-op-inc.mk, $(srcdir)/vx-op-src.mk,
	$(srcdir)/mx-op-src.mk, $(srcdir)/smx-op-src.mk): New targets.

	* config-ops.sh: Accept top_srcdir argument.  Work from build
	directory too, not just source tree.

2010-02-28  Michael Goffioul  <michael.goffioul@gmail.com>

	* Array-C.cc (DiagArray2<Complex>::Proxy): Remove explicit
	instantiation under MSVC.
	Array-d.cc (DiagArray2<double>::Proxy): Ditto.
	Array-f.cc (DiagArray2<float>::Proxy): Ditto.
	Array-fC.cc (DiagArray2<FloatComplex::Proxy): Ditto.

2010-02-28  Jaroslav Hajek  <highegg@gmail.com>

	* Array-util.cc (gripe_index_out_of_range): Throw errors with id.
	(gripe_nonconformant): Likewise.
	(error_id_index_out_of_bounds, error_id_invalid_index,
	error_id_nonconformant_args): New variables.
	(gripe_invalid_index): New function.
	* Array-util.h: Declare them.
	* Array.cc (Array<T>::checkelem): Throw invalid-index when negative
	indices are encountered.

2010-02-27  John W. Eaton  <jwe@octave.org>

	* Sparse.cc (Sparse<T>::diag): Handle case of diag (szv) when szv
	is a sparse vector with nnz = 0.

2010-02-27  Jaroslav Hajek  <highegg@gmail.com>

	* Array-util.cc (gripe_index_out_of_range): New function.
	* Array.cc (Array<T>::range_error): Remove.
	(Array<T>::checkelem): Rewrite.
	(Array<T>::index, Array<T>::delete_elements): Simplify.
	* DiagArray2.cc (DiagArray2::checkelem): Use gripe_index_out_of_range.
	* Range.cc (Range::checkelem, Range::index): Ditto.

2010-02-26  Jaroslav Hajek  <highegg@gmail.com>

	* mx-inlines.cc (OP_DUP_FCN): Remove.
	(mx_inline_dup): Remove.
	(mx_inline_not): Remove.
	(mx_inline_make_complex): Remove.
	(mx_inline_change_sign): Remove.
	(mx_inline_fabs_dup): Remove.
	(mx_inline_cabs_dup): Remove.
	(mx_inline_imag_dup): Remove.
	(mx_inline_real_dup): Remove.
	(mx_inline_conj_dup): Remove.
	(mx_inline_change_sign): Remove.

2010-02-26  Jaroslav Hajek  <highegg@gmail.com>

	* Array.h (Array<T>::ArrayRep): Simplify copy constructor. Add
	conversion constructor.
	(Array<T>): Remove pointer acquiring ctors.
	(Array<T>::maybe_economize): Update.
	(Array<T>::make_unique): Update.
	* Array.cc (Array<T>::fill): Update.

	* MArray.h (MArray<T>::MArray<T> (T *, ...)): Remove.
	* DiagArray2.h (DiagArray2<T>::DiagArray2<T> (T *, ...)): Remove.
	* MDiagArray2.h (MDiagArray2<T>::MDiagArray2<T> (T *, ...)): Remove.
	* Array3.h (Array3<T>::Array3<T> (T *, ...)): Remove.

	* dColVector.h (ColumnVector::ColumnVector (T *, ...)): Remove.
	* fColVector.h (FloatColumnVector::FloatColumnVector (T *, ...)): Remove.
	* CColVector.h (ComplexColumnVector::ComplexColumnVector (T *, ...)): Remove.
	* fCColVector.h (FloatComplexColumnVector::FloatComplexColumnVector (T *, ...)): Remove.

	* dRowVector.h (RowVector::RowVector (T *, ...)): Remove.
	* fRowVector.h (FloatRowVector::FloatRowVector (T *, ...)): Remove.
	* CRowVector.h (ComplexRowVector::ComplexRowVector (T *, ...)): Remove.
	* fCRowVector.h (FloatComplexRowVector::FloatComplexRowVector (T *, ...)): Remove.

	* dMatrix.h (Matrix::Matrix (T *, ...)): Remove.
	* fMatrix.h (FloatMatrix::FloatMatrix (T *, ...)): Remove.
	* CMatrix.h (ComplexMatrix::ComplexMatrix (T *, ...)): Remove.
	* fCMatrix.h (FloatComplexMatrix::FloatComplexMatrix (T *, ...)): Remove.
	* boolMatrix.h (boolMatrix::boolMatrix (T *, ...)): Remove.
	* chMatrix.h (charMatrix::charMatrix (T *, ...)): Remove.

	* dNDArray.h (NDArray::NDArray (T *, ...)): Remove.
	* fNDArray.h (FloatNDArray::FloatNDArray (T *, ...)): Remove.
	* CNDArray.h (ComplexNDArray::ComplexNDArray (T *, ...)): Remove.
	* fCNDArray.h (FloatComplexNDArray::FloatComplexNDArray (T *, ...)): Remove.
	* boolNDArray.h (boolNDArray::boolNDArray (T *, ...)): Remove.
	* chNDArray.h (charNDArray::charNDArray (T *, ...)): Remove.

2010-02-26  Jaroslav Hajek  <highegg@gmail.com>

	* DiagArray2.h (DiagArray2): Clean up ctors. Remove Proxy class.
	Remove non-const two-index elem methods.
	* DiagArray2.cc: Update.
	* MDiagArray2.h: Update.

	* dDiagArray2.h: Update.
	* dDiagArray2.cc: Update.
	* fDiagArray2.h: Update.
	* fDiagArray2.cc: Update.
	* CDiagArray2.h: Update.
	* CDiagArray2.cc: Update.
	* fCDiagArray2.h: Update.
	* fCDiagArray2.cc: Update.

	* dMatrix.cc: Update.
	* fMatrix.cc: Update.
	* CMatrix.cc: Update.
	* fCMatrix.cc: Update.

	* dRowVector.cc: Update.
	* fRowVector.cc: Update.
	* CRowVector.cc: Update.
	* fCRowVector.cc: Update.

	* dColVector.cc: Update.
	* fColVector.cc: Update.
	* CColVector.cc: Update.
	* fCColVector.cc: Update.

	* dColVector.cc (ColumnVector::abs): New method.
	* dColVector.h: Declare it.
	* fColVector.cc (FloatColumnVector::abs): New method.
	* fColVector.h: Declare it.
	* CColVector.cc (ComplexColumnVector::abs): New method.
	* CColVector.h: Declare it.
	* fCColVector.cc (FloatComplexColumnVector::abs): New method.
	* fCColVector.h: Declare it.

2010-02-26  Jaroslav Hajek  <highegg@gmail.com>

	* mx-inlines.cc: Parameterize all appliers by value types rather than
	Array types. Return & accept Array instances.
	* mx-op-defs.h: Update references.
	* CMatrix.cc: Ditto.
	* CNDArray.cc: Ditto.
	* DiagArray2.h: Ditto.
	* MArray.cc: Ditto.
	* boolMatrix.cc: Ditto.
	* boolNDArray.cc: Ditto.
	* bsxfun-defs.cc: Ditto.
	* chMatrix.cc: Ditto.
	* chNDArray.cc: Ditto.
	* dMatrix.cc: Ditto.
	* dNDArray.cc: Ditto.
	* fCMatrix.cc: Ditto.
	* fCNDArray.cc: Ditto.
	* fMatrix.cc: Ditto.
	* fNDArray.cc: Ditto.
	* intNDArray.cc: Ditto.
	* MDiagArray2.cc: Remove computed assignment operators, adapt
	operators to new mechanism.
	* MDiagArray2.h: Declare operators as friends.
	* MArray-decl.h (MDIAGARRAY2_OPS_FRIEND_DECLS): Don't expand
	MARRAY_OP_ASSIGN_FRIENDS here.

2010-02-25  John W. Eaton  <jwe@octave.org>

	* eigs-base.cc: Use octave_idx_type for Fortran LOGICAL values
	in function prototypes.
	(EigsRealSymmetricMatrix, EigsRealSymmetricMatrixShift,
	EigsRealSymmetricFunc, EigsRealNonSymmetricMatrix,
	EigsRealNonSymmetricMatrixShift, EigsRealNonSymmetricFunc,
	EigsComplexNonSymmetricMatrix, EigsComplexNonSymmetricMatrixShift,
	EigsComplexNonSymmetricFunc): Declare rvec argument as bool, not int.
	Fix explicit instantiations to match.

2010-02-25  Jaroslav Hajek  <highegg@gmail.com>

	* oct-mem.h (safe_size_comp): New helper func.
	(no_ctor_new): Call it here.

2010-02-25  Jaroslav Hajek  <highegg@gmail.com>

	* oct-mem.h (copy_or_memcpy, fill_or_memset, no_ctor_new): Accept
	size_t rather than octave_idx_type.
	* Array.h (Array<T>::byte_size): Correct calculation.
	* DiagArray2.h (DiagArray2<T>::byte_size): Call inherited byte_size.
	* PermMatrix.h (PermMatrix::byte_size): Ditto.

2010-02-25  Jaroslav Hajek  <highegg@gmail.com>

	* str-vec.h (string_vector::string_vector): Use (n, 1).
	(string_vector::resize): Ditto.
	* str-vec.cc (string_vector::string_vector): Ditto.

2010-02-24  Jaroslav Hajek  <highegg@gmail.com>

	* Array.cc (Array::Array (const Array&, octave_idx_type,
	octave_idx_type): New ctor.
	(Array::reshape (octave_idx_type, octave_idx_type): New method.
	* Array.h: Declare them.
	* Array2.h: Deprecate Array2, make it a #define for Array.

	* Array-C.cc: Remove Array2 instantiation.
	* Array-b.cc: Ditto.
	* Array-ch.cc: Ditto.
	* Array-d.cc: Ditto.
	* Array-f.cc: Ditto.
	* Array-fC.cc: Ditto.
	* Array-i.cc: Ditto.
	* Array-s.cc: Ditto.
	* Array-voidp.cc: Ditto.

	* CMatrix.cc: Use Array instead of Array2 everywhere.
	* CMatrix.h: Ditto.
	* CNDArray.cc: Ditto.
	* DiagArray2.cc: Ditto.
	* DiagArray2.h: Ditto.
	* MDiagArray2.h: Ditto.
	* Sparse.cc: Ditto.
	* Sparse.h: Ditto.
	* boolMatrix.h: Ditto.
	* boolNDArray.cc: Ditto.
	* chMatrix.h: Ditto.
	* chNDArray.cc: Ditto.
	* dMatrix.cc: Ditto.
	* dMatrix.h: Ditto.
	* dNDArray.cc: Ditto.
	* fCMatrix.cc: Ditto.
	* fCMatrix.h: Ditto.
	* fCNDArray.cc: Ditto.
	* fMatrix.cc: Ditto.
	* fMatrix.h: Ditto.
	* fNDArray.cc: Ditto.
	* lo-specfun.cc: Ditto.
	* lo-specfun.h: Ditto.

2010-02-23  Jaroslav Hajek  <highegg@gmail.com>

	* chMatrix.h (charMatrix): Base on Array<char>.
	* chMatrix.cc (charMatrix): Update.
	* boolMatrix.h (boolMatrix): Ditto.
	* boolMatrix.h (boolMatrix): Update.

2010-02-23  Jaroslav Hajek  <highegg@gmail.com>

	* Array.h (Array): Define 2D constructors. Remove conflicting 1D
	initialized constructor. Deprecate 1D constructor. Deprecate 1D resize.
	Add 2D resize, resize1. Remove resize_fill. Make resize_fill_value
	return a reference. Remove 1D clear.

	* MArray.h (MArray): Merge with MArrayN. Define 2D constructors, sync
	with Array changes.

	* MArrayN.h, MArray2.h: Deprecate headers, use compatibility #defines.
	* MArrayN.cc, MArray2.cc: Remove sources.
	* Makefile.am: Update.

	* fCMatrix.h (FloatComplexMatrix): Rebase on MArray.
	* fMatrix.h (FloatMatrix): Ditto.
	* dMatrix.h (Matrix): Ditto.
	* CMatrix.h (ComplexMatrix): Ditto.
	* fCNDArray.h (FloatComplexNDArray): Rebase on MArray.
	* fNDArray.h (FloatNDArray): Ditto.
	* dNDArray.h (NDArray): Ditto.
	* CNDArray.h (ComplexNDArray): Ditto.

	* Array-util.cc: Update.
	* Array.cc: Ditto.
	* Array2.h: Ditto.
	* Array3.h: Ditto.
	* CColVector.cc: Ditto.
	* CColVector.h: Ditto.
	* CMatrix.cc: Ditto.
	* CNDArray.cc: Ditto.
	* CRowVector.cc: Ditto.
	* CSparse.cc: Ditto.
	* ChangeLog: Ditto.
	* CmplxCHOL.cc: Ditto.
	* CmplxHESS.cc: Ditto.
	* CmplxLU.cc: Ditto.
	* CmplxQRP.cc: Ditto.
	* CmplxSCHUR.cc: Ditto.
	* CmplxSVD.cc: Ditto.
	* CollocWt.cc: Ditto.
	* DASPK-opts.in: Ditto.
	* DASPK.cc: Ditto.
	* DASRT-opts.in: Ditto.
	* DASRT.cc: Ditto.
	* DASSL-opts.in: Ditto.
	* DASSL.cc: Ditto.
	* DiagArray2.cc: Ditto.
	* DiagArray2.h: Ditto.
	* EIG.cc: Ditto.
	* LSODE-opts.in: Ditto.
	* LSODE.cc: Ditto.
	* MArray-C.cc: Ditto.
	* MArray-d.cc: Ditto.
	* MArray-defs.h: Ditto.
	* MArray-f.cc: Ditto.
	* MArray-fC.cc: Ditto.
	* MArray-i.cc: Ditto.
	* MArray-s.cc: Ditto.
	* MArray.cc: Ditto.
	* MDiagArray2.h: Ditto.
	* MSparse-defs.h: Ditto.
	* MSparse.cc: Ditto.
	* MSparse.h: Ditto.
	* Makefile.am: Ditto.
	* MatrixType.cc: Ditto.
	* PermMatrix.cc: Ditto.
	* Quad.cc: Ditto.
	* SparseCmplxLU.cc: Ditto.
	* SparseCmplxQR.cc: Ditto.
	* SparseCmplxQR.h: Ditto.
	* SparseQR.cc: Ditto.
	* SparseQR.h: Ditto.
	* SparsedbleLU.cc: Ditto.
	* base-lu.cc: Ditto.
	* dColVector.h: Ditto.
	* dMatrix.cc: Ditto.
	* dNDArray.cc: Ditto.
	* dRowVector.h: Ditto.
	* dSparse.cc: Ditto.
	* dbleCHOL.cc: Ditto.
	* dbleHESS.cc: Ditto.
	* dbleLU.cc: Ditto.
	* dbleQRP.cc: Ditto.
	* dbleSCHUR.cc: Ditto.
	* dbleSVD.cc: Ditto.
	* dim-vector.h: Ditto.
	* eigs-base.cc: Ditto.
	* fCColVector.cc: Ditto.
	* fCColVector.h: Ditto.
	* fCMatrix.cc: Ditto.
	* fCNDArray.cc: Ditto.
	* fCRowVector.cc: Ditto.
	* fCRowVector.h: Ditto.
	* fCmplxCHOL.cc: Ditto.
	* fCmplxHESS.cc: Ditto.
	* fCmplxLU.cc: Ditto.
	* fCmplxQRP.cc: Ditto.
	* fCmplxSCHUR.cc: Ditto.
	* fCmplxSVD.cc: Ditto.
	* fColVector.h: Ditto.
	* fEIG.cc: Ditto.
	* fMatrix.cc: Ditto.
	* fNDArray.cc: Ditto.
	* fRowVector.h: Ditto.
	* floatCHOL.cc: Ditto.
	* floatHESS.cc: Ditto.
	* floatLU.cc: Ditto.
	* floatQRP.cc: Ditto.
	* floatSCHUR.cc: Ditto.
	* floatSVD.cc: Ditto.
	* glob-match.h: Ditto.
	* int16NDArray.h: Ditto.
	* int32NDArray.h: Ditto.
	* int64NDArray.h: Ditto.
	* int8NDArray.h: Ditto.
	* intNDArray.cc: Ditto.
	* intNDArray.h: Ditto.
	* oct-fftw.cc: Ditto.
	* oct-norm.cc: Ditto.
	* oct-rand.cc: Ditto.
	* regex-match.cc: Ditto.
	* sparse-dmsolve.cc: Ditto.
	* str-vec.cc: Ditto.
	* str-vec.h: Ditto.
	* uint16NDArray.h: Ditto.
	* uint32NDArray.h: Ditto.
	* uint64NDArray.h: Ditto.
	* uint8NDArray.h: Ditto.

2010-02-22  John W. Eaton  <jwe@octave.org>

	* data-conv.cc, data-conv.h (read_floats, read_doubles,
	do_float_format_conversion, do_double_format_conversion):
	Declare len arg and loop counter as octave_idx_type, not int.
	(strip_spaces): Use size_t for string dimension and index, not int.
	(LS_DO_READ, LS_DO_WRITE): Declare loop counter as
	octave_idx_type, not int.
	(write_floats, write_doubles):
	Declare len arg as octave_idx_type, not int.
	(IEEE_big_double_to_IEEE_little_double,
	VAX_D_double_to_IEEE_little_double,
	VAX_G_double_to_IEEE_little_double,
	Cray_to_IEEE_little_double,
	IEEE_big_float_to_IEEE_little_float,
	VAX_D_float_to_IEEE_little_float,
	VAX_G_float_to_IEEE_little_float, Cray_to_IEEE_little_float,
	IEEE_little_double_to_IEEE_big_double,
	VAX_D_double_to_IEEE_big_double,
	VAX_G_double_to_IEEE_big_double, Cray_to_IEEE_big_double,
	IEEE_little_float_to_IEEE_big_float,
	VAX_D_float_to_IEEE_big_float, VAX_G_float_to_IEEE_big_float,
	Cray_to_IEEE_big_float, IEEE_little_double_to_VAX_D_double,
	IEEE_big_double_to_VAX_D_double,
	VAX_G_double_to_VAX_D_double, Cray_to_VAX_D_double,
	IEEE_little_float_to_VAX_D_float,
	IEEE_big_float_to_VAX_D_float, VAX_G_float_to_VAX_D_float,
	Cray_to_VAX_D_float, IEEE_little_double_to_VAX_G_double,
	IEEE_big_double_to_VAX_G_double,
	VAX_D_double_to_VAX_G_double, Cray_to_VAX_G_double,
	IEEE_little_float_to_VAX_G_float,
	IEEE_big_float_to_VAX_G_float, VAX_D_float_to_VAX_G_float,
	Cray_to_VAX_G_float, read_doubles):
	Declare len arg as octave_idx_type, not int.

2010-02-21  Michael Goffioul  <michael.goffioul@gmail.com>

	* lo-sysdep.cc, lo-utils.h, oct-shlib.h: Define WIN32_LEAN_AND_MEAN
	and don't #undef min/max.
	* oct-inttypes.h: Don't #undef min/max.

	* oct-glob.cc (octave_glob): Convert backslashes to forward slashes
	automatically before calling glob, and convert back after the call
	(implementation from jwe).

	* Makefile.am: Add -bindir flag to liboctave_la_LDFLAGS.

2010-02-19  Jaroslav Hajek  <highegg@gmail.com>

	* idx-vector.cc (idx_vector::as_array,
	idx_vector::idx_range_rep::as_array,
	idx_vector::idx_scalar_rep::as_array,
	idx_vector::idx_vector_rep::as_array): New methods.
	* idx-vector.h: Declare them.

2010-02-17  John W. Eaton  <jwe@octave.org>

	* oct-rand.cc: Include <sdint.h>.  Change declarations of ranlib
	functions to take int32_t instead of octave_idx_type values.
	Change all uses.
	(octave_rand::do_seed): Use int32_t in union, not octave_idx_type.
	(force_to_fit_range): Args are now int32_t, not octave_idx_type.
	(octave_rand::initialize_ranlib_generators): Use int32_t in seed
	calculation.

2010-02-17  Jaroslav Hajek  <highegg@gmail.com>

	* mx-op-defs.h (MINMAX_FCNS): Generalize.
	* mx-op-decl.h (MINMAX_DECLS): Likewise.

	* int16NDArray.h, int32NDArray.h, int64NDArray.h, int8NDArray.h,
	uint16NDArray.h, uint32NDArray.h, uint64NDArray.h, uint8NDArray.h:
	Update.
	* int16NDArray.cc, int32NDArray.cc, int64NDArray.cc, int8NDArray.cc,
	uint16NDArray.cc, uint32NDArray.cc, uint64NDArray.cc, uint8NDArray.cc:
	Update.

	* CNDArray.h, dNDArray.h, fCNDArray.h, fNDArray.h: Replace explicit
	decls.

	* CNDArray.cc, dNDArray.cc, fCNDArray.cc, fNDArray.cc: Replace explicit
	definitions.


2010-02-11  John W. Eaton  <jwe@octave.org>

	* sparse-mk-ops.awk, mk-ops.awk, filemode.c, lo-cieee.c,
	oct-rl-hist.c, randgamma.c, randmtzig.c, randpoisson.c,
	tempnam.c, tempname.c: Untabify.

2010-02-11  John W. Eaton  <jwe@octave.org>

	* Array-C.cc, Array-fC.cc, Array-util.cc, Array.cc,
	CColVector.cc, CDiagMatrix.cc, CMatrix.cc, CNDArray.cc,
	CRowVector.cc, CSparse.cc, CmplxAEPBAL.cc, CmplxCHOL.cc,
	CmplxGEPBAL.cc, CmplxHESS.cc, CmplxLU.cc, CmplxQR.cc,
	CmplxQRP.cc, CmplxSCHUR.cc, CmplxSVD.cc, CollocWt.cc, DASPK.cc,
	DASRT.cc, DASSL.cc, EIG.cc, LSODE.cc, MSparse.cc, MatrixType.cc,
	ODES.cc, Quad.cc, Range.cc, Sparse-C.cc, Sparse.cc,
	SparseCmplxCHOL.cc, SparseCmplxLU.cc, SparseCmplxQR.cc,
	SparseQR.cc, SparsedbleCHOL.cc, SparsedbleLU.cc, boolNDArray.cc,
	boolSparse.cc, chMatrix.cc, chNDArray.cc, cmd-edit.cc,
	cmd-hist.cc, dColVector.cc, dDiagMatrix.cc, dMatrix.cc,
	dNDArray.cc, dRowVector.cc, dSparse.cc, data-conv.cc,
	dbleAEPBAL.cc, dbleCHOL.cc, dbleGEPBAL.cc, dbleHESS.cc,
	dbleLU.cc, dbleQR.cc, dbleQRP.cc, dbleSCHUR.cc, dbleSVD.cc,
	dir-ops.cc, eigs-base.cc, fCColVector.cc, fCDiagMatrix.cc,
	fCMatrix.cc, fCNDArray.cc, fCRowVector.cc, fCmplxAEPBAL.cc,
	fCmplxCHOL.cc, fCmplxGEPBAL.cc, fCmplxHESS.cc, fCmplxLU.cc,
	fCmplxQR.cc, fCmplxQRP.cc, fCmplxSCHUR.cc, fCmplxSVD.cc,
	fColVector.cc, fDiagMatrix.cc, fEIG.cc, fMatrix.cc, fNDArray.cc,
	fRowVector.cc, file-stat.cc, floatAEPBAL.cc, floatCHOL.cc,
	floatGEPBAL.cc, floatHESS.cc, floatLU.cc, floatQR.cc,
	floatQRP.cc, floatSCHUR.cc, floatSVD.cc, idx-vector.cc,
	intNDArray.cc, kpse.cc, lo-ieee.cc, lo-mappers.cc,
	lo-specfun.cc, lo-sysdep.cc, lo-utils.cc, mach-info.cc,
	mx-inlines.cc, oct-alloc.cc, oct-env.cc, oct-fftw.cc,
	oct-glob.cc, oct-group.cc, oct-inttypes.cc, oct-md5.cc,
	oct-rand.cc, oct-shlib.cc, oct-sort.cc, oct-spparms.cc,
	oct-syscalls.cc, oct-time.cc, pathsearch.cc, regex-match.cc,
	sparse-base-chol.cc, sparse-base-lu.cc, sparse-dmsolve.cc,
	sparse-sort.cc, sparse-util.cc, str-vec.cc: Untabify.

2010-02-11  John W. Eaton  <jwe@octave.org>

	* Array-util.h, Array.h, Array2.h, Array3.h, CColVector.h,
	CMatrix.h, CNDArray.h, CRowVector.h, CSparse.h, CmplxCHOL.h,
	CmplxGEPBAL.h, CmplxHESS.h, CmplxLU.h, CmplxQRP.h, CmplxSCHUR.h,
	CmplxSVD.h, CollocWt.h, DAE.h, DAEFunc.h, DAERT.h, DAERTFunc.h,
	DASPK.h, DASRT.h, DASSL.h, DiagArray2.h, EIG.h, MArrayN.h,
	MDiagArray2.h, MSparse-defs.h, MSparse.h, MatrixType.h, ODE.h,
	ODEFunc.h, ODES.h, ODESFunc.h, Quad.h, Range.h,
	Sparse-diag-op-defs.h, Sparse-op-defs.h, Sparse-perm-op-defs.h,
	Sparse.h, SparseCmplxCHOL.h, SparseCmplxLU.h, SparseCmplxQR.h,
	SparseQR.h, SparsedbleCHOL.h, SparsedbleLU.h, base-dae.h,
	base-de.h, base-lu.h, base-min.h, base-qr.h, boolNDArray.h,
	boolSparse.h, chNDArray.h, cmd-hist.h, dMatrix.h, dNDArray.h,
	dSparse.h, data-conv.h, dbleCHOL.h, dbleGEPBAL.h, dbleHESS.h,
	dbleLU.h, dbleQRP.h, dbleSCHUR.h, dbleSVD.h, dir-ops.h,
	fCColVector.h, fCMatrix.h, fCNDArray.h, fCRowVector.h,
	fCmplxCHOL.h, fCmplxGEPBAL.h, fCmplxHESS.h, fCmplxLU.h,
	fCmplxQRP.h, fCmplxSCHUR.h, fCmplxSVD.h, fEIG.h, fMatrix.h,
	fNDArray.h, file-stat.h, floatCHOL.h, floatGEPBAL.h,
	floatHESS.h, floatLU.h, floatQRP.h, floatSCHUR.h, floatSVD.h,
	glob-match.h, idx-vector.h, intNDArray.h, lo-ieee.h,
	lo-specfun.h, mx-op-decl.h, mx-op-defs.h, oct-env.h, oct-fftw.h,
	oct-group.h, oct-inttypes.h, oct-mutex.h, oct-passwd.h,
	oct-rand.h, oct-shlib.h, oct-sort.h, oct-spparms.h, oct-time.h,
	oct-uname.h, pathsearch.h, sparse-base-chol.h, sparse-base-lu.h,
	sparse-sort.h, sparse-util.h, statdefs.h, str-vec.h: Untabify.

2010-02-10  John W. Eaton  <jwe@octave.org>

	* dMatrix.h (template <class U> Matrix (const Array<U>&)):
	New constructor.
	* CMatrix.h (template <class U> ComplexMatrix (const Array<U>&)):
	New constructor.
	* fMatrix.h (template <class U> FloatMatrix (const Array<U>&)):
	New constructor.
	* fCMatrix.h (template <class U> FloatComplexMatrix (const Array<U>&)):
	New constructor.

2010-02-09  Jaroslav Hajek  <highegg@gmail.com>

	* idx-vector.cc (idx_vector::idx_vector_rep::idx_vector_rep (const
	Array<octave_idx_type>&, octave_idx_type, direct)): New constructor.
	* idx-vector.h: Declare it.
	(idx_vector::idx_vector (const Array<octave_idx_type>&,
	octave_idx_type)): New constructor.

2010-02-08  John W. Eaton  <jwe@octave.org>

	* oct-time.cc: Include "strftime.h", not <strftime.h>.
	* file-ops.cc: Include "pathmax.h", not <pathmax.h>.

2010-02-08  John W. Eaton  <jwe@octave.org>

	* oct-env.cc (octave_env::prog_invocation_name): Rename from
	program_invocation_name.  Change all uses.
	(octave_env::prog_name): Rename from program_name.  Change all uses.
	(octave_env::do_set_program_name): Call ::set_program_name
	function from gnulib.

2010-02-08  Jaroslav Hajek  <highegg@gmail.com>

	* idx-vector.h (idx_vector::idx_base_rep::sort_idx): New pure virtual
	function.
	(idx_vector::idx_colon_rep::sort_idx,
	idx_vector::idx_range_rep::sort_idx,
	idx_vector::idx_scalar_rep::sort_idx,
	idx_vector::idx_vector_rep::sort_idx,
	idx_vector::idx_mask_rep::sort_idx): New override decls.
	idx_vector::sort (Array<octave_idx_type>&): New method.
	* idx-vector.cc (idx_vector::idx_range_rep::sort_idx,
	idx_vector::idx_vector_rep::sort_idx): New methods.
	(idx_vector::idx_vector_rep::sort_uniq_clone): Rewrite
	to use bucket sort under plausible circumstances.

2010-02-08  Jaroslav Hajek  <highegg@gmail.com>

	* Array.cc (Array<T>::permute): Fix result dimensions when inv=true.

2010-02-05  Jaroslav Hajek  <highegg@gmail.com>

	* MArrayN.cc (MArrayN::idx_min, MArrayN::idx_max): New methods.
	* MArrayN.h: Declare them.
	* lo-mappers.h (xmin, xmax): Define for general arguments.

2010-02-04  Jaroslav Hajek  <highegg@gmail.com>

	* chMatrix.h (charMatrix): Rebase directly on Array<char>.
	* chNDArray.h (charNDArray): Ditto.
	* chMatrix.cc: Update.
	* chNDArray.cc: Update.
	* MArray-ch.cc: Remove.
	* Makefile.am: Update.

2010-02-04  John W. Eaton  <jwe@octave.org>

	* lo-cutils.c (gethostname): Delete function.
	* lo-sysdep.h (gethostname): Delete declaration.

2010-02-03  John W. Eaton  <jwe@octave.org>

	* oct-syscalls.h, oct-syscalls.cc (octave_fcntl): Assume fcntl exists.
	Rename from octave_syscalls::fcntl.
	(octave_syscalls::popen2): Call octave_fcntl, not fcntl.
	* cmd-hist.cc, lo-sysdep.cc, oct-syscalls.cc:
	Include <fcntl.h> unconditionally.

2010-02-03  John W. Eaton  <jwe@octave.org>

	* dbleSVD.cc (SVD::init): Ensure args to std::max are the same type.
	* CmplxSVD.cc (ComplexSVD::init): Likewise.
	* floatSVD.cc (FloatSVD::init): Likewise.
	* fCmplxSVD.cc (FloatComplexSVD::init): Likewise.
	* idx-vector.cc (idx_range_rep): Likewise.
	* Array.cc (Array<T>::nth_element): Likewise.

	* lo-specfun.cc (null_dims): Delete unused static variable.
	(betainc): Call dim_vector (0, 0), not dim_vector (0).

2010-02-03  John W. Eaton  <jwe@octave.org>

	* file-ops.h (octave_canonicalize_file_name): Rename from
	file_ops::canonicalize_file_name.

2010-02-03  John W. Eaton  <jwe@octave.org>

	* file-ops.cc (canonicalize_file_name):
	Don't pass current directory to octave_env::make_absolute.
	* cmd-edit.cc (do_decode_prompt_string): Likewise.

	* oct-env.h (octave_env::get_current_directory):
	Rename from octave_env::getcwd.
	(octave_env::make_absolute): Provide default value for second arg.

	* lo-sysdep.cc (octave_getcwd): Assume we are using gnulib
	getcwd module.

2010-02-02  John W. Eaton  <jwe@octave.org>

	* oct-time.h: Include <ctime>, not "systime.h".
	* oct-time.cc: Include <strftime.h>, not "strftime.h".
	Don't include <windows.h>.

	* systime.h: Delete.
	* Makefile.am (INCS): Remove it from the list.

2010-02-02  John W. Eaton  <jwe@octave.org>

	* lo-utils.h, lo-cutils.c (oct_strptime): Delete.
	* oct-time.cc (octave_strptime::init): Call strptime, not oct_strptime.

2010-01-28  Jaroslav Hajek  <highegg@gmail.com>

	* dMatrix.cc (Matrix::determinant): Treat matrices marked as singular
	normally.
	* fMatrix.cc (FloatMatrix::determinant): Ditto.
	* CMatrix.cc (ComplexMatrix::determinant): Ditto.
	* fCMatrix.cc (FloatComplexMatrix::determinant): Ditto.

2010-01-26  John W. Eaton  <jwe@octave.org>

	* file-ops.cc: Don't tag functions with OCTAVE_API in source file.

2010-01-26  John W. Eaton  <jwe@octave.org>

	* lo-cutils.c, lo-utils.h (octave_link, octave_symlink,
	octave_readlink, octave_mkdir, octave_mkfifo, octave_rmdir,
	octave_rename, octave_tempnam, octave_umask, octave_unlink):
	Delete.
	* file-io.h, file-io.cc (octave_mkdir,  octave_mkfifo,
	octave_link, octave_symlink, octave_readlink, octave_rename,
	octave_rmdir, octave_recursive_rmdir, octave_umask,
	octave_unlink, octave_tempnam): Rename from file_ops::X to
	octave_X.  Change all uses.
	(file_ops::static_members): Incorporate directly into file_ops class.

2010-01-23  John W. Eaton  <jwe@octave.org>

	* Makefile.am (LIBOCTAVE_C_SOURCES): Remove oct-getopt.c from the list.
	(LIBOCTAVE_CXX_SOURCES): Remove prog-args.c from the list.
	(INCS): Remove prog-args.h and oct-getopt.h from the list.
	* prog-args.cc, prog-args.h, oct-getopt.c, oct-getopt.h: Delete.

2010-01-22  John W. Eaton  <jwe@octave.org>

	* prog-args.h, prog-args.cc (prog_args::get_option,
	prog_args::option_argument, prog_args::option_index):
	Don't declare const.

2010-01-22  John W. Eaton  <jwe@octave.org>

	* prog-args.h, prog-args.cc (prog_args::get_option):
	Rename from getopt. Now const.
	(prog_args::option_argument): Rename from optarg.  Now const.
	(prog_args::option_index): Rename from optind.  Now const.

2010-01-22  John W. Eaton  <jwe@octave.org>

	* file-ops.cc: Don't include statdefs.h.

2010-01-22  Jaroslav Hajek  <highegg@gmail.com>

	* dbleSVD.cc (SVD::init): Ensure LD* arguments >= 1.
	* floatSVD.cc (FloatSVD::init): Likewise.
	* CmplxSVD.cc (ComplexSVD::init): Likewise.
	* fCmplxSVD.cc (FloatComplexSVD::init): Likewise.

2010-01-21  John W. Eaton  <jwe@octave.org>

	* CMatrix.cc, fCMatrix.cc, cmd-edit.cc, cmd-hist.cc,
	file-ops.cc, file-ops.h, file-stat.cc, file-stat.h, filemode.c,
	kpse.cc, lo-cutils.c, lo-sysdep.cc, lo-utils.cc, oct-env.cc,
	oct-group.cc, oct-group.h, oct-passwd.cc, oct-passwd.h,
	oct-time.cc, oct-syscalls.cc, oct-syscalls.h, statdefs.h,
	sysdir.h, syswait.h, tempname.c, regex-match.h:
	Assume sys/types.h and unistd.h are present (gnulib provides them).

2010-01-21  John W. Eaton  <jwe@octave.org>

	* file-ops.h, file-ops.cc, lo-utils.h, lo-cutils.c: Untabify.

	* file-ops.cc: Don't include unistd.h.
	(NOT_SUPPORTED): Delete unused macro.

2010-01-21  John W. Eaton  <jwe@octave.org>

	* lo-cutils.c (octave_tempnam): New funtion.
	* lo-utils.h: Provide decl.
	* file-ops.cc (file_ops::tempnam): Call octave_tempnam.

2010-01-21  John W. Eaton  <jwe@octave.org>

	* lo-cutils.c (octave_readlink): New funtion.
	* lo-utils.h: Provide decl.
	* file-ops.cc (file_ops::readlink): Call octave_readlink.

2010-01-21  John W. Eaton  <jwe@octave.org>

	* lo-cutils.c (octave_symlink): New funtion.
	* lo-utils.h: Provide decl.
	* file-ops.cc (file_ops::symlink): Call octave_symlink.

2010-01-21  John W. Eaton  <jwe@octave.org>

	* lo-cutils.c (octave_link): New funtion.
	* lo-utils.h: Provide decl.
	* file-ops.cc (file_ops::link): Call octave_link.

2010-01-21  John W. Eaton  <jwe@octave.org>

	* lo-cutils.c (octave_unlink): New funtion.
	* lo-utils.h: Provide decl.
	* file-ops.cc (file_ops::unlink): Call octave_unlink.

2010-01-21  John W. Eaton  <jwe@octave.org>

	* lo-cutils.c (octave_umask): New funtion.
	* lo-utils.h: Provide decl.
	* file-ops.cc (file_ops::umask): Call octave_umask.

2010-01-21  John W. Eaton  <jwe@octave.org>

	* file-ops.h (file_ops::mkdir): Move definitions to file-ops.cc.
	(file_ops::mkfifo): Move definitions to file-ops.cc.
	(file_ops::mkdir_internal, file_ops::mkfifo_internal): Delete decls.
	* file-ops.cc (file_ops::mkdir): Call octave_mkdir.
	(file_ops::mkfifo): Call octave_mkfifo.
	* lo-cutils.c (octave_mkdir, octave_mkfifo): New functions.
	* lo-utils.h: Provide decls.

2010-01-21  John W. Eaton  <jwe@octave.org>

	* Makefile.am (LIBOCTAVE_C_SOURCES): Remove strptime.c from the list.
	* strptime.c: Delete.

2010-01-21  John W. Eaton  <jwe@octave.org>

	* lo-cutils.c (octave_rename): New funtion.
	* lo-utils.h: Provide decl.
	* file-ops.cc (file_ops::rename): Call octave_rename.
	* Makefile.am (LIBOCTAVE_C_SOURCES): Remove rename.c from the list.
	* rename.c: Delete.

2010-01-21  John W. Eaton  <jwe@octave.org>

	* lo-cutils.c (octave_rmdir): New function.
	* lo-utils.h: Provide decl.
	* file-ops.cc (file_ops::rmdir): Call octave_rmdir.
	* Makefile.am (LIBOCTAVE_C_SOURCES): Remove rmdir.c from the list.
	* rmdir.c: Delete.

2010-01-21  John W. Eaton  <jwe@octave.org>

	* Makefile.am (LIBOCTAVE_C_SOURCES): Remove strcasecmp.c and
	strncase.c from the list.
	* strcasecmp.c, strncase.c: Delete.

2010-01-21  John W. Eaton  <jwe@octave.org>

	* Makefile.am (INCS): Remove getopt.h from the list.
	(LIBOCTAVE_C_SOURCES): Remove getopt.c and getopt1.c from the list.
	* getopt.c, getopt1.c, getopt.h: Delete.

2010-01-20  John W. Eaton  <jwe@octave.org>

	* Array-C.cc, Array-b.cc, Array-ch.cc, Array-d.cc, Array-f.cc,
	Array-fC.cc, Array-i.cc, Array-idx-vec.cc, Array-s.cc,
	Array-str.cc, Array-util.cc, Array-voidp.cc, Array.cc,
	CColVector.cc, CDiagMatrix.cc, CMatrix.cc, CNDArray.cc,
	CRowVector.cc, CSparse.cc, CmplxAEPBAL.cc, CmplxCHOL.cc,
	CmplxGEPBAL.cc, CmplxHESS.cc, CmplxLU.cc, CmplxQR.cc,
	CmplxQRP.cc, CmplxSCHUR.cc, CmplxSVD.cc, CollocWt.cc, DASPK.cc,
	DASRT.cc, DASSL.cc, DiagArray2.cc, EIG.cc, LSODE.cc,
	MArray-C.cc, MArray-ch.cc, MArray-d.cc, MArray-f.cc,
	MArray-fC.cc, MArray-i.cc, MArray-s.cc, MArray.cc, MArray2.cc,
	MArrayN.cc, MDiagArray2.cc, MSparse-C.cc, MSparse-d.cc,
	MSparse.cc, MatrixType.cc, ODES.cc, Quad.cc, Range.cc,
	Sparse-C.cc, Sparse-b.cc, Sparse-d.cc, Sparse.cc,
	SparseCmplxCHOL.cc, SparseCmplxLU.cc, SparseCmplxQR.cc,
	SparseQR.cc, SparsedbleCHOL.cc, SparsedbleLU.cc, base-lu.cc,
	boolMatrix.cc, boolNDArray.cc, boolSparse.cc, chMatrix.cc,
	chNDArray.cc, cmd-edit.cc, cmd-hist.cc, dColVector.cc,
	dDiagMatrix.cc, dMatrix.cc, dNDArray.cc, dRowVector.cc,
	dSparse.cc, data-conv.cc, dbleAEPBAL.cc, dbleCHOL.cc,
	dbleGEPBAL.cc, dbleHESS.cc, dbleLU.cc, dbleQR.cc, dbleQRP.cc,
	dbleSCHUR.cc, dbleSVD.cc, dir-ops.cc, eigs-base.cc,
	fCColVector.cc, fCDiagMatrix.cc, fCMatrix.cc, fCNDArray.cc,
	fCRowVector.cc, fCmplxAEPBAL.cc, fCmplxCHOL.cc, fCmplxGEPBAL.cc,
	fCmplxHESS.cc, fCmplxLU.cc, fCmplxQR.cc, fCmplxQRP.cc,
	fCmplxSCHUR.cc, fCmplxSVD.cc, fColVector.cc, fDiagMatrix.cc,
	fEIG.cc, fMatrix.cc, fNDArray.cc, fRowVector.cc, file-ops.cc,
	file-stat.cc, floatAEPBAL.cc, floatCHOL.cc, floatGEPBAL.cc,
	floatHESS.cc, floatLU.cc, floatQR.cc, floatQRP.cc,
	floatSCHUR.cc, floatSVD.cc, glob-match.cc, idx-vector.cc,
	int16NDArray.cc, int32NDArray.cc, int64NDArray.cc,
	int8NDArray.cc, intNDArray.cc, kpse.cc, lo-ieee.cc,
	lo-mappers.cc, lo-specfun.cc, lo-sysdep.cc, lo-utils.cc,
	mach-info.cc, mx-inlines.cc, oct-alloc.cc, oct-env.cc,
	oct-fftw.cc, oct-group.cc, oct-inttypes.cc, oct-md5.cc,
	oct-passwd.cc, oct-rand.cc, oct-shlib.cc, oct-sort.cc,
	oct-spparms.cc, oct-syscalls.cc, oct-time.cc, oct-uname.cc,
	pathsearch.cc, prog-args.cc, regex-match.cc,
	sparse-base-chol.cc, sparse-base-lu.cc, sparse-dmsolve.cc,
	sparse-sort.cc, sparse-util.cc, str-vec.cc, uint16NDArray.cc,
	uint32NDArray.cc, uint64NDArray.cc, uint8NDArray.cc,
	f2c-main.c, lo-cieee.c, lo-cutils.c, oct-getopt.c,
	oct-rl-edit.c, oct-rl-hist.c, randgamma.c, randmtzig.c,
	randpoisson.c, Array-util.h, Array.h, Array2.h, Array3.h,
	ArrayN.h, CColVector.h, CDiagMatrix.h, CMatrix.h, CNDArray.h,
	CRowVector.h, CSparse.h, CmplxAEPBAL.h, CmplxCHOL.h,
	CmplxGEPBAL.h, CmplxHESS.h, CmplxLU.h, CmplxQR.h, CmplxQRP.h,
	CmplxSCHUR.h, CmplxSVD.h, CollocWt.h, DAE.h, DAEFunc.h, DAERT.h,
	DAERTFunc.h, DASPK.h, DASRT.h, DASSL.h, DiagArray2.h, EIG.h,
	LSODE.h, MArray.h, MArray2.h, MArrayN.h, MDiagArray2.h,
	MSparse-defs.h, MSparse.h, Matrix.h, MatrixType.h, ODE.h,
	ODEFunc.h, ODES.h, ODESFunc.h, Quad.h, Range.h,
	Sparse-op-defs.h, Sparse.h, SparseCmplxCHOL.h, SparseCmplxLU.h,
	SparseCmplxQR.h, SparseQR.h, SparsedbleCHOL.h, SparsedbleLU.h,
	base-dae.h, base-de.h, base-lu.h, base-min.h, boolMatrix.h,
	boolNDArray.h, boolSparse.h, byte-swap.h, chMatrix.h,
	chNDArray.h, cmd-edit.h, cmd-hist.h, dColVector.h,
	dDiagMatrix.h, dMatrix.h, dNDArray.h, dRowVector.h, dSparse.h,
	data-conv.h, dbleAEPBAL.h, dbleCHOL.h, dbleGEPBAL.h, dbleHESS.h,
	dbleLU.h, dbleQR.h, dbleQRP.h, dbleSCHUR.h, dbleSVD.h,
	dir-ops.h, fCColVector.h, fCDiagMatrix.h, fCMatrix.h,
	fCNDArray.h, fCRowVector.h, fCmplxAEPBAL.h, fCmplxCHOL.h,
	fCmplxGEPBAL.h, fCmplxHESS.h, fCmplxLU.h, fCmplxQR.h,
	fCmplxQRP.h, fCmplxSCHUR.h, fCmplxSVD.h, fColVector.h,
	fDiagMatrix.h, fEIG.h, fMatrix.h, fNDArray.h, fRowVector.h,
	file-ops.h, file-stat.h, floatAEPBAL.h, floatCHOL.h,
	floatGEPBAL.h, floatHESS.h, floatLU.h, floatQR.h, floatQRP.h,
	floatSCHUR.h, floatSVD.h, functor.h, glob-match.h, idx-vector.h,
	int16NDArray.h, int32NDArray.h, int64NDArray.h, int8NDArray.h,
	intNDArray.h, kpse-xfns.h, lo-ieee.h, lo-mappers.h, lo-math.h,
	lo-specfun.h, lo-sysdep.h, lo-traits.h, lo-utils.h, mach-info.h,
	mx-base.h, mx-defs.h, mx-ext.h, mx-op-defs.h, oct-alloc.h,
	oct-cmplx.h, oct-env.h, oct-fftw.h, oct-getopt.h, oct-group.h,
	oct-inttypes.h, oct-md5.h, oct-passwd.h, oct-rand.h,
	oct-rl-edit.h, oct-rl-hist.h, oct-shlib.h, oct-sort.h,
	oct-spparms.h, oct-syscalls.h, oct-time.h, oct-uname.h,
	pathlen.h, pathsearch.h, prog-args.h, randgamma.h, randmtzig.h,
	randpoisson.h, regex-match.h, sparse-base-chol.h,
	sparse-base-lu.h, sparse-sort.h, sparse-util.h, statdefs.h,
	str-vec.h, sun-utils.h, sysdir.h, systime.h, syswait.h,
	uint16NDArray.h, uint32NDArray.h, uint64NDArray.h,
	uint8NDArray.h: Remove Emacs local-variables settings.

2010-01-20  Jaroslav Hajek  <highegg@gmail.com>

	* boolNDArray.cc (boolNDArray::cumsum): Sum directly in double to
	avoid a copy.

2010-01-20  John W. Eaton  <jwe@octave.org>

	* dim-vector.h: Style fixes.  Remove Emacs local variables block.
	Untabify.

2010-01-20  John W. Eaton  <jwe@octave.org>

	* Makefile.am (PRIVATE_INCS): New variable.  List oct-glob.h
	here instead of in INCS.
	(liboctave_la_SOURCES): Include $(PRIVATE_INCS) in the list.

	* glob-match.cc (glob_match::match, glob_match::glob): Now const.
	Move definitions here from glob-match.h.

2010-01-20  Jaroslav Hajek  <highegg@gmail.com>

	* mx-inlines.cc (mx_inline_any_r, mx_inline_all_r): New helper
	reductors.
	(mx_inline_any, mx_inline_all): Call the here in row-wise reduction
	with few enough columns.

2010-01-20  Jaroslav Hajek  <highegg@gmail.com>

	* lo-mappers.h (xmin (double, double), xmax (double, double),
	xmin (float, float), xmax (float, float)): Inline definitions.
	* lo-mappers.cc (xmin (double, double), xmax (double, double),
	xmin (float, float), xmax (float, float)): Remove from here.
	* mx-inlines.cc (mx_inline_xmin, mx_inline_xmax): Provide
	specializations for real array-scalar and scalar-array cases.

2010-01-20  Jaroslav Hajek  <highegg@gmail.com>

	* oct-norm.cc (norm_accumulator_p::accum, norm_accumulator_mp::accum):
	Call octave_quit here.
	(higham_subp): Also here.

2010-01-20  Jaroslav Hajek  <highegg@gmail.com>

	* mx-op-defs.h (SND_MINMAX_FCN, NDS_MINMAX_FCN, NDND_MINMAX_FCN):
	Simplify using mx_inlines machinery.
	* dNDArray (min, max): Simplify.
	* fNDArray (min, max): Simplify.
	* CNDArray (min, max): Simplify.
	* fCNDArray (min, max): Simplify.

2010-01-20  Jaroslav Hajek  <highegg@gmail.com>

	* Array.h: Substitute OCTAVE_QUIT -> octave_quit ().
	* CMatrix.cc: Ditto.
	* CNDArray.cc: Ditto.
	* CSparse.cc: Ditto.
	* CmplxGEPBAL.cc: Ditto.
	* MArrayN.cc: Ditto.
	* MSparse.cc: Ditto.
	* Sparse-diag-op-defs.h: Ditto.
	* Sparse-op-defs.h: Ditto.
	* Sparse-perm-op-defs.h: Ditto.
	* Sparse.cc: Ditto.
	* Sparse.h: Ditto.
	* SparseCmplxQR.cc: Ditto.
	* SparseQR.cc: Ditto.
	* boolSparse.cc: Ditto.
	* bsxfun-defs.cc: Ditto.
	* dMatrix.cc: Ditto.
	* dNDArray.cc: Ditto.
	* dSparse.cc: Ditto.
	* dbleGEPBAL.cc: Ditto.
	* fCMatrix.cc: Ditto.
	* fCNDArray.cc: Ditto.
	* fCmplxGEPBAL.cc: Ditto.
	* fMatrix.cc: Ditto.
	* fNDArray.cc: Ditto.
	* file-ops.cc: Ditto.
	* floatGEPBAL.cc: Ditto.
	* lo-utils.cc: Ditto.
	* mx-op-defs.h: Ditto.
	* oct-fftw.cc: Ditto.
	* oct-norm.cc: Ditto.
	* oct-rand.cc: Ditto.
	* sparse-dmsolve.cc: Ditto.

2010-01-20  Jaroslav Hajek  <highegg@gmail.com>

	* bsxfun-defs.cc (BSXFUN_STDOP_DEFS_MXLOOP): Fix reversed min/max
	defs.

2010-01-20  John W. Eaton  <jwe@octave.org>

	* glob-match.h: Update copyright.

2010-01-20  John W. Eaton  <jwe@octave.org>

	* Makefile.am (INCS): Include oct-glob.h in the list.
	(LIBOCTAVE_CXX_SOURCES): Include oct-glob.cc in the list.
	* oct-glob.h, oct-glob.cc: New files.
	* glob-match.cc: (glob_match::match): Move internals to oct-glob.cc.
	(glob_match::glob_internal): Move internals to oct-glob.cc.
	(single_match_exists): Move to oct-glob.cc.
	(glob_match::opts_to_fnmatch_flags): New function.
	* glob-match.h Include oct-glob.h.
	(glob_match::glob): Call octave_glob to do the real work.
	(glob_match::glob_internal): Delete decl.
	(glob_match::match (const string_vector&)): Move here from
	glob-match.cc.
	(glob_match::match (const std::string&)): Call octave_fnmatch to
	do the real work.
	(glob_match::fnmatch_flags): Rename from flags.
	(glob_match::opts_to_fnmatch_flags): New function.
	(glob_match::glob_match): Use it.

2010-01-17  Jaroslav Hajek  <highegg@gmail.com>

	* CMatrix.cc (xgemm): Use octave_idx_type rather than int.
	* fCMatrix.cc (xgemm): Ditto.

2010-01-16  Michael Goffioul  <michael.goffioul@gmail.com>

	* oct-time.cc: Avoid to include nonneeded headers from Win32 API,
	especially winsock.h. Include <sys/time.h> unconditionally, as it is
	now provided by gnulib, in order to get gettimeofday defined.

2010-01-15  Jaroslav Hajek  <highegg@gmail.com>

	* Array.cc (Array<T>::insert): Rewrite using assign.
	(Array<T>::insert2, Array<T>::insertN): Remove.
	* Array.h: Update declarations. Add brief documentation.

2010-01-15  Jaroslav Hajek  <highegg@gmail.com>

	* Array-b.cc: Inline ascending and descending sort.
	(do_bool_partition): New helper template function.
	(octave_sort<bool>::sort): Provide specializations.

2010-01-14  Jaroslav Hajek  <highegg@gmail.com>

	* Array.cc (Array<T>::insert (const Array<T>&, const
	Array<octave_idx_type>&): Allow less dimensions than indices.

2010-01-14  Jaroslav Hajek  <highegg@gmail.com>

	* chNDArray.h: Declare relational bsxfun ops.
	* chNDArray.cc: Define them.

2010-01-14  John W. Eaton  <jwe@octave.org>

	* CMatrix.cc: Fix prototype for zherk.
	* fCMatrix.cc: Fix prototype for cherk.

2010-01-14  John W. Eaton  <jwe@octave.org>

	* oct-rl-edit.c (octave_rl_set_name): Save arg before setting
	rl_terminal_name.

2010-01-13  John W. Eaton  <jwe@octave.org>

	* idx-vector.cc (idx_vector::idx_scalar_rep::idx_scalar_rep (T x)):
	Initialize dummy variable.

2010-01-13  Jaroslav Hajek  <highegg@gmail.com>

	* Array.cc (Array<T>::compute_index): Generalize to the case of
	unequal lengths.

2010-01-13  Jaroslav Hajek  <highegg@gmail.com>

	* dim-vector.h (dim_vector::chop_trailing_singletons): Only uniquify
	if really needed.
	* Array.h (Array<T>::Array (T*, const dim_vector&)): Call
	chop_trailing_singletons.
	(Array<T>::Array (const Array<T>&, const dim_vector&,
	octave_idx_type...)): Ditto.
	(Array<T>::Array (const dim_vector&)): Ditto.
	(Array<T>::Array (const dim_vector&, const T&)): Ditto.
	(Array<T>::chop_trailing_singletons): Deprecate.
	* Array.cc (Array::Array(const Array&, const dim_vector&)): Ditto.
	(Array::index (const Array<idx_vector>&, ...)): Ditto.
	(Array<T>::permute): Don't call deprecate method here.
	(Array<T>::assign): Neither here.

2010-01-11  Rik  <octave@nomad.inbox5.com>

	* Makefile.am: Remove unnecessary use of
	simple_move_if_change_rule to allow Make to update timestamps.

2010-01-08  Jaroslav Hajek  <highegg@gmail.com>

	* Array.h (Array<T>::crefT): New helper typedef.
	(Array<T>::elem const, Array<T>::xelem const,
	Array<T>::checkelem const, Array<T>::operator () const): Return crefT.
	(Array<T>::range_error const): Remove overloads.
	* Array.cc (Array<T>::range_error const): Remove overloads.

2010-01-07  John W. Eaton  <jwe@octave.org>

	* oct-time.cc (octave_time::stamp): Assume gettimeofday is
	available and that it takes two arguments.

2010-01-07  Jaroslav Hajek  <highegg@gmail.com>

	* lo-utils.cc (octave_fgets (FILE *, bool&)): Add OCTAVE_QUIT at the
	end.

2010-01-05  John W. Eaton  <jwe@octave.org>

	* Makefile.am (AM_CPPFLAGS): Include @CPPFLAGS@ and -I../libgnu
	in the list.

2009-12-30  Jaroslav Hajek  <highegg@gmail.com>

	* idx-vector.cc (idx_vector::maybe_reduce): Implement reduction rule
	for subsequent ones () indices.

2009-12-28  John W. Eaton  <jwe@octave.org>

	* file-ops.cc (fle_ops::mkdir_internal,
	file_ops::mkfifo_internal): New private static functions.
	* file-ops.h (file_ops::mkdir, file_ops::mkdir): Move
	definitions here from file-ops.cc.  Forward to X_internal functions.

2009-12-26  John W. Eaton  <jwe@octave.org>

	* file-stat.cc (lstat): Delete replacement function.
	(file_fstat::update_internal): Assume fstat is available.

2009-12-25  John W. Eaton  <jwe@octave.org>

	* file-ops.cc (file_ops::mkdir): Assume we have an mkdir
	function that takes two arguments.
	* mkdir.c: Delete.
	* Makefile.am (LIBOCTAVE_C_SOURCES): Remove mkdir.c from the list.

2009-12-25  John W. Eaton  <jwe@octave.org>

	* oct-md5.cc (oct_md5_result_to_str): New function.
	(oct_md5, oct_md5_file): Simplify using gnulib md5 functions and
	oct_md5_result_to_str.

	* Makefile.am (INCS): Remove md5.h from the list.
	(LIBOCTAVE_C_SOURCES): Remove md5.c from the list.
	* md5.c, md5.h: Delete.

2009-12-19  Rik  <octave@nomad.inbox5.com>

	* Makefile.am: Eliminate TOPDIR variable in favor of built-in
	automake variables of top_builddir and top_srcdir.

2009-12-17  John W. Eaton  <jwe@octave.org>

	* glob-match.h, glob-match.cc (glob_match::glob_internal):
	Rename from glob_match::glob and make private.
	* glob-match.h (glob_match::glob): Forward to glob_internal.

2009-12-15  Jaroslav Hajek  <highegg@gmail.com>

	* Array.cc (Array<T>::index (const idx_vector&)): Fix determining of
	result dimensions.

2009-12-15  Jaroslav Hajek  <highegg@gmail.com>

	* Range.cc (Range::elem, Range::checkelem, Range::index):
	New methods.
	* Range.h: Declare them.

2009-12-15  Jaroslav Hajek  <highegg@gmail.com>

	* idx-vector.h (idx_vector::loop, idx_vector::bloop): Fix behavior for
	masks.

2009-12-13  Rik  <octave@nomad.inbox5.com>

	* Makefile.am: Use DISTCLEANFILES rather than distclean-local rule.
	Use PERL variable defined by autoconf rather than direct call.
	Use simple_move_if_change rule to reduce useless compiles if
	OPTS_INC have not changed.

2009-12-12  Jaroslav Hajek  <highegg@gmail.com>

	* oct-shlib.h: Remove stray declarations.

2009-12-11  John W. Eaton  <jwe@octave.org>

	* oct-shlib.cc (octave_dlopen_shlib::octave_dlopen_shlib):
	Print filename along with message from dlerror.
	Reverse sense of test.

2009-12-09  Jaroslav Hajek  <highegg@gmail.com>

	* oct-shlib.h (octave_shlib): Rewrite.
	* oct-shlib.cc (octave_shlib): Rewrite.

2009-12-09  John W. Eaton  <jwe@octave.org>

	* oct-time.cc (octave_base_tm::strftime): Call nstrftime instead
	of my_strftime.

2009-12-09  John W. Eaton  <jwe@octave.org>

	* oct-time.cc: Include strftime.h.  Don't provide decl for strftime.
	(octave_base_tm::strftime): Call my_strftime instead of ::strftime.
	* Makefile.am (AM_CPPFLAGS): Add -I$(top_srcdir)/libgnu to the list.
	(LINK_DEPS): Add ../libgnu/libgnu.la to the list.
	(LIBOCTAVE_C_SOURCES): Remove strftime.c from the list.
	* strftime.c: Delete.

2009-12-08  Michael Goffioul  <michael.goffioul@gmail.com>

	* Array-d.cc (Array<double>::is_sorted): Declare as OCTAVE_API.
	* Array-f.cc (Array<float>::is_sorted): Ditto.
	* lo-sysdep.cc: Undef min and max after including windows.h

2009-12-05  Jaroslav Hajek  <highegg@gmail.com>

	* Array-d.cc (Array<double>::is_sorted): Optimized specialization.
	* Array-f.cc (Array<float>::is_sorted): Ditto.

2009-12-05  Jaroslav Hajek  <highegg@gmail.com>

	* oct-sort.cc (lookup_binary): Remove.
	(octave_sort<T>::lookup (const T*, octave_idx_type, const T&, comp)):
	Move code here.
	(octave_sort<T>::lookup (const T*, octave_idx_type, const T*,
	octave_idx_type, octave_idx_type *, comp)): Remove offset parameter.
	Use a simple sequence of lookups.
	(octave_sort<T>::lookup (const T*, octave_idx_type, const T*,
	octave_idx_type, octave_idx_type *)): Update.
	(octave_sort<T>::lookupm, octave_sort<T>::lookupb): Remove.
	(octave_sort<T>::lookup_sorted): New overloaded method.

	* Array.cc (Array<T>::lookup (const Array<T>&, sortmode)): Remove
	linf & rinf params. Rewrite using is_sorted to check for sortedness,
	call octave_sort::lookup_sorted to do the sorted merge.
	(Array<T>::lookupm, Array<T>::lookupb): Remove.
	(NO_INSTANTIATE_ARRAY_SORT): Update.

2009-12-05  Jaroslav Hajek  <highegg@gmail.com>

	* Array.cc (sortrows_comparator): Rename to safe_comparator.
	(Array<T>::is_sorted): Use it here.
	* Array-d.cc: Update.
	* Array-f.cc: Update.
	* Array-C.cc: Update.
	* Array-fC.cc: Update.

2009-12-03  John W. Eaton  <jwe@octave.org>

	* Makefile.am (BUILT_NODISTFILES): New variable.

2009-12-01  Jaroslav Hajek  <highegg@gmail.com>

	* idx-vector.cc (idx_vector::idx_range_rep::unconvert,
	idx_vector::idx_scalar_rep::unconvert,
	idx_vector::idx_vector_rep::unconvert,
	idx_vector::idx_mask_rep::unconvert): New methods.
	(idx_vector::unconvert): Use them here. Add mask output.
	* idx-vector.h: Update decls.

2009-11-28  Jaroslav Hajek  <highegg@gmail.com>

	* dim-vector.h (dim_vector::zero_by_zero): New method.
	* idx-vector.h (idx_vector::idx_mask_rep::is_colon_equiv): Fix.
	* Array.cc (Array<T>::assign): Minor tweaks. Optimize
	A = []; A(1:m,1:n,1:k) = X for all cases. Use a shallow copy
	for all colon-equivalent indices.

2009-11-27  Jaroslav Hajek  <highegg@gmail.com>

	* idx-vector.h (idx_vector::index_class): New member: class_mask.
	(idx_vector::idx_mask_rep): New class.
	(idx_vector::idx_vector (bool)): Construct idx_mask_rep.
	(idx_vector::unmask): New method decl.
	* idx-vector.cc (idx_vector::idx_vector (const boolNDArray&)):
	Construct idx_mask_rep conditionally.
	(idx_vector::unmask): New method.
	(idx_vector::unconvert): Make non-const. unmask when called on a mask
	vector.
	(idx_vector::is_cont_range): Check also for idx_mask_rep.

2009-11-27  Jaroslav Hajek  <highegg@gmail.com>

	* Array.cc (Array<T>::nnz): New method.
	* Array.h: Declare it.
	* MArray.h (MArray<T>::nnz): Remove.
	* MArrayN.h (MArrayN<T>::nnz): Remove.
	* boolNDArray.h (boolNDArray::nnz): Remove.

2009-11-25  Jaroslav Hajek  <highegg@gmail.com>

	* dbleCHOL.cc (CHOL::init): Output LAPACK's info. Resize matrix if
	nonzero. Use smarter copying.
	* floatCHOL.cc (FloatCHOL::init): Ditto.
	* CmplxCHOL.cc (ComplexCHOL::init): Ditto.
	* fCmplxCHOL.cc (FloatComplexCHOL::init): Ditto.

2009-11-24  Jaroslav Hajek  <highegg@gmail.com>

	* MArrayN.cc (MArrayN::idx_add): New methods.
	* MArrayN.h: Declare them.
	* MArray.cc, MArray.h: Remove from here.

2009-11-19  Jaroslav Hajek  <highegg@gmail.com>

	* dim-vector.h (dim_vector::safe_numel): New method.
	* Array.h (Array<T>::Array (const dim_vector&),
	Array<T>::Array (const dim_vector&, const T&),
	Array<T>::Array (T *, const dim_vector&)): Use it here.
	* Array.cc (Array<T>::clear (const dim_vector&)): Also here.
	(Array<T>::get_size): Remove.
	* Array2.h (Array2::get_size): Remove.
	* Array3.h (Array3::get_size): Remove.

2009-11-19  Jaroslav Hajek  <highegg@gmail.com>

	* Array.cc (Array::clear (const dim_vector&)): Use get_size.

2009-11-19  Jaroslav Hajek  <highegg@gmail.com>

	* lo-mappers.cc (do_erfinv): New static function.
	(erfinv (double), erfinv (float)): New mappers.
	* lo-mappers.h: Declare them.

2009-11-18  David Grundberg  <davidg@cs.umu.se>

       * str-vec.cc (string_vector::list_in_columns): Avoid crash on
       empty arguments from list_in_columns.

2009-11-18  Jaroslav Hajek  <highegg@gmail.com>

	* Sparse.h (read_sparse_matrix): Fix order of tests and reads.

2009-11-18  Jaroslav Hajek  <highegg@gmail.com>

	* mx-inlines.cc (mx_inline_any_negative, mx_inline_pow): New loops.
	(DEFMXMAPPER2X): New macro.
	* bsxfun-decl.h (BSXFUN_OP2_DECL): New macro.
	* bsxfun-defs.cc (BSXFUN_OP2_DEF, BSXFUN_OP2_DEF_MXLOOP): New macros.
	(do_bsxfun_op): Use OCTAVE_QUIT.
	* dNDArray.cc (NDArray::all_integers (void)): New method.
	(NDArray::any_element_is_negative): Use mx_inline_any_negative.
	(bsxfun_pow (const NDArray&, const NDArray&),
	bsxfun_pow (const ComplexNDArray&, const NDArray&)): New functions.
	* dNDArray.h: Update.
	* fNDArray.cc (FloatNDArray::all_integers (void)): New method.
	(FloatNDArray::any_element_is_negative): Use mx_inline_any_negative.
	(bsxfun_pow (const FloatNDArray&, const FloatNDArray&),
	bsxfun_pow (const FloatComplexNDArray&, const FloatNDArray&)):
	New functions.
	* fNDArray.h: Update.
	* CNDArray.cc (bsxfun_pow (const ComplexNDArray&, const
	ComplexNDArray&)): New function.
	* CNDArray.h: Update.
	* fCNDArray.cc (bsxfun_pow (const FloatComplexNDArray&, const
	FloatComplexNDArray&)): New function.
	* fCNDArray.h: Update.

2009-11-13  Jaroslav Hajek  <highegg@gmail.com>

	* CNDArray.cc (ComplexNDArray::all_elements_are_real):
	Use mx_inline_all_real.
	* CMatrix.cc (ComplexMatrix::all_elements_are_real): Ditto.
	* fCNDArray.cc (FloatComplexNDArray::all_elements_are_real):
	Use mx_inline_all_real.
	* fCMatrix.cc (FloatComplexMatrix::all_elements_are_real): Ditto.
	* CDiagMatrix.cc (ComplexDiagMatrix::all_elements_are_real): Ditto.
	* fCDiagMatrix.cc (FloatComplexDiagMatrix::all_elements_are_real):
	Ditto.
	* CSparse.cc (SparseComplexMatrix::all_elements_are_real): Ditto.

2009-11-17  Jaroslav Hajek  <highegg@gmail.com>

	* base-aepbal.h (permuting_vector): Fix lower part swapping.

2009-11-13  John W. Eaton  <jwe@octave.org>

	* Makefile.am (liboctave_la_CPPFLAGS): Add @OCTAVE_DLL_DEFS@ to
	the list of flags.

2009-11-13  Jaroslav Hajek  <highegg@gmail.com>

	* mx-inlines.cc (mx_inline_any_nan): Rewrite.
	(mx_inline_all_real): New reduction loop.

2009-11-12  Jaroslav Hajek  <highegg@gmail.com>

	* lo-mappers.cc ( rc_acos, rc_acos, rc_acosh, rc_acosh, rc_asin,
	rc_asin, rc_atanh, rc_atanh, rc_log, rc_log, rc_xlog2, rc_log2,
	rc_log10, rc_log10, rc_sqrt, rc_sqrt): New mappers.
	* lo-mappers.h: Declare them.

	* lo-specfun.cc (rc_lgamma, rc_lgamma, rc_log1p, rc_log1p): New
	mappers.
	* lo-specfun.h: Declare them.
	* Array.h (Array<T>::map): Unroll loop to reduce OCTAVE_QUIT checking.
	Provide function-reference overloads.

	* MArray.h (MArray<T>::map): Provide function-reference overloads.
	* Array2.h (Array2<T>::map): Ditto.
	* MArray2.h (MArray2<T>::map): Ditto.

	* Sparse.h (Sparse<T>::map): Ditto.
	* MSparse.h (MSparse<T>::map): Ditto.

	* dNDArray.h (NDArray::map): Remove.
	* dNDArray.cc (NDArray::map): Remove.
	* fNDArray.h (FloatNDArray::map): Remove.
	* fNDArray.cc (FloatNDArray::map): Remove.
	* CNDArray.h (ComplexNDArray::map): Remove.
	* CNDArray.cc (ComplexNDArray::map): Remove.
	* fCNDArray.h (FloatComplexNDArray::map): Remove.
	* fCNDArray.cc (FloatComplexNDArray::map): Remove.

	* dMatrix.h (Matrix::map): Remove.
	* dMatrix.cc (Matrix::map): Remove.
	* fMatrix.h (FloatMatrix::map): Remove.
	* fMatrix.cc (FloatMatrix::map): Remove.
	* CMatrix.h (ComplexMatrix::map): Remove.
	* CMatrix.cc (ComplexMatrix::map): Remove.
	* fCMatrix.h (FloatComplexMatrix::map): Remove.
	* fCMatrix.cc (FloatComplexMatrix::map): Remove.

	* dRowVector.h (RowVector::map): Remove.
	* dRowVector.cc (RowVector::map): Remove.
	* fRowVector.h (FloatRowVector::map): Remove.
	* fRowVector.cc (FloatRowVector::map): Remove.
	* CRowVector.h (ComplexRowVector::map): Remove.
	* CRowVector.cc (ComplexRowVector::map): Remove.
	* fCRowVector.h (FloatComplexRowVector::map): Remove.
	* fCRowVector.cc (FloatComplexRowVector::map): Remove.

	* dColVector.h (ColumnVector::map): Remove.
	* dColVector.cc (ColumnVector::map): Remove.
	* fColVector.h (FloatColumnVector::map): Remove.
	* fColVector.cc (FloatColumnVector::map): Remove.
	* CColVector.h (ComplexColumnVector::map): Remove.
	* CColVector.cc (ComplexColumnVector::map): Remove.
	* fCColVector.h (FloatComplexColumnVector::map): Remove.
	* fCColVector.cc (FloatComplexColumnVector::map): Remove.

	* dSparse.h (SparseMatrix::map): Remove.
	* dSparse.cc (SparseMatrix::map): Remove.
	* CSparse.h (SparseComplexMatrix::map): Remove.
	* CSparse.cc (SparseComplexMatrix::map): Remove.

2009-11-11  John W. Eaton  <jwe@octave.org>

	* lo-ieee.cc (octave_ieee_init): Improve comment about systems
	without IEEE floating point format.

2009-11-11  Jaroslav Hajek  <highegg@gmail.com>

	* mx-inlines.cc (mx_inline_map): New template loop.
	(DEFMXMAPPER): New macro.
	(DEFMXMAPPER2): Rename from DEFMXMAPPER.
	(do_mx_unary_map): New applier.
	(mx_inline_real, mx_inline_complex): New loops.
	* dNDArray.cc (NDArray::abs, NDArray::isnan, NDArray::isinf,
	NDArray::isfinite, real, imag): Use new constructs.
	* fNDArray.cc (FloatNDArray::abs, FloatNDArray::isnan,
	FloatNDArray::isinf, FloatNDArray::isfinite, real, imag): Ditto.
	* CNDArray.cc (ComplexNDArray::abs, ComplexNDArray::isnan,
	ComplexNDArray::isinf, ComplexNDArray::isfinite, conj): Use new
	constructs.
	* fCNDArray.cc (FloatComplexNDArray::abs, FloatComplexNDArray::isnan,
	FloatComplexNDArray::isinf, FloatComplexNDArray::isfinite, conj): Use
	new constructs.

2009-11-10  John W. Eaton  <jwe@octave.org>

	* mx-ops, sparse-mx-ops, vx-ops, vx-ops:
	Add comment about updating.
	* Makefile.am, config-ops.sh: New files.
	* Makefile.in: Delete.

2009-11-09  Jaroslav Hajek  <highegg@gmail.com>

	* dSparse.h (Sparse::max): Use Array<octave_idx_type>.
	* dSparse.cc: Update.
	* CSparse.h (Sparse::max): Use Array<octave_idx_type>.
	* CSparse.cc: Update.
	* dNDArray.h (NDArray::max, NDArray::min, NDArray::cummax,
	NDArray::cummin, NDArray::diff): Use dim = -1 as default.
	* fNDArray.h (FloatNDArray::max, FloatNDArray::min, FloatNDArray::cummax,
	FloatNDArray::cummin, FloatNDArray::diff): Use dim = -1 as default.
	* CNDArray.h (ComplexNDArray::max, ComplexNDArray::min,
	ComplexNDArray::cummax, ComplexNDArray::cummin, ComplexNDArray::diff):
	Use dim = -1 as default.
	* fCNDArray.h (FloatComplexNDArray::max, FloatComplexNDArray::min,
	FloatComplexNDArray::cummax, FloatComplexNDArray::cummin,
	FloatComplexNDArray::diff): Use dim = -1 as default.
	* intNDArray.h (intNDArray::max, intNDArray::min, intNDArray::cummax,
	intNDArray::cummin, intNDArray::diff): Use dim = -1 as default.

2009-11-03  Jaroslav Hajek  <highegg@gmail.com>

	* oct-mem.h: Rename octave_ucopy -> copy_or_memcpy,
	octave_fill -> fill_or_memset, octave_new -> no_ctor_new,
	octave_delete -> no_ctor_delete.
	* Array.h: Update.
	* Array.cc: Update.
	* idx-vector.h: Update.
	* idx-vector.cc: Update.

2009-11-03  Jaroslav Hajek  <highegg@gmail.com>

	* oct-mem.h: New source.
	* Makefile.in: Include it.
	* Array.h (Array<T>::ArrayRep::ArrayRep (...)): Use octave_new,
	octave_ucopy and octave_fill.
	(Array<T>::ArrayRep::~ArrayRep): Use octave_delete.
	(Array<T>::coerce): Use octave_new.
	* Array.cc (Array<T>::fill, rec_resize_helper::do_resize_fill,
	Array<T>::resize_fill, rec_permute_helper::do_permute,
	Array<T>::delete_elements): Use octave_ucopy and octave_fill.
	* idx-vector.h (index_vector::index, index_vector::assign): Use
	octave_ucopy.
	* idx-vector.cc (index_vector::copy_data): Ditto.

2009-11-03  Jaroslav Hajek  <highegg@gmail.com>

	* idx-vector.cc (idx_vector::maybe_reduce): Implement (i:k:end, :)
	and (i:k:end, p:q) reductions.

2009-11-02  Jaroslav Hajek  <highegg@gmail.com>

	* mx-inlines.cc (twosum_accum): Remove FLOAT_TRUNCATE.

2009-10-28  John W. Eaton  <jwe@octave.org>

	* PermMatrix.cc: Don't include error.h.

2009-10-27  David Bateman  <dbateman@free.fr>

	* SparsedbleLU.cc (SparseLU::SparseLU (const SparseMatrix&,
	const Matrix&, bool), SparseLU::SparseLU (const SparseMatrix&,
	const ColumnVector&, const Matrix&, boo, bool, double, bool,
	bool)): Fix test for valid pivot tolerance.
	* SparseCmplxLU.cc (SparseComplexLU::SparseComplexLU
	(const SparseComplexMatrix&, const Matrix&, bool),
	SparseComplexLU::SparseComplexLU (const SparseComplexMatrix&,
	const ColumnVector&, const Matrix&, boo, bool, double, bool,
	bool)): Ditto.

2009-10-23  Jaroslav Hajek  <highegg@gmail.com>

	* idx-vector.cc (idx_vector::idx_range_rep::idx_range_rep
	(octave_idx_type, octave_idx_type, octave_idx_type)):
	Improve checking.

2009-10-21  John W. Eaton  <jwe@octave.org>

	* oct-time.h 	(octave_time::octave_time (time_t t, int us)):
	New constructor.
	(operator + (const octave_time&, const octave_time&)): New function.

	* file-stat.h (base_file_stat::time_resolution): New function.

2009-10-20  Jaroslav Hajek  <highegg@gmail.com>

	* bsxfun-decl.h, bsxfun-defs.cc: New sources.
	* Makefile.in: Add them.
	* dim-vector.h (dim_vector::compute_index,
	dim_vector::increment_index): Fix.
	* mx-inlines.cc (DEFMXMAPPER, DEFMXLOCALMAPPER): New macros.
	(mx_inline_xmin, mx_inline_xmax): New loops.
	(mx_inline_fun): Remove.
	* oct-inttypes.h (xmin (const octave_int<T>&, const octave_int<T>&),
	xmax (const octave_int<T>&, const octave_int<T>&)):
	New inline functions.

	* CNDArray.cc: Define bsxfun operations.
	* boolNDArray.cc: Ditto.
	* dNDArray.cc: Ditto.
	* fCNDArray.cc: Ditto.
	* fNDArray.cc: Ditto.
	* int16NDArray.cc: Ditto.
	* int32NDArray.cc: Ditto.
	* int64NDArray.cc: Ditto.
	* int8NDArray.cc: Ditto.
	* uint16NDArray.cc: Ditto.
	* uint32NDArray.cc: Ditto.
	* uint64NDArray.cc: Ditto.
	* uint8NDArray.cc: Ditto.

	* CNDArray.h: Declare bsxfun operations.
	* boolNDArray.h: Ditto.
	* dNDArray.h: Ditto.
	* fCNDArray.h: Ditto.
	* fNDArray.h: Ditto.
	* int16NDArray.h: Ditto.
	* int32NDArray.h: Ditto.
	* int64NDArray.h: Ditto.
	* int8NDArray.h: Ditto.
	* uint16NDArray.h: Ditto.
	* uint32NDArray.h: Ditto.
	* uint64NDArray.h: Ditto.
	* uint8NDArray.h: Ditto.

2009-10-19  Jaroslav Hajek  <highegg@gmail.com>

	* dim-vector.h (dim_vector::compute_index,
	dim_vector::increment_index, dim_vector::cumulative,
	dim_vector::cum_compute_index): New methods.

2009-10-18  Carsten Clark  <tantumquantum+gnuoctave@gmail.com>

	* Makefile.in: Remove ArrayN.cc.

2009-10-18  Jaroslav Hajek  <highegg@gmail.com>

	* Makefile.in: Include base-qr.h and base-qr.cc.

2009-10-17  Jaroslav Hajek  <highegg@gmail.com>

	* dbleQR.cc: Initialize QR::raw, QR::economy and QR::std.

2009-10-16  Jaroslav Hajek  <highegg@gmail.com>

	* ArrayN.h: Remove everything, just #define ArrayN Array.
	Warn if under gcc.
	* ArrayN.cc: Remove.
	* Array.cc (operator >>): New operator.
	* Array.h: Declare it.

	* Array-C.cc: Remove traces of ArrayN.
	* Array-b.cc: Ditto.
	* Array-ch.cc: Ditto.
	* Array-d.cc: Ditto.
	* Array-f.cc: Ditto.
	* Array-fC.cc: Ditto.
	* CNDArray.cc: Ditto.
	* CNDArray.h: Ditto.
	* MArrayN.h: Ditto.
	* boolNDArray.cc: Ditto.
	* boolNDArray.h: Ditto.
	* chNDArray.h: Ditto.
	* dNDArray.cc: Ditto.
	* dNDArray.h: Ditto.
	* fCNDArray.cc: Ditto.
	* fCNDArray.h: Ditto.
	* fNDArray.cc: Ditto.
	* fNDArray.h: Ditto.
	* intNDArray.cc: Ditto.
	* intNDArray.h: Ditto.
	* lo-specfun.cc: Ditto.
	* lo-specfun.h: Ditto.

	* mx-op-defs.h (DMS_BIN_OP, SDM_BIN_OP): Rewrite.
	(DMS_BIN_OPS, SDM_BIN_OPS): Define dm*s and dm/s rather than dm+s and
	dm-s which are rather useless.
	* mx-ops: Update.

2009-10-16  Jaroslav Hajek  <highegg@gmail.com>

	* Array.cc (Array<T>::column, Array<T>::page, Array<T>::linearize,
	Array<T>::linear_slice): New methods.
	* Array.h: Declare them
	* ArrayN.h: Forward them.

2009-10-14  Jaroslav Hajek  <highegg@gmail.com>

	* oct-sort.cc (octave_sort<T>::nth_element): New overloaded method.
	* oct-sort.h: Declare it.
	* Array.cc (Array<T>::nth_element): New method.
	* Array.h: Declare it.
	(Array<T>::sort): Use int for dim argument.
	* ArrayN.h (ArrayN<T>::nth_element): Wrap.
	(ArrayN<T>::sort): Use int for dim argument.

2009-10-13  Jaroslav Hajek  <highegg@gmail.com>

	* lo-traits.h (equal_types, is_instance, subst_template_param): New
	traits classes.
	* mx-inlines.cc (op_dble_sum, twosum_accum): New helper funcs.
	(mx_inline_dsum, mx_inline_xsum): New reduction loops.
	* fNDArray.cc (FloatNDArray::dsum): New method.
	* fNDArray.h: Declare it.
	* fCNDArray.cc (FloatComplexNDArray::dsum): New method.
	* fCNDArray.h: Declare it.
	* dNDArray.cc (NDArray::xsum): New method.
	* dNDArray.h: Declare it.
	* CNDArray.cc (ComplexNDArray::xsum): New method.
	* CNDArray.h: Declare it.
	* intNDArray.cc (intNDArray::dsum): New method.
	* intNDArray.h: Declare it.

2009-10-12  Jaroslav Hajek  <highegg@gmail.com>

	* base-qr.cc (base_qr::regular): New method.
	* base-qr.h: Declare it.
	* base-lu.cc (base_lu::regular): New method.
	* base-lu.h: Declare it.

2009-10-12  Jaroslav Hajek  <highegg@gmail.com>

	* base-qr.h: New source.
	* base-qr.cc: New source.
	* dbleQR.h (QR): Rebase on base_qr<Matrix>.
	* dbleQR.cc: Ditto.
	* floatQR.h (QR): Rebase on base_qr<FloatMatrix>.
	* floatQR.cc: Ditto.
	* CmplxQR.h (QR): Rebase on base_qr<ComplexMatrix>.
	* CmplxQR.cc: Ditto.
	* fCmplxQR.h (QR): Rebase on base_qr<FloatComplexMatrix>.
	* fCmplxQR.cc: Ditto.
	* dbleQRP.h (QR): Update.
	* dbleQRP.cc: Ditto.
	* floatQRP.h (QR): Update.
	* floatQRP.cc: Ditto.
	* CmplxQRP.h (QR): Update.
	* CmplxQRP.cc: Ditto.
	* fCmplxQRP.h (QR): Update.
	* fCmplxQRP.cc: Ditto.

2009-10-08  Jaroslav Hajek  <highegg@gmail.com>

	* PermMatrix.cc (PermMatrix::eye): New method.
	* PermMatrix.h: Declare it.
	* dbleLU.cc (LU::update, LU::update_piv): New overloaded methods.
	* dbleLU.h: Declare them.
	* floatLU.cc (FloatLU::update, FloatLU::update_piv): New overloaded
	methods.
	* floatLU.h: Declare them.
	* CmplxLU.cc (ComplexLU::update, ComplexLU::update_piv): New
	overloaded methods.
	* CmplxLU.h: Declare them.
	* fCmplxLU.cc (FloatComplexLU::update, FloatComplexLU::update_piv):
	New overloaded methods.
	* fCmplxLU.h: Declare them.

2009-10-07  John W. Eaton  <jwe@octave.org>

	* mx-inlines.cc (mx_inline_diff): Avoid uninitialized variable warning.

2009-10-06  Jaroslav Hajek  <highegg@gmail.com>

	* dDiagMatrix.cc (operator *(const DiagMatrix&, const DiagMatrix&)):
	Rewrite.
	* fDiagMatrix.cc (operator *(const FloatDiagMatrix&, const FloatDiagMatrix&)):
	Rewrite.
	* CDiagMatrix.cc (operator *(const ComplexDiagMatrix&, const ComplexDiagMatrix&)):
	Rewrite.
	* fCDiagMatrix.cc (operator *(const FloatComplexDiagMatrix&, const
	FloatComplexDiagMatrix&)):
	Rewrite.
	* DiagArray2.h (DiagArray2::diag_length): New method.
	* PermMatrix.h (PermMatrix::length): Make consistent with
	DiagArray2::length.

2009-10-05  Jaroslav Hajek  <highegg@gmail.com>

	* base-lu.cc (base_lu::unpack): Unpack getp as well.

2009-10-05  Jaroslav Hajek  <highegg@gmail.com>

	* PermMatrix.cc (PermMatrix::determinant): Implement a (hopefully)
	working algorithm.

2009-10-05  Jaroslav Hajek  <highegg@gmail.com>

	* dim-vector.h (operator ==): Include fast case.
	* base-lu.cc (base_lu::packed, base_lu::unpack): New methods.
	(base_lu::L, base_lu::U, base_lu::Y, base_lu::getp): Distinguish
	packed vs. unpacked case.
	* base-lu.h: Update decls.
	(base_lu::l_fact): New member field.

2009-10-02  Jaroslav Hajek  <highegg@gmail.com>

	* lo-traits.h (strip_template_param): New trait class.

2009-10-01  Jaroslav Hajek  <highegg@gmail.com>

	* Array.cc (Array<T>::permute): Fast case identity permutation.

2009-09-27  Jaroslav Hajek  <highegg@gmail.com>

	* oct-cmplx.h: Fix complex-real orderings.

2009-09-27  Jaroslav Hajek  <highegg@gmail.com>

	* dim-vector.h (dim_vector::redim): Rewrite.
	* Array-util.cc (sub2ind): Allow single index case.

2009-09-26  Jaroslav Hajek  <highegg@gmail.com>

	* dMatrix.cc (xgemm): Use blas_trans_type to indicate transposes.
	(operator *(const Matrix&, const Matrix&)): Update.
	* fMatrix.cc (xgemm): Use blas_trans_type to indicate transposes.
	(operator *(const FloatMatrix&, const FloatMatrix&)): Update.
	* CMatrix.cc (xgemm): Use blas_trans_type to indicate transposes.
	(operator *(const ComplexMatrix&, const ComplexMatrix&)): Update.
	* fCMatrix.cc (xgemm): Use blas_trans_type to indicate transposes.
	(operator *(const FloatComplexMatrix&, const FloatComplexMatrix&)): Update.
	* dMatrix.h: Update decl.
	* fMatrix.h: Update decl.
	* CMatrix.h: Update decl.
	* fCMatrix.h: Update decl.

2009-09-23  Jaroslav Hajek  <highegg@gmail.com>

	* CMatrix.cc (ComplexMatrix::ComplexMatrix (const Matrix&, const
	Matrix&)): New constructor.
	(operator * (Matrix, ComplexMatrix), operator * (ComplexMatrix,
	Matrix)): Optimize.
	* fCMatrix.cc (FloatComplexMatrix::FloatComplexMatrix (const FloatMatrix&, const
	FloatMatrix&)): New constructor.
	(operator * (FloatMatrix, FloatComplexMatrix), operator * (FloatComplexMatrix,
	FloatMatrix)): Optimize.

2009-09-23  Jaroslav Hajek  <highegg@gmail.com>

	* dMatrix.cc (stack_complex_matrix, unstack_complex_matrix): New
	static funcs.
	(Matrix::solve (..., const ComplexMatrix&, ...)): Use the above funcs.
	Improve forwarding.
	* fMatrix.cc (stack_complex_matrix, unstack_complex_matrix): New
	static funcs.
	(FloatMatrix::solve (..., const FloatComplexMatrix&, ...)): Use the
	above funcs.  Improve forwarding.

2009-09-23  Jaroslav Hajek  <highegg@gmail.com>

	* mx-defs.h (blas_trans_type): New enum.
	(get_blas_char): New inline func.
	* dMatrix.cc (Matrix::utsolve, Matrix::ltsolve, Matrix::solve):
	Support transt parameter.
	* fMatrix.cc (FloatMatrix::utsolve, FloatMatrix::ltsolve,
	FloatMatrix::solve): Ditto.
	* CMatrix.cc (ComplexMatrix::utsolve, ComplexMatrix::ltsolve,
	ComplexMatrix::solve): Ditto.
	* fCMatrix.cc (FloatComplexMatrix::utsolve,
	FloatComplexMatrix::ltsolve, FloatComplexMatrix::solve): Ditto.
	* dMatrix.h, fMatrix.h, CMatrix.h, fCMatrix.h: Update.

2009-09-21  Jaroslav Hajek  <highegg@gmail.com>

	* mx-op-defs.h (VS_BIN_OP, SV_BIN_OP, VV_BIN_OP): Simplify.

2009-09-19  Jaroslav Hajek  <highegg@gmail.com>

	* dNDArray.h (NDArray::matrix_type): New typedef.
	* fNDArray.h (FloatNDArray::matrix_type): New typedef.
	* CNDArray.h (ComplexNDArray::matrix_type): New typedef.
	* fCNDArray.h (FloatComplexNDArray::matrix_type): New typedef.
	* boolNDArray.h (boolNDArray::matrix_type): New typedef.
	* charNDArray.h (charNDArray::matrix_type): New typedef.

	* dMatrix.h (Matrix::column_vector_type,
	Matrix::row_vector_type): New typedefs.
	* fMatrix.h (FloatMatrix::column_vector_type,
	FloatMatrix::row_vector_type): New typedefs.
	* CMatrix.h (ComplexMatrix::column_vector_type,
	ComplexMatrix::row_vector_type): New typedefs.
	* fCMatrix.h (FloatComplexMatrix::column_vector_type,
	FloatComplexMatrix::row_vector_type): New typedefs.

2009-09-18  John W. Eaton  <jwe@octave.org>

	* mach-info.cc: Don't include oct-types.h.

2009-09-18  Jaroslav Hajek  <highegg@gmail.com>

	* Array.h (NoAlias): New template class.
	* dRowVector.cc (linspace): Rewrite.
	* fRowVector.cc (linspace): Rewrite.
	* CRowVector.cc (linspace): Rewrite.
	* fCRowVector.cc (linspace): Rewrite.
	* dMatrix.cc (linspace): New method.
	* dMatrix.h (linspace): Declare it.
	* fMatrix.cc (linspace): New method.
	* fMatrix.h (linspace): Declare it.
	* CMatrix.cc (linspace): New method.
	* CMatrix.h (linspace): Declare it.
	* fCMatrix.cc (linspace): New method.
	* fCMatrix.h (linspace): Declare it.

2009-09-17  John W. Eaton  <jwe@octave.org>

	* oct-types.h.in: Delete.
	* Makefile.in (BUILT_INCLUDES, DISTFILES): Remove oct-types.h.in
	from the list.
	(distclean, maintainer-clean): Don't remove oct-types.h
	* DAEFunc.h, MatrixType.h, base-aepbal.h, dim-vector.h,
	lo-specfun.h, lo-utils.h, mx-op-decl.h, oct-inttypes.h,
	randgamma.h, randmtzig.h, randpoisson.h:
	Don't include oct-types.h.

2009-09-16  Jaroslav Hajek  <highegg@gmail.com>

	* oct-rand.cc (octave_rand::do_matrix, do_nd_array, do_vector):
	Use Array::clear rather than Array::resize.

2009-09-06  Jaroslav Hajek  <highegg@gmail.com>

	* dColVector.h (operator *(const Matrix&, const ColumnVector)):
	Optimize.
	* fColVector.h (operator *(const FloatMatrix&, const
	FloatColumnVector)): Optimize.
	* CColVector.h (operator *(const ComplexMatrix&, const
	ComplexColumnVector)): Optimize.
	* fCColVector.h (operator *(const FloatComplexMatrix&, const
	FloatComplexColumnVector)): Optimize.

2009-09-04  Jaroslav Hajek  <highegg@gmail.com>

	* Array.cc (Array<T>::clear (const dim_vector&)): new method.
	* Array.h: Declare it.
	(Array<T>::clear (octave_idx_type)): New method.
	(Array<T>::clear (octave_idx_type, octave_idx_type)): New method.

2009-09-04  Jaroslav Hajek  <highegg@gmail.com>

	* mx-inlines.cc (DEFMXBOOLOPEQ): New macro.
	(mx_inline_and2, mx_inline_or2): New loops.

	* MArray.h (MArray<T>::MArray (const dim_vector&)): New constructor.
	(MArray<T>::MArray (const Array<T>&)): Ensure column vector.
	(MArray<T>::resize): New method.
	* DiagArray2.h (DiagArray2<T>::DiagArray2 (const dim_vector&)): New
	constructor.
	* MDiagArray2.h (MDiagArray2<T>::MDiagArray2 (const dim_vector&)): New
	constructor.
	* dColVector.h (ColumnVector::ColumnVector (const dim_vector&)): New
	constructor.
	* fColVector.h (FloatColumnVector::FloatColumnVector (const
	dim_vector&)): New constructor.
	* CColVector.h (ComplexColumnVector::ComplexColumnVector (const
	dim_vector&)): New constructor.
	* fCColVector.h (FloatComplexColumnVector::FloatComplexColumnVector
	(const dim_vector&)): New constructor.
	* dRowVector.h (RowVector::RowVector (const dim_vector&)): New
	constructor.
	* fRowVector.h (FloatRowVector::FloatRowVector (const dim_vector&)):
	New constructor.
	* CRowVector.h (ComplexRowVector::ComplexRowVector (const
	dim_vector&)): New constructor.
	* fCRowVector.h (FloatComplexRowVector::FloatComplexRowVector (const
	dim_vector&)): New constructor.

	* CNDArray.cc (operator *= (const ComplexNDArray, double)): Simplify.
	* fCNDArray.cc (operator *= (const FloatComplexNDArray, float)): Simplify.

	* MArray.cc
	(operator += (MArray<T>&, const T&)): Simplify.
	(operator -= (MArray<T>&, const T&)): Simplify.
	(operator *= (MArray<T>&, const T&)): Simplify.
	(operator /= (MArray<T>&, const T&)): Simplify.
	(operator += (MArray<T>&, const MArray<T>&)): Simplify.
	(operator -= (MArray<T>&, const MArray<T>&)): Simplify.
	(product (MArray<T>&, const MArray<T>&)): Simplify.
	(quotient (MArray<T>&, const MArray<T>&)): Simplify.
	(MARRAY_AS_OP): Simplify.
	(MARRAY_SA_OP): Simplify.
	(MARRAY_AA_OP): Simplify.
	(operator - (const MArray<T>&)): Simplify.

	* MArray2.cc
	(operator += (MArray2<T>&, const T&)): Simplify.
	(operator -= (MArray2<T>&, const T&)): Simplify.
	(operator *= (MArray2<T>&, const T&)): Simplify.
	(operator /= (MArray2<T>&, const T&)): Simplify.
	(operator += (MArray2<T>&, const MArray<T>&)): Simplify.
	(operator -= (MArray2<T>&, const MArray<T>&)): Simplify.
	(product (MArray2<T>&, const MArray<T>&)): Simplify.
	(quotient (MArray2<T>&, const MArray<T>&)): Simplify.
	(MARRAY_A2S_OP): Simplify.
	(MARRAY_SA2_OP): Simplify.
	(MARRAY_A2A2_OP): Simplify.
	(operator - (const MArray2<T>&)): Simplify.

	* MArrayN.cc
	(operator += (MArrayN<T>&, const T&)): Simplify.
	(operator -= (MArrayN<T>&, const T&)): Simplify.
	(operator *= (MArrayN<T>&, const T&)): Simplify.
	(operator /= (MArrayN<T>&, const T&)): Simplify.
	(operator += (MArrayN<T>&, const MArray<T>&)): Simplify.
	(operator -= (MArrayN<T>&, const MArray<T>&)): Simplify.
	(product (MArrayN<T>&, const MArray<T>&)): Simplify.
	(quotient (MArrayN<T>&, const MArray<T>&)): Simplify.
	(MARRAY_NDS_OP): Simplify.
	(MARRAY_SND_OP): Simplify.
	(MARRAY_NDND_OP): Simplify.
	(operator - (const MArrayN<T>&)): Simplify.

	* MDiagArray2.cc
	(operator += (MDiagArray2<T>&, const MDiagArray2<T>&)): Simplify.
	(operator -= (MDiagArray2<T>&, const MDiagArray2<T>&)): Simplify.
	(operator *= (MDiagArray2<T>&, T)): Simplify.
	(operator /= (MDiagArray2<T>&, T)): Simplify.
	(MARRAY_DAS_OP, MARRAY_SDA_OP, MARRAY_DADA_OP): Simplify.
	* boolNDArray.cc (mx_el_and_assign, mx_el_or_assign): Simplify.

	* MArray-defs.h (DO_VS_OP, DO_SV_OP, DO_VV_OP,
	DO_VS_OP2, DO_VV_OP2, NEGV): Remove.

2009-09-03  Jaroslav Hajek  <highegg@gmail.com>

	* mx-inlines.cc (DEFMXUNOPEQ): New macro.
	(mx_inline_not2, mx_inline_uminus2): New loops.
	* boolNDArray.cc (boolNDArray::invert): New method.
	* boolNDArray.h: Declare it.
	* MArrayN.cc (MArrayN<T>::changesign): New method.
	* MArrayN.h: Declare it.
	* dNDArray.cc (NDArray::changesign): New method.
	* dNDArray.h: Declare it.
	* fNDArray.cc (FloatNDArray::changesign): New method.
	* fNDArray.h: Declare it.
	* CNDArray.cc (ComplexNDArray::changesign): New method.
	* CNDArray.h: Declare it.
	* fCNDArray.cc (FloatComplexNDArray::changesign): New method.
	* fCNDArray.h: Declare it.
	* intNDArray.cc (intNDArray::changesign): New method.
	* intNDArray.h: Declare it.

2009-09-02  Jaroslav Hajek  <highegg@gmail.com>

	* oct-cmplx.h: Rewrite the comaprison ops. Use FLOAT_TRUNCATE.

2009-09-01  Jaroslav Hajek  <highegg@gmail.com>

	* oct-cmplx.h: Correct strict operators in macros.

2009-08-31  John W. Eaton  <jwe@octave.org>

	* lo-ieee.cc (octave_ieee_init): Abort if floating point format
	is not recognized as IEEE.

2009-08-27  John W. Eaton  <jwe@octave.org>

	* str-vec.cc, str-vec.h (string_vector::string_vector (const
	std::set<std::string>&)): New constructor.

2009-08-27  Jaroslav Hajek  <highegg@gmail.com>

	* mx-inlines.cc (DEFCMPLXCMOP): Remove.
	* oct-cmplx.h (operator <, operator >): Remove definitions.
	(DEF_COMPLEXR_COMP): New macro. Instantiate for <, >, <=, >=.
	* mx-op-defs.h (MM_CMP_OP, MS_CMP_OP, SM_CMP_OP,
	NDND_CMP_OP, NDS_CMP_OP, SND_CMP_OP): Replace by one-liners. Remove
	unused parameters.
	(MM_CMP_OPS, MS_CMP_OPS, SM_CMP_OPS, NDND_CMP_OPS, NDS_CMP_OPS,
	SND_CMP_OPS): Update.
	(NDS_CMP_OP1, NDS_CMP_OPS1, NDS_CMP_OP2, NDS_CMP_OPS2,
	SND_CMP_OP1, SND_CMP_OPS1, SND_CMP_OP2, SND_CMP_OPS2): Remove.
	* mk-ops.awk: Simplify CMP_OPS branch.
	* Sparse-op-defs.h (SPARSE_SMSM_CMP_OPS, SPARSE_SMS_CMP_OPS,
	SPARSE_SSM_CMP_OPS, SPARSE_MSM_CMP_OPS, SPARSE_SMM_CMP_OPS):
	Update.

	* CNDArray.cc: Update syntax.
	* boolNDArray.cc: Ditto.
	* chNDArray.cc: Ditto.
	* dNDArray.cc: Ditto.
	* fCNDArray.cc: Ditto.
	* fNDArray.cc: Ditto.

	* int16NDArray.cc: Ditto.
	* int32NDArray.cc: Ditto.
	* int64NDArray.cc: Ditto.
	* int8NDArray.cc: Ditto.
	* uint16NDArray.cc: Ditto.
	* uint32NDArray.cc: Ditto.
	* uint64NDArray.cc: Ditto.
	* uint8NDArray.cc: Ditto.

	* CMatrix.cc: Ditto.
	* boolMatrix.cc: Ditto.
	* chMatrix.cc: Ditto.
	* dMatrix.cc: Ditto.
	* fCMatrix.cc: Ditto.
	* fMatrix.cc: Ditto.

2009-08-24  Jaroslav Hajek  <highegg@gmail.com>

	* MArray.cc (MArray<T>::product_eq, MArray<T>::quotient_eq): New
	methods.
	* MArray2.cc (MArray2<T>::product_eq, MArray2<T>::quotient_eq): Ditto.
	* MArrayN.cc (MArrayN<T>::product_eq, MArrayN<T>::quotient_eq): Ditto.
	* MArray-decl.h (MARRAY_OP_ASSIGN_DECLX): New macro.
	(MARRAY_OP_ASSIGN_DECLS, MARRAY_OP_ASSIGN_FWD_DEFS): Include
	product_eq and quotient_eq.
	(MARRAY_FORWARD_DEFS): Use MARRAY_OP_ASSIGN_FWD_DEFS1.
	(MDIAGARRAY2_OPS_FORWARD_DECLS): Don't instantiate
	OP= operators for diag matrices.
	(MDIAGARRAY2_FORWARD_DEFS): Ditto.
	* MArray-defs.h (INSTANTIATE_MDIAGARRAY2_FRIENDS): Ditto.

2009-08-23  Jaroslav Hajek  <highegg@gmail.com>

	* Array.h (Array::make_unique, Array::~Array, Array::operator =):
	Move here to allow inlining.
	* Array.cc: Remove from here.

2009-08-20  Jaroslav Hajek  <highegg@gmail.com>

	* mx-inlines.cc (logical_value): New overloaded template.
	(DEFMXBOOL_OP): Use it in definitions.
	(mx_inline_not): Also use logical_value.
	* mx-op-defs.h (ND_LOGICAL_NAN_CHECK, SC_LOGICAL_NAN_CHECK): Remove
	(also from all macros).

	* CMatrix.cc (operator !): Simply call mx_inline_not.
	* CNDArray.cc: Ditto.
	* dMatrix.cc: Ditto.
	* dNDArray.cc: Ditto.
	* fCMatrix.cc: Ditto.
	* fCNDArray.cc: Ditto.
	* fMatrix.cc: Ditto.
	* fNDArray.cc: Ditto.

2009-08-20  Jaroslav Hajek  <highegg@gmail.com>

	* dMatrix.cc (Matrix::operator!): Simplify & check for NaNs.
	* fMatrix.cc (FloatMatrix::operator!): Ditto.
	* CMatrix.cc (ComplexMatrix::operator!): Ditto.
	* fCMatrix.cc (FloatComplexMatrix::operator!): Ditto.
	* dNDArray.cc (NDArray::operator!): Ditto.
	* fNDArray.cc (FloatNDArray::operator!): Ditto.
	* CNDArray.cc (ComplexNDArray::operator!): Ditto.
	* fCNDArray.cc (FloatComplexNDArray::operator!): Ditto.

2009-08-20  Jaroslav Hajek  <highegg@gmail.com>

	* mx-inlines.cc (mx_inline_add, mx_inline_sub, mx_inline_mul,
	mx_inline_div, mx_inline_uminus, mx_inline_not, mx_inline_add2,
	mx_inline_sub2, mx_inline_mul2, mx_inline_div2, mx_inline_iszero,
	mx_inline_notzero, mx_inline_and, mx_inline_or, mx_inline_not_and,
	mx_inline_not_or, mx_inline_and_not, mx_inline_or_not,
	mx_inline_lt, mx_inline_le, mx_inline_gt, mx_inline_ge,
	mx_inline_eq, mx_inline_ne): New templates.
	(do_mx_unary_op, do_mm_binary_op, do_sm_binary_op,
	do_ms_binary_op, do_mm_inplace_op,do_ms_inplace_op):
	New templates.

	* mx-op-defs.h (ND_LOGICAL_NAN_CHECK, SC_LOGICAL_NAN_CHECK):
	New macros.
	(NDND_BIN_OP, NDS_BIN_OP, SND_BIN_OP): Simplify.
	(MM_BIN_OP, MS_BIN_OP, MM_BIN_OP): Simplify.
	(NDND_BOOL_OP, NDS_BOOL_OP, SND_BOOL_OP): Simplify.
	(MM_BOOL_OP, MS_BOOL_OP, MM_BOOL_OP): Simplify.
	(NDND_BOOL_OPS2, NDS_BOOL_OPS2, SND_BOOL_OPS2,
	MM_BOOL_OPS2, MS_BOOL_OPS2, SM_BOOL_OPS2): Remove.
	* mx-op-decl.h (NDND_BOOL_OPX_DECLS, NDS_BOOL_OPX_DECLS,
	SND_BOOL_OPX_DECLS): New macros.
	* mk-ops.awk: use _BOOL_OPS rather than _BOOL_OPS2.

	* boolMatrix.cc: Add missing bool op defs.
	* boolMatrix.h: Add missing bool op decls.


	* boolNDArray.cc: Remove unused arg to BOOL_OPS.
	* CMatrix.cc: Ditto.
	* CNDArray.cc: Ditto.
	* ChangeLog: Ditto.
	* chMatrix.cc: Ditto.
	* chNDArray.cc: Ditto.
	* dMatrix.cc: Ditto.
	* dNDArray.cc: Ditto.
	* fCMatrix.cc: Ditto.
	* fCNDArray.cc: Ditto.
	* fMatrix.cc: Ditto.
	* fNDArray.cc: Ditto.
	* int16NDArray.cc: Ditto.
	* int32NDArray.cc: Ditto.
	* int64NDArray.cc: Ditto.
	* int8NDArray.cc: Ditto.
	* uint16NDArray.cc: Ditto.
	* uint32NDArray.cc: Ditto.
	* uint64NDArray.cc: Ditto.
	* uint8NDArray.cc: Ditto.

	* CColVector.cc: Update syntax where needed.
	* CDiagMatrix.cc: Ditto.
	* CMatrix.cc: Ditto.
	* CRowVector.cc: Ditto.
	* chMatrix.cc: Ditto.
	* dColVector.cc: Ditto.
	* dDiagMatrix.cc: Ditto.
	* dMatrix.cc: Ditto.
	* dRowVector.cc: Ditto.
	* fCColVector.cc: Ditto.
	* fCDiagMatrix.cc: Ditto.
	* fCMatrix.cc: Ditto.
	* fCRowVector.cc: Ditto.
	* fColVector.cc: Ditto.
	* fDiagMatrix.cc: Ditto.
	* fMatrix.cc: Ditto.
	* fRowVector.cc: Ditto.

2009-08-19  Jaroslav Hajek  <highegg@gmail.com>

	* Array-util.cc (zero_dims_inquire): Add matching ndims case.

2009-08-19  Jaroslav Hajek  <highegg@gmail.com>

	* MArrayN.cc (operator+=, operator-=): Test matching dimensions first.
	* boolNDArray.cc (mx_el_and_assign, mx_el_or_assign): New functions.
	* boolNDArray.h: Declare them.

2009-08-19  Jaroslav Hajek  <highegg@gmail.com>

	* Array.cc (Array<T>::clear): New method.
	* Array.h: Declare it.
	* MArray-decl.h (MARRAY_OP_ASSIGN_DECLS1, MARRAY_OP_ASSIGN_FWD_DECLS1,
	MARRAY_OP_ASSIGN_FRIENDS1, MARRAY_OP_ASSIGN_FWD_DEFS1): New macros.
	(MARRAY_OPS_FORWARD_DECLS, MARRAY_OPS_FRIEND_DECLS): Use them.
	* MArray-defs.h (MARRAY_OP_ASSIGN_DEFS1): New macro.
	(INSTANTIATE_MARRAY_FRIENDS): Use it.
	(INSTANTIATE_MARRAY2_FRIENDS): Use it.
	(INSTANTIATE_MARRAYN_FRIENDS): Use it.
	* MArray.cc (operator+=, operator-=):
	Operate out-of-place when this is shared copy.
	(operator*=, operator/=): New operator overloads.
	* MArray2.cc: Ditto.
	* MArrayN.cc: Ditto.
	* CNDArray.cc (operator *= (ComplexNDArray&, double),
	operator /= (ComplexNDArray&, double)): New operators.
	* CNDArray.h: Declare them.
	* fCNDArray.cc (operator *= (FloatComplexNDArray&, double),
	operator /= (FloatComplexNDArray&, double)): New operators.
	* fCNDArray.h: Declare them.

2009-08-17  John W. Eaton  <jwe@octave.org>

	* Makefile.in (LINK_DEPS): List LIBS last.

2009-08-16  Jaroslav Hajek  <highegg@gmail.com>

	* dMatrix.cc, fMatrix.cc, CMatrix.cc, fCMatrix.cc: Add more tests.
	* CMatrix.cc (xgemm): Fix vector * matrix case.
	* fCMatrix.cc (xgemm): Ditto.

2009-08-16  Jaroslav Hajek  <highegg@gmail.com>

	* fMatrix.cc, fCMatrix.cc: Make tests use single precision.

2009-08-16  Jaroslav Hajek  <highegg@gmail.com>

	* CMatrix.cc (xgemm): Fix typo. Add test.
	* fCMatrix.cc (xgemm): Ditto.

2009-08-14  John W. Eaton  <jwe@octave.org>

	* Makefile.in (LINK_DEPS): Include BLAS_LIBS in the list.

2009-08-13  John W. Eaton  <jwe@octave.org>

	* CMatrix.cc, CNDArray.cc, dMatrix.cc, dNDArray.cc, fCMatrix.cc,
	fCNDArray.cc, fMatrix.cc, fNDARray.cc, oct-fftw.cc, oct-fftw.h:
	Update for new FFTW defines.

	* Makefile.in: Add library-specific CPPFLAGS and LDFLAGS variables
	to CPPFLAGS and LDFLAGS for files that use sparse matrices or fftw.

2009-08-12  Jaroslav Hajek  <highegg@gmail.com>

	* Makefile.in: Include LDFLAGS when linking shared executable.

2009-08-11  John W. Eaton  <jwe@octave.org>

	* oct-fftw.h, oct-fftw.cc (octave_fftw_planner): Convert to singleton.
	(octave_float_fft_planner): Likewise.

2009-08-11  John W. Eaton  <jwe@octave.org>

	* Makefile.in (LINK_DEPS): Use READLINE_LIBS instead of
	LIBREADLINE.  Also link with TERM_LIBS and DL_LIBS.

2009-08-11  Jaroslav Hajek  <highegg@gmail.com>

	* mx-inlines.cc (mx_inline_diff<T>): New overloaded template
	function.
	(get_extent_triplet): Use dim_vector::first_non_singleton.
	(do_mx_diff_op): New template function.
	* dNDArray.cc (NDArray::diff): New method.
	* dNDArray.h: Declare it.
	* fNDArray.cc (FloatNDArray::diff): New method.
	* fNDArray.h: Declare it.
	* CNDArray.cc (ComplexNDArray::diff): New method.
	* CNDArray.h: Declare it.
	* fCNDArray.cc (FloatComplexNDArray::diff): New method.
	* fCNDArray.h: Declare it.
	* intNDArray.cc (intNDArray<T>::diff): New method.
	* intNDArray.h: Declare it.

2009-08-10  Jaroslav Hajek  <highegg@gmail.com>

	* dim-vector.h (dim_vector::first_non_singleton): New method.

2009-08-06  Jaroslav Hajek  <highegg@gmail.com>

	* dim-vector.h (dim_vector): Rewrite. Use single-alloc implementation
	aka GCC's basic_string class.
	* Array.cc: Use dim_vector::alloc where fitting.
	* Array-util.cc: Ditto.

2009-08-05  John W. Eaton  <jwe@octave.org>

	* oct-shlib.cc (octave_shl_load_shlib::open): Pass BIND_IMMEDIATE,
	not BIND_DEFERRED to shl_load.
	(octave_dlopen_shlib::open): Don't pass RTLD_GLOBAL to dlopen.

2009-08-05  John W. Eaton  <jwe@octave.org>

	* Makefile.in (LINK_DEPS): Omit $(BLAS_LIBS) from the list.
	Include $(RLD_FLAG) in the list.

2009-08-05  John W. Eaton  <jwe@octave.org>

	* Makefile.in (LINK_DEPS): Include $(PTHREAD_LIBS) in the list.

2009-08-04  Kristian Rumberg  <kristianrumberg@gmail.com>

	* cmd-edit.cc (gnu_readline::do_get_line_buffer,
	default_command_editor::do_get_line_buffer): New functions.
	(command_editor::get_line_buffer): New function.
	* cmd-edit.h (command_editor::get_line_buffer): Provide decls.
	(command_editor::do_get_line_buffer): New pure virtual function.

2009-07-31  Jaroslav Hajek  <highegg@gmail.com>

	* idx-vector.h (idx_vector::is_range): New method.
	(idx_vector::copy_data, idx_vector::unconvert): New method decls.
	* idx-vector.cc (idx_vector::copy_data, idx_vector::unconvert): New
	methods.
	* Array-utils.cc (sub2ind, ind2sub): New functions.

2009-07-29  John W. Eaton  <jwe@octave.org>

	* fMatrix.cc (operator >>): Use template function to read value.
	* fNDArray.cc (operator >>): Likeise.
	* fCMatrix.cc (operator >>): Use template function to read value.
	* fCNDArray.cc (operator >>): Likeise.
	* dMatrix.cc (operator >>): Use template function to read value.
	* dNDArray.cc (operator >>): Likeise.
	* CMatrix.cc (operator >>): Use template function to read value.
	* CNDArray.cc (operator >>): Likeise.

	* lo-utils.cc, lo-utils.h (octave_read_value): New template
	(octave_read_value<double>, octave_read_value<Complex>):
	Provide specializations.
	(octave_read_double, octave_read_complex, octave_read_float,
	octave_rread_float_complex): Define in terms of template functions.
	* Sparse.h (read_sparse_matrix): New template function.
	* dSparse.cc (operator >>): Call read_sparse_matrix.
	* CSparse.cc (operator >>): Likewise.
	* boolSparse.cc (operator >>): Likewise.
	* sparse-util.cc, sparse-util.h (sparse_indices_ok): New function.
	* Sparse.cc (Sparse<T>::indices_ok, Sparse<T>::SparseRep::indices_ok):
	New member functions.

2009-07-20  John W. Eaton  <jwe@octave.org>

	* lo-ieee.cc (octave_ieee_init) [__NetBSD__]: Call nan to
	initialize Octave_NaN and nanf, to initialize Octave_Float_NaN.

2009-07-11  John W. Eaton  <jwe@octave.org>

	* file-ops.cc (file_ops::symlink, file_ops::readlink):
	Don't use incorrectly sized OCTAVE_LOCAL_BUFFER.

2009-07-08  John W. Eaton  <jwe@octave.org>

	* dim-vector.h (dim_vector::dim_vector_rep::dim_vector_rep
	(octave_idx_type, const dim_vector_rep *, int)):
	Enforce 2-d objects here.
	(dim_vector::dim_vector_rep::dim_vector_rep): Simply copy object.
	(dim_vector::resize): Allow N < 2.

2009-07-03  Jaroslav Hajek  <highegg@gmail.com>

	* Sparse-op-defs.h (SPARSE_ALL_OP): Fix typo.
	* dSparse.cc (SparseMatrix::prod): Ditto.
	* CSparse.cc (ComplexSparseMatrix::prod): Ditto.

2009-07-02  Jaroslav Hajek  <highegg@gmail.com>

	* Sparse-diag-op-defs.h (inner_do_add_sm_dm): Rewrite to ensure
	ordering of row indices.

2009-06-30  Jaroslav Hajek  <highegg@gmail.com>

	* oct-sort.cc (octave_sort<T>::lookupb<Comp>): Fix typo.

2009-06-29  Jaroslav Hajek  <highegg@gmail.com>

	* oct-sort.cc (octave_sort<T>::lookup_merge): Delete.
	(octave_sort<T>::lookup<Comp>,
	octave_sort<T>::lookupm<Comp>,
	octave_sort<T>::lookupb<Comp>): Rewrite.

2009-06-26  Michael Goffioul  <michael.goffioul@gmail.com>

	* pathsearch.h (class dir_path::static_members): Decorate with
	OCTAVE_API.

2009-06-26  Jaroslav Hajek  <highegg@gmail.com>

	* oct-sort.cc (octave_sort<T>::lookup_merge<Comp>): Slightly speed-up
	the merge case.

2009-06-26  Jaroslav Hajek  <highegg@gmail.com>

	* oct-sort.cc (octave_sort<T>::lookup_merge<Comp>): Fix lower-part
	recursion.

2009-06-24  Alexander Barth  <barth.alexander@gmail.com>

	* eigs-base.cc (EigsRealSymmetricMatrix,
	EigsRealSymmetricMatrixShift, EigsRealSymmetricFunc,
	EigsRealNonSymmetricMatrix, EigsRealNonSymmetricMatrixShift,
	EigsRealNonSymmetricFunc, EigsComplexNonSymmetricMatrix,
	EigsComplexNonSymmetricMatrixShift, EigsComplexNonSymmetricFunc):
	Use octave_idx_type for parameters of type LOGICAL in ARPACK.

2009-06-22  Jaroslav Hajek  <highegg@gmail.com>

	* chMatrix.cc (charMatrix::charMatrix (const string_vector&)):
	Optimize w.r.t. COW of std::string.

2009-06-18  Jaroslav Hajek  <highegg@gmail.com>

	* oct-sort.cc (lookup_impl<T, Comp>): New helper inline function.
	(octave_sort<T>::lookup_merge<Comp>): New private template method.
	(octave_sort<T>::lookup<Comp>): Rewrite.
	(octave_sort<T>::lookupm<Comp>): use lookup_impl.
	(octave_sort<T>::lookupb<Comp>): use lookup_impl.
	(out_of_range_pred, out_of_range): Remove.

2009-06-18  Jaroslav Hajek  <highegg@gmail.com>

	* dMatrix.cc (xgemm): Replace resize() with uninitialized allocations
	where appropriate.
	* fMatrix.cc (xgemm): Ditto.
	* CMatrix.cc (xgemm): Ditto.
	* fCMatrix.cc (xgemm): Ditto.

2009-06-12  Jaroslav Hajek  <highegg@gmail.com>

	* oct-sort.cc (octave_sort::lookupm, octave_sort::lookupb): New
	overloaded methods.
	* oct-sort.h: Declare them.
	* Array.cc (Array<T>::lookupm, Array<T>::lookupb): New methods.
	* Array.h: Declare them.

2009-06-09  Jaroslav Hajek  <highegg@gmail.com>

	* cmd-edit.cc (command_editor::force_default_editor): New static
	method.
	* cmd-edit.h: Declare it.

2009-06-09  Jaroslav Hajek  <highegg@gmail.com>

	* lo-mappers.cc (xlog2 (const Complex&, int&), xlog2 (const
	FloatComplex&, int&)): Use more robust expression.

2009-06-07  Jaroslav Hajek  <highegg@gmail.com>

	* Array.cc (Array<T>::find): Avoid allocating excessive memory. Fix
	order for backward searches.

2009-06-02  Jaroslav Hajek  <highegg@gmail.com>

	* Array-C.cc (class DiagArray2<Complex>::Proxy): Only explicitly
	instantiate DiagArray2<T>::Proxy on MSVC.
	* Array-d.cc (class DiagArray2<double>::Proxy): Ditto.
	* Array-f.cc (class DiagArray2<float>::Proxy): Ditto.
	* Array-fC.cc (class DiagArray2<FloatComplex>::Proxy): Ditto.

2009-05-26  John W. Eaton  <jwe@octave.org>

	* pathsearch.h (dir_path::path_sep_char (char),
	dir_path::static_members::path_sep_char (char)): New functions.

2009-05-21  Michael Goffioul  <michael.goffioul@gmail.com>

	* Array-C.cc (class DiagArray2<Complex>::Proxy): Tag with OCTAVE_API.
	* Array-d.cc (class DiagArray2<double>::Proxy): Ditto.
	* Array-f.cc (class DiagArray2<float>::Proxy): Ditto.
	* Array-fC.cc (class DiagArray2<FloatComplex>::Proxy): Ditto.
	* Array.cc (class octave_sort<T>): Ditto.
	* CColVector.h (conj, operator*, operator>>, operator<<): Ditto.
	* CDiagMatrix.h (class ComplexDiagMatrix, conj, operator*): Ditto.
	* CMatrix.h (conj): Ditto.
	* CNDArray.h (conj): Ditto.
	* PermMatrix.h (class PermMatrix, operator*): Ditto.
	* dDiagMatrix.h (class DiagMatrix): Ditto.
	* fCColVector.h (conj, operator*, operator>>, operator<<): Ditto.
	* fCDiagMatrix.h (class FloatComplexDiagMatrix, conj, operator*):
	Ditto.
	* fCMatrix.h (conj): Ditto.
	* fCNDArray.h (conj): Ditto.
	* fDiagMatrix.h (operator*): Ditto.
	* oct-locbuf.h (octave_chunk_buffer::octave_chunk_buffer,
	octave_chunk_buffer::~octave_chunk_buffer): Ditto.
	* oct-inttypes.cc (octave_int_cmp_op::emulate_op): Ditto.
	* DET.h (class base_det<T>): Remove OCTAVE_API (cannot be applied on
	templates).
	* oct-inttypes.cc (octave_int_cmp_op::emulate_op<class xop>): Ditto.

	* CmplxQR.cc (ComplexQR::insert_col, ComplexQR::delete_col): Copy
	volatile variable to avoid MSVC compilation error (cannot pass
	volatile variable as const& argument).
	* dbleQR.cc (QR::insert_col, QR::delete_col): Ditto.
	* fCmplxQR.cc (FloatComplexQR::insert_col,
	FloatComplexQR::delete_col): Ditto.
	* floatQR.cc (FloatQR::insert_col, FloatQR::delete_col): Ditto.

	* oct-mutex.cc: Exclude pthread.h inclusion under Win32.

	* base-aepbal.h (base_aepbal::operator=): Add missing return
	statement.

2009-05-20  Jaroslav Hajek  <highegg@gmail.com>

	* eigs-base.cc (
	EigsRealSymmetricMatrix,
	EigsRealSymmetricMatrixShift,
	EigsRealSymmetricFunc,
	EigsRealNonSymmetricMatrix,
	EigsRealNonSymmetricMatrixShift,
	EigsRealNonSymmetricFunc,
	EigsComplexNonSymmetricMatrix,
	EigsComplexNonSymmetricMatrixShift,
	EigsComplexNonSymmetricFunc): Update tests.

2009-05-21  Jaroslav Hajek  <highegg@gmail.com>

	* CMatrix.cc
	(ComplexMatrix::all, ComplexMatrix::any, ComplexMatrix::cumprod,
	ComplexMatrix::cumsum, ComplexMatrix::prod, ComplexMatrix::sum,
	ComplexMatrix::sumsq): Use explicit template qualifications
	to workaround bugs in Intel C++ and MSVC++ compilers.
	* CNDArray.cc
	(ComplexNDArray::all, ComplexNDArray::any, ComplexNDArray::cumprod,
	ComplexNDArray::cumsum, ComplexNDArray::prod, ComplexNDArray::sum,
	ComplexNDArray::sumsq): Ditto.
	* boolMatrix.cc
	(boolMatrix::all, boolMatrix::any): Ditto.
	* boolNDArray.cc
	(boolNDArray::all, boolNDArray::any): Ditto.
	* chMatrix.cc
	(charMatrix::all, charMatrix::any): Ditto.
	* chNDArray.cc
	(charNDArray::all, charNDArray::any): Ditto.
	* dMatrix.cc
	(Matrix::all, Matrix::any, Matrix::cumprod,
	Matrix::cumsum, Matrix::prod, Matrix::sum,
	Matrix::sumsq): Ditto.
	* dNDArray.cc
	(NDArray::all, NDArray::any, NDArray::cumprod,
	NDArray::cumsum, NDArray::prod, NDArray::sum,
	NDArray::sumsq): Ditto.
	* fCMatrix.cc
	(FloatComplexMatrix::all, FloatComplexMatrix::any, FloatComplexMatrix::cumprod,
	FloatComplexMatrix::cumsum, FloatComplexMatrix::prod, FloatComplexMatrix::sum,
	FloatComplexMatrix::sumsq): Ditto.
	* fCNDArray.cc
	(FloatComplexNDArray::all, FloatComplexNDArray::any, FloatComplexNDArray::cumprod,
	FloatComplexNDArray::cumsum, FloatComplexNDArray::prod, FloatComplexNDArray::sum,
	FloatComplexNDArray::sumsq): Ditto.
	* fMatrix.cc
	(FloatMatrix::all, FloatMatrix::any, FloatMatrix::cumprod,
	FloatMatrix::cumsum, FloatMatrix::prod, FloatMatrix::sum,
	FloatMatrix::sumsq): Ditto.
	* fNDArray.cc
	(FloatNDArray::all, FloatNDArray::any, FloatNDArray::cumprod,
	FloatNDArray::cumsum, FloatNDArray::prod, FloatNDArray::sum,
	FloatNDArray::sumsq): Ditto.
	* intNDArray.cc
	(intNDArray<T>::all, intNDArray<T>::any,
	intNDArray<T>::cumsum, intNDArray<T>::sum): Ditto.

2009-05-20  Jaroslav Hajek  <highegg@gmail.com>

	* Makefile.in: Remove reference to ArrayN-idx.h.

2009-05-20  Jaroslav Hajek  <highegg@gmail.com>

	* Array-voidp.cc: New source.
	* Array.cc (NO_INSTANTIATE_ARRAY_SORT): const T& -> T const &
	* Makefile.in: Include it.

2009-05-15  Jaroslav Hajek  <highegg@gmail.com>

	* Array.cc (Array<T>::instantiation_guard): New function
	(INSTANTIATE_ARRAY): Always override it here.
	* Array.h: Declare it.

2009-05-15  Jaroslav Hajek  <highegg@gmail.com>

	* ArrayN-idx.h: Remove file.
	* ArrayN.cc: Don't include it.
	* MArrayN.cc: Dtto.

2009-05-09  Jaroslav Hajek  <highegg@gmail.com>

	* Array-util.cc (zero_dims_inquire): Move j++ out of branch.

2009-05-07  Marco Atzeri  <marco_atzeri@yahoo.it>

	* Makefile.in: (SHLPRE): Rename from SHLLIBPRE.

2009-05-05  Robert T. Short  <octave@phaselockedsystems.com>

	* file-ops.h (file_ops::tail) New function.

2009-05-05  Carsten Clark  <tantumquantum+gnuoctave@gmail.com>

	* Quad.cc (user_function): Use access_double and assign_double on
	SPARC only, not on all Sun systems.
	* sun-utils.h: Likewise, define these functions on SPARC only.

2009-05-05  Jaroslav Hajek  <highegg@gmail.com>

	* Sparse.cc (assign1): Fix an old indexing bug.

2009-05-04  Carsten Clark  <tantumquantum+gnuoctave@gmail.com>

	* Quad.cc (float_user_function): Remove Sun/GCC special case.

2009-04-16  Jaroslav Hajek  <highegg@gmail.com>

	* idx-vector.cc (idx_vector::idx_range_rep::idx_range_rep (const
	Range&)): Check for positive integer indices. Unify gripes.

2009-04-15  Jaroslav Hajek  <highegg@gmail.com>

	* Array.cc (rec_permute_helper::blk_trans): Declare as static.
	(Array<T>::transpose): Reuse it.

2009-04-04  Jaroslav Hajek  <highegg@gmail.com>

	* Array.cc (Array<T>::make_unique): Don't economize when unique.
	(Array<T>::resize_fill (octave_idx_type, const T&)): Optimize push &
	pop operations.
	(Array<T>::delete_elements (const idx_vector&)): Do pop operation
	using resize.

2009-03-29  Jaroslav Hajek  <highegg@gmail.com>

	* Array.cc (Array<T>::assign): Remove redundant checks after invalid
	resize.

2009-03-26  Jaroslav Hajek  <highegg@gmail.com>

	* Array.cc (Array<T>::find): Reshape result for Matlab compatibility.
	* Array.h (Array<T>): Add friend template declaration.

2009-03-27  Jaroslav Hajek  <highegg@gmail.com>

	* idx-vector.cc (idx_vector::idx_vector_rep::idx_vector_rep (const
	Array<bool>&): Use more M*b-compatible behaviour.

2009-03-26  Jaroslav Hajek  <highegg@gmail.com>

	* dim-vector.h (dim_vector::numel): Add optional argument, simplify.

2009-03-26  Jaroslav Hajek  <highegg@gmail.com>

	* Array.h (Array<T>::dims): Return a const reference.
	(Array<T>::is_vector): New method.

2009-03-26  Jaroslav Hajek  <highegg@gmail.com>

	* Array.cc (Array<T>::find): New method.
	* Array.h: Declare it.

2009-03-25  John W. Eaton  <jwe@octave.org>

	* EIG.cc (EIG::init (const Matrix&, bool),
	EIG::init (const Matrix&, const Matrix&, bool)):
	Avoid volatile declaration for tmp variable.

	* Makefile.in (MATRIX_INC): Add Sparse-diag-op-defs.h and
	Sparse-perm-op-defs.h to the list.

2009-03-25  Jaroslav Hajek  <highegg@gmail.com>

	* oct-inttypes.cc (INT_DOUBLE_BINOP_DECL (*, uint64),
	INT_DOUBLE_BINOP_DECL (*, int64)): x -> y where appropriate.

2009-03-25  Jaroslav Hajek  <highegg@gmail.com>

	* Array.cc (rec_permute_helper::use_blk): New field.
	(rec_permute_helper::blk_trans): New method.
	(rec_permute_helper::rec_permute_helper): Use smart reductions,
	detect possibility of using blocked transpose.
	(rec_permute_helper::do_permute): Use blocked transpose if possible.

2009-03-23  Jaroslav Hajek  <highegg@gmail.com>

	* idx-vector.cc (convert_index(double,...)): Simplify.

2009-03-21  Jaroslav Hajek  <highegg@gmail.com>

	* Array-d.cc: lo_ieee_isnan -> xisnan.
	* Array-f.cc: Ditto.
	* oct-inttypes.cc: Ditto.
	* oct-inttypes.h: Ditto.
	* CDiagMatrix.cc: Add missing include.
	* fCDiagMatrix.cc: Ditto.

2009-03-20  Jaroslav Hajek  <highegg@gmail.com>

	* CColVector.cc, CMatrix.cc, CNDArray.cc, CRowVector.cc, CSparse.cc,
	boolSparse.cc, dColVector.cc, dMatrix.cc, dNDArray.cc, dRowVector.cc,
	dSparse.cc, fCColVector.cc, fCMatrix.cc, fCNDArray.cc, fCRowVector.cc,
	fColVector.cc, fMatrix.cc, fNDArray.cc, fRowVector.cc, intNDArray.cc:
	Allow empty arrays in stream input operators.

2009-03-20  Jaroslav Hajek  <highegg@gmail.com>

	* Array.h (Array<T>::fastmap): New method.
	* dNDArray.cc (NDArray::isnan, NDArray::isinf, NDArray::isfinite):
	New methods.
	* dNDArray.h: Declare them.
	* fNDArray.cc (FloatNDArray::isnan, FloatNDArray::isinf,
	FloatNDArray::isfinite): New methods.
	* fNDArray.h: Declare them.
	* CNDArray.cc (ComplexNDArray::isnan, ComplexNDArray::isinf,
	ComplexNDArray::isfinite): New methods.
	* CNDArray.h: Declare them.
	* fCNDArray.cc (FloatComplexNDArray::isnan, FloatComplexNDArray::isinf,
	FloatComplexNDArray::isfinite): New methods.
	* fCNDArray.h: Declare them.
	* lo-mappers.h (xisnan, xisinf, xfinite): If possible, use definitions
	from <cmath>.

2009-03-18  Jaroslav Hajek  <highegg@gmail.com>

	* oct-norm.cc (get_eps): Remove that hack.
	(higham): Use std::numeric_limits instead.
	Include OCTAVE_QUIT.

2009-03-16  Jason Riedy  <jason@acm.org>

	* Sparse.cc (transpose): Eliminate the workspace by computing in
	retval.xcidx.
	* CSparse.cc (hermitian): Eliminate the workspace by computing in
	retval.xcidx.

2009-03-14  Jaroslav Hajek  <highegg@gmail.com>

	* mx-op-decl.h (NDS_BOOL_OP_DECLS, SND_BOOL_OP_DECLS, NDND_BOOL_OP_DECLS): Support compound binary ops.
	* mx-op-defs.h (NDS_BOOL_OPS, SND_BOOL_OPS, NDND_BOOL_OPS): Ditto. Optimize.
	* mx-op-defs.h (NDS_CMP_OP, SND_CMP_OP, NDND_CMP_OP): Optimize.

2009-03-14  Jaroslav Hajek  <highegg@gmail.com>

	* fNDArray.h (FloatMatrix::matrix_value): Fix return type.
	* dNDArray.cc (Matrix::matrix_value): Simplify.
	* fNDArray.cc (FloatMatrix::matrix_value): Simplify.
	* CNDArray.cc (ComplexMatrix::matrix_value): Simplify.
	* fCNDArray.cc (FloatComplexMatrix::matrix_value): Simplify.

2009-03-13  Jaroslav Hajek  <highegg@gmail.com>

	* Range.h (Range::Range (double, double, octave_idx_type)): Remove
	constructor body.
	* Range.cc: Move it here. Check for invalid range op results.
	(all operators): Validate cache for invalid range op results.
	* idx-vector.h (idx_vector::index): Optimize zero-step range case.
	* idx-vector.cc (idx_vector::maybe_reduce): Always reduce colon in
	singleton dimension.

2009-03-10  Jason Riedy  <jason@acm.org>

	* sparse-base-lu.cc (Pr_mat): New member function.  Return the row
	permutation as a PermMatrix.
	(Pc_mat): New member function.  Return the col permutation as a
	PermMatrix.

	* sparse-base-lu.h (sparse_base_lu): Declare Pc_mat and Pr_mat
	member functions.

2009-03-09  Jason Riedy  <jason@acm.org>

	* Sparse-diag-op-defs.h (octave_impl::inner_do_add_sm_dm): New
	template function.  Implementation for adding sparse and diagonal
	matrices.  Takes two functional arguments, opa and opd, to
	generate both subtraction variants.
	(octave_impl::do_commutative_add_dm_sm): New template function.
	Ensure A+D and D+A use the same generated code.
	(octave_impl::do_add_dm_sm): New template function.  Check
	arguments for diag + sparse and call inner routine.
	(octave_impl::do_sub_dm_sm): New template function.  Check
	arguments for diag - sparse and call inner routine.
	(octave_impl::do_add_sm_dm): New template function.  Check
	arguments for sparse + diag and call inner routine.
	(octave_impl::do_sub_sm_dm): New template function.  Check
	arguments for sparse - diag and call inner routine.

	* dSparse.h (operator +): Declare overrides for real diag +
	sparse.
	(operator -): Declare overrides for real diag - sparse, sparse -
	diag.

	* dSparse.cc (operator +): Define overrides for real diag +
	sparse.
	(operator -): Define overrides for real diag - sparse, sparse -
	diag.

	* CSparse.h (operator +): Declare overrides for complex and real
	combinations of diag + sparse.
	(operator -): Declare overrides for complex and real combinations
	of diag - sparse, sparse - diag.

	* CSparse.cc (operator +): Define overrides for complex and real
	combinations of diag + sparse.
	(operator -): Define overrides for complex and real combinations
	of diag - sparse, sparse - diag.

2009-03-08  Jason Riedy  <jason@acm.org>

	* Sparse-diag-op-defs.h (octave_impl::do_mul_dm_sm)
	(octave_impl::do_mul_sm_dm): New template
	functions. Implementations for sparse * diag and diag * sparse.

	* CSparse.h (operator *, trans_mul, herm_mul): Add overloads for
	DiagMatrix and ComplexDiagMatrix.
	* CSparse.cc (operator *, trans_mul, herm_mul): Implement
	operations by calling approprate functions in
	Sparse-diag-op-defs.h.
	* dSparse.h (operator *, trans_mul): Add overloads for DiagMatrix.
	* dSparse.cc (operator *, trans_mul): Implement operations by
	calling approprate functions in Sparse-diag-op-defs.h.

2009-03-12  John W. Eaton  <jwe@octave.org>

	* oct-inttypes.h (bitshift): Apply mask even if not shifting.
	From Seb Astien <se6astien2@googlemail.com>.

2009-03-11  Jaroslav Hajek  <highegg@gmail.com>

	* PermMatrix.cc (PermMatrix::power): New method.
	* PermMatrix.h: Declare it.

2009-03-11  Jaroslav Hajek  <highegg@gmail.com>

	* dNDArray.cc (NDArray::NDArray (const charNDArray&)): New
	constructor.
	* fNDArray.cc (FloatNDArray::FloatNDArray (const charNDArray&)):
	Ditto.
	* CNDArray.cc (ComplexNDArray::ComplexNDArray (const charNDArray&)):
	Ditto.
	* fCNDArray.cc (FloatComplexNDArray::FloatComplexNDArray
	(const charNDArray&)): Ditto.

	* dNDArray.h (NDArray::NDArray (const charNDArray&)): Declare.
	* fNDArray.h (FloatNDArray::FloatNDArray (const charNDArray&)):
	Ditto.
	* CNDArray.h (ComplexNDArray::ComplexNDArray (const charNDArray&)):
	Ditto.
	* fCNDArray.h (FloatComplexNDArray::FloatComplexNDArray
	(const charNDArray&)): Ditto.

	* dMatrix.cc (Matrix::Matrix (const charMatrix&)): Cast to unsigned
	chars.
	* fMatrix.cc (FloatMatrix::FloatMatrix (const charMatrix&)): Likewise.
	* CMatrix.cc (ComplexMatrix::ComplexMatrix (const charMatrix&)):
	Likewise.
	* fCMatrix.cc (FloatComplexMatrix::FloatComplexMatrix
	(const charMatrix&)): Likewise.

2009-03-10  Jason Riedy  <jason@acm.org>

	* Sparse-perm-op-defs.h (octinternal_do_mul_colpm_sm): New
	template function.  Logic for the column permutation * sparse
	matrix operator.
	(octinternal_do_mul_pm_sm): New template function.  Logic for the
	permutation matrix * sparse matrix operator.  Note that there is
	no special row perm * sparse routine; the permutation is inverted
	and the col perm routine is called.
	(octinternal_do_mul_sm_rowpm): New template function.  Logic for
	the sparse matrix * row permutation operator.
	(octinternal_do_mul_sm_colpm): New template function.  Logic for
	the sparse matrix * column permutation operator.
	(octinternal_do_mul_sm_pm): New template function.  Logic for the
	sparse matrix * permutation matrix operator.

	* dSparse.h (operator *): Declare sparse * permutation and
	permutation * sparse.
	* dSparse.cc (operator *): Define sparse * permutation and
	permutation * sparse.

	* CSparse.h (operator *): Declare sparse * permutation and
	permutation * sparse.
	* CSparse.cc (operator *): Define sparse * permutation and
	permutation * sparse.

2009-03-10  Jason Riedy  <jason@acm.org>

	* sparse-base-lu.cc (Pc_vec): The column permutation should be
	Ufact.cols ()-long, not Lfact.rows ()-long.

2009-03-10  Jason Riedy  <jason@acm.org>

	* dSparse.cc (SparseMatrix::SparseMatrix (const PermMatrix&)):
	Fix conversion to add values to the matrix as well as getting
	structure correct.

2009-03-10  John W. Eaton  <jwe@octave.org>

	* Array.h, ArrayN.h, Bounds.h, CmplxAEPBAL.h, CmplxCHOL.h,
	CmplxGEPBAL.h, CmplxHESS.h, CmplxQR.h, CmplxQRP.h, CmplxSCHUR.h,
	CmplxSVD.h, CollocWt.h, EIG.h, FEGrid.h, LinConst.h, Range.h,
	Sparse.h, SparseCmplxQR.h, SparseQR.h, dbleAEPBAL.h, dbleCHOL.h,
	dbleGEPBAL.h, dbleHESS.h, dbleQR.h, dbleQRP.h, dbleSCHUR.h,
	dbleSVD.h, dim-vector.h, fCmplxAEPBAL.h, fCmplxCHOL.h,
	fCmplxGEPBAL.h, fCmplxHESS.h, fCmplxQR.h, fCmplxQRP.h,
	fCmplxSCHUR.h, fCmplxSVD.h, fEIG.h, floatAEPBAL.h, floatCHOL.h,
	floatGEPBAL.h, floatHESS.h, floatQR.h, floatQRP.h, floatSCHUR.h,
	floatSVD.h, idx-vector.h, lo-utils.h, oct-inttypes.h,
	oct-spparms.h, str-vec.h: Include <iosfwd> instead of <iosstream>.

2009-03-10  Jaroslav Hajek  <highegg@gmail.com>

	* mx-inlines.cc (OP_CUMMINMAX_FCN2): r -> r0 where appropriate.

2009-03-08  Jaroslav Hajek  <highegg@gmail.com>

	* idx-vector.h (idx_vector::bloop): loop --> bloop.
	(idx_vector::loop): New method.
	* MArray.cc (MArray<T>::idx_add (cons idx_vector&, T))
	(MArray<T>::idx_add (cons idx_vector&, const MArray<T>&)): New methods.
	* MArray.h: Declare them.

2009-03-05  Jason Riedy  <jason@acm.org>

	* Sparse.h (Sparse<T>::elt_type): Remove typedef, replace with:
	* Sparse.h (Sparse<T>::element_type): Add typedef to be consistent
	with Array.h
	* DiagArray2.h (DiagArray2<T>::elt_type): Likewise, removed.
	* DiagArray2.h (DiagArray2<T>::element_type): Define by using
	Array<T>::element_type.
	* intNDArray.h (intNDArray<T>::element_type): Remove, inherited
	from MArrayN<T>.

2009-03-05  Jaroslav Hajek  <highegg@gmail.com>

	* dSparse.h (SparseMatrix::SparseMatrix(const PermMatrix&)): New
	constructor.
	(SparseMatrix::SparseMatrix(const DiagMatrix&)): Fix implementation.
	* CSparse.h (SparseComplexMatrix::SparseComplexMatrix(const ComplexDiagMatrix&)):
	Fix implementation.

2009-03-04  Jaroslav Hajek  <highegg@gmail.com>

	* PermMatrix.h (PermMatrix::elem): Fix comparisons.

2009-03-03  Jaroslav Hajek  <highegg@gmail.com>

	* lo-mappers.cc (xmin (float, float), xmax (float, float)): Simplify.

2009-03-02  Jaroslav Hajek  <highegg@gmail.com>

	* mx-inlines.cc: Add missing #include.

2009-02-25  John W. Eaton  <jwe@octave.org>

	* Makefile.in: Make maintainer-clean and distclean the same.

2009-02-25  Jaroslav Hajek  <highegg@gmail.com>

	* oct-inttypes.cc (pow (const octave_int<T>&, const octave_int<T>&)):
	Simplify.

2009-02-23  Jaroslav Hajek  <highegg@gmail.com>

	* oct-inttypes.h (octave_int_cmp_op::mop): Implement as simple
	forwarders when OCTAVE_INT_USE_LONG_DOUBLE is not defined.
	(octave_int_cmp_op::emulate_mop): New static overloaded template
	member function.
	* oct-inttypes.cc: Turn the octave_int_cmp_op::mop definitions into
	defs for octave_int_cmp_op::emulate_mop.
	(INSTANTIATE_INT64_DOUBLE_CMP_OP0): Instantiate
	octave_int_cmp_op::emulate_op instead.

2009-02-23  Jaroslav Hajek  <highegg@gmail.com>

	* dDiagMatrix.cc (DiagMatrix::pseudo_inverse): New method.
	* dDiagMatrix.h: Declare it.
	* fDiagMatrix.cc (FloatDiagMatrix::pseudo_inverse): New method.
	* fDiagMatrix.h: Declare it.
	* CDiagMatrix.cc (ComplexDiagMatrix::pseudo_inverse): New method.
	* CDiagMatrix.h: Declare it.
	* fCDiagMatrix.cc (FloatComplexDiagMatrix::pseudo_inverse): New method.
	* fCDiagMatrix.h: Declare it.

2009-02-20  Jaroslav Hajek  <highegg@gmail.com>

	* oct-sort.h (octave_sort<T>::MergeState::MergeState): New
	constructor.
	(octave_sort<T>::MergeState::~MergeState): New destructor.
	(octave_sort<T>::MergeState::reset,
	octave_sort<T>::MergeState::getmem,
	octave_sort<T>::MergeState::getmemi): New methods.
	(octave_sort<T>::sort,
	octave_sort<T>::merge_lo, octave_sort<T>::merge_hi
	octave_sort<T>::merge_at): Reflect change.

2009-02-19  Jaroslav Hajek  <highegg@gmail.com>

	* oct-types.h (sortmode): Move enum here.
	* oct-sort.h (octave_sort<T>::ms): Declare as pointer.
	(octave_sort<T>::lookup): New overloaded method.
	* oct-sort.cc: Reflect change to ms.
	(octave_sort<T>::lookup): New overloaded method.
	(out_of_range_pred): New helper class.
	(out_of_range): New helper function.
	* oct-lookup.h: Remove file.
	* Array.cc (Array<T>::lookup): New overloaded method.
	* Array.h: Declare it.

2009-02-18  John W. Eaton  <jwe@octave.org>

	* dbleQR.cc (QR::init, QR::form): Cast int to octave_idx_type in
	call to std::max.
	* floatQR.cc (FloatQR::init, FloatQR::form): Ditto.
	* CmplxQR.cc (ComplexQR::init, ComplexQR::form): Ditto.
	* fCmplxQR.cc (FloatComplexQR::init, FloatComplexQR::form): Ditto.

	* dbleQRP.cc (QRP::init): Cast int to octave_idx_type in call to
	std::max and as operand to -= operator.
	* CmplxQRP.cc (ComplexQRP::init): Ditto.
	* floatQRP.cc (FloatQRP::init): Ditto.
	* fCmplxQRP.cc (FloatComplexQRP::init): Ditto.

	* CDiagMatrix.cc, CDiagMatrix.h (ComplexDiagMatrix::inverse):
	Declare info as octave_idx_type, not int.
	* dDiagMatrix.cc, dDiagMatrix.h (DiagMatrix::inverse): Ditto.
	* fDiagMatrix.cc, fCDiagMatrix.h (FloatDiagMatrix::inverse): Ditto.
	* fCDiagMatrix.cc, fCDiagMatrix.h (FloatComplexDiagMatrix::inverse):
	Ditto.

	* dMatrix.cc (Matrix::determinant):
	Declare local variables volatile as needed to avoid "maybe
	clobbered by vfork" warning from GCC.
	* fMatrix.cc (FloatMatrix::determinant): Likewise.
	* CMatrix.cc (ComplexMatrix::determinant): Likewise.
	* fCMatrix.cc (FloatComplexMatrix::determinant): Likewise.
	* dbleQR.cc (QR::update, QR::insert_col, QR::delete_col): Likewise.
	* floatQR.cc (FloatQR::update, FloatQR::insert_col,
	FloatQR::delete_col): Likewise.
	* CmplxQR.cc (ComplexQR::update, ComplexQR::insert_col,
	ComplexQR::delete_col): Likewise.
	* fCmplxQR.cc (FloatComplexQR::update, FloatComplexQR::insert_col,
	FloatComplexQR::delete_col): Likewise.

	* dMatrix.cc (padec, solve_singularity_warning): Delete unused
	static variable and function.
	* CMatrix.cc (padec, solve_singularity_warning): Ditto.
	* fMatrix.cc (padec, solve_singularity_warning): Ditto.
	* fCMatrix.cc (padec, solve_singularity_warning): Ditto.

2009-02-18  Jaroslav Hajek  <highegg@gmail.com>

	* Array.cc (Array<T>::resize (const dim_vector&)): Check for negative
	dimensions.

2009-02-18  Jaroslav Hajek  <highegg@gmail.com>

	* oct-inttypes.cc (pow (const octave_int<T>&, const octave_int<T>&)):
	Use octave_int comparisons to avoid warning for unsigned types.

2009-02-17  Jaroslav Hajek  <highegg@gmail.com>

	* Array.cc (Array<T>::resize (const dim_vector&)): Remove dead branch.

2009-02-17  Jaroslav Hajek  <highegg@gmail.com>

	* mx-inlines.cc (OP_CUM_FCN, OP_CUM_FCN2, OP_CUM_FCNN):
	Add TSRC/TRES parameters.
	(mx_inline_cumcount): New function.
	* intNDArray.cc (intNDArray::cumsum): New method.
	* intNDArray.h: Declare it.
	* boolNDArray.cc (boolNDArray::cumsum): New method.
	* boolNDArray.h: Declare it.

2009-02-17  Jaroslav Hajek  <highegg@gmail.com>

	* mx-inlines.cc (OP_CUMMINMAX_FCN, OP_CUMMINMAX_FCN2,
	OP_CUMMINMAX_FCNN): New macros.
	(mx_inline_cummax, mx_inline_cummin, do_mx_cumminmax_op):
	New overloaded template functions.

	* dNDArray.cc (NDArray::cummin, NDArray::cummax): New methods.
	* dNDArray.h: Declare them.

	* fNDArray.cc (FloatNDArray::cummin, FloatNDArray::cummax): New
	methods.
	* fNDArray.h: Declare them.

	* CNDArray.cc (ComplexNDArray::cummin, ComplexNDArray::cummax): New
	methods.
	* CNDArray.h: Declare them.

	* fCNDArray.cc (FloatComplexNDArray::cummin,
	FloatComplexNDArray::cummax): New methods.
	* fCNDArray.h: Declare them.

	* intNDArray.cc (intNDArray::cummin, intNDArray::cummax): New methods.
	* intNDArray.h: Declare them.

2009-02-17  Jaroslav Hajek  <highegg@gmail.com>

	* mx-inlines.cc (OP_MINMAX_FCN): Correct behaviour with NaNs.

2009-02-17  Jaroslav Hajek  <highegg@gmail.com>

	* MArray-defs.h: Move declarative part to MArray-decl.h
	* MArray-decl.h: New source.

	* mx-op-defs.h: Move declarative part to mx-op-decl.h.
	* mx-op-decl.h: New source.

	* Makefile.in: Include new sources in build.
	* mk-ops.awk: Include mx-op-decl.h in headers, mx-op-defs in .cc
	files.

	* CMatrix.cc, CMatrix.h, CNDArray.cc, CNDArray.h, MArray.h, MArray2.h,
	MArrayN.h, MDiagArray2.h, boolMatrix.cc, boolMatrix.h, boolNDArray.cc,
	boolNDArray.h, chMatrix.cc, chMatrix.h, chNDArray.cc, chNDArray.h,
	dMatrix.cc, dMatrix.h, dNDArray.cc, dNDArray.h, fCMatrix.cc,
	fCMatrix.h, fCNDArray.cc, fCNDArray.h, fMatrix.cc, fMatrix.h,
	fNDArray.cc, fNDArray.h, int16NDArray.cc, int16NDArray.h,
	int32NDArray.cc, int32NDArray.h, int64NDArray.cc, int64NDArray.h,
	int8NDArray.cc, int8NDArray.h, uint16NDArray.cc, uint16NDArray.h,
	uint32NDArray.cc, uint32NDArray.h, uint64NDArray.cc, uint64NDArray.h,
	uint8NDArray.cc, uint8NDArray.h: Ditto.

2009-02-16  Jaroslav Hajek  <highegg@gmail.com>

	* Array.cc (Array<T>::assign (const idx_vector& i,
	const idx_vector& j,...)): Fix invalid dimension inquiry.

2009-02-16  Jaroslav Hajek  <highegg@gmail.com>

	* mx-inlines.cc (OP_ROW_SHORT_CIRCUIT): New macro.
	(mx_inline_any, mx_inline_all): Override row-reduction case.
	(MX_CUMULATIVE_OP, MX_BASE_REDUCTION_OP, MX_REDUCTION_OP,
	MX_ANY_OP, MX_ALL_OP, MX_ND_ANY_ALL, MX_ND_REDUCTION,
	MX_ND_COMPLEX_OP_REDUCTION, MX_ND_CUMULATIVE_OP,
	MX_ND_ANY_EVAL, MX_ND_ALL_EVAL, MX_ND_REAL_OP_REDUCTION):
	Remove unused macros.

2009-02-16  Jaroslav Hajek  <highegg@gmail.com>

	* mx-inlines.cc (OP_RED_FCNN): Use explicit type qualification.
	(mx_inline_count): New overloaded template function.
	* boolNDArray.h (boolNDArray::sum): Return NDArray.
	* boolNDArray.cc (boolNDArray::sum): Return NDArray, use do_mx-red_op.

2009-02-16  Jaroslav Hajek  <highegg@gmail.com>

	* Array-C.cc, Array-fC.cc: Don't redefine complex comparison.
	* Sparse.cc (Sparse::sort): Don't use vec_index.
	* Sparse-C.cc, Sparse-d.cc, Sparse-b.cc: Don't reinstantiate
	octave_sort, reflect changes.
	* sparse-sort.cc: Explicitly instantiate octave_sort for requested
	pointer types.

2009-02-16  Jaroslav Hajek  <highegg@gmail.com>

	* oct-cmplx.h (operator <, operator >): New operators.
	* mx-inlines.cc (OP_MINMAX_FCN, OP_MINMAX_FCN2, OP_MINMAX_FCNN):
	New macros.
	(mx_inline_min, mx_inline_max, do_mx_minmax_op): New overloaded
	template functions.
	* dNDArray (NDArray::min, NDArray::max): Use do_mx_minmax_op.
	* fNDArray (FloatNDArray::min, FloatNDArray::max): Ditto.
	* CNDArray (ComplexNDArray::min, ComplexNDArray::max): Ditto.
	* fCNDArray (FloatComplexNDArray::min, FloatComplexNDArray::max):
	Ditto.

2009-02-16  Jaroslav Hajek  <highegg@gmail.com>

	* chMatrix.cc (charMatrix::all, charMatrix::any): Use do_mx_red_op.
	* chNDArray.cc (charNDArray::all, charNDArray::any): Ditto.

2009-02-16  John W. Eaton  <jwe@octave.org>

	* cmd-edit.cc (default_command_editor::do_readline):
	Use fputs instead of fprintf.

2009-02-14  Jaroslav Hajek  <highegg@gmail.com>

	* mx-inlines.cc (OP_RED_FCN, OP_RED_FCN2, OP_RED_FCNN, OP_CUM_FCN,
	OP_CUM_FCN2, OP_CUM_FCNN): Include TRET parameter.
	(OP_RED_ANYC, OP_RED_ANYR, OP_RED_ALLC, OP_RED_ALLR): New macros.
	(is_true, is_false): New template functions.
	(mx_inline_any, mx_inline_all): New template functions.

	* dMatrix.cc (Matrix::any, Matrix::all): Use do_mx_red_op and
	do_mx_cum_op.
	* fMatrix.cc (FloatMatrix::any, FloatMatrix::all): Use do_mx_red_op
	and do_mx_cum_op.
	* CMatrix.cc (ComplexMatrix::any, ComplexMatrix::all): Use
	do_mx_red_op and do_mx_cum_op.
	* fCMatrix.cc (FloatComplexMatrix::any, FloatComplexMatrix::all): Use
	do_mx_red_op and do_mx_cum_op.

	* dNDArray.cc (NDArray::any, NDArray::all): Use do_mx_red_op and
	do_mx_cum_op.
	* fNDArray.cc (FloatNDArray::any, FloatNDArray::all): Use do_mx_red_op
	and do_mx_cum_op.
	* CNDArray.cc (ComplexNDArray::any, ComplexNDArray::all): Use
	do_mx_red_op and do_mx_cum_op.
	* fCNDArray.cc (FloatComplexNDArray::any, FloatComplexNDArray::all):
	Use do_mx_red_op and do_mx_cum_op.

	* intNDArray.cc (intNDArray::any, intNDArray::all): Use do_mx_red_op and
	do_mx_cum_op.

	* boolNDArray.cc (boolNDArray::any, boolNDArray::all): Use do_mx_red_op and
	do_mx_cum_op.

	* boolMatrix.cc (boolMatrix::any, boolMatrix::all): Use do_mx_red_op and
	do_mx_cum_op.

2009-02-14  Jaroslav Hajek  <highegg@gmail.com>

	* intNDArray.cc: include mx-inlines.cc.
	(intNDArray::sum): Use mx_do_red_op (..., mx_inline_sum).
	* Range.cc (Range::is_sorted): Add missing return statement.

2009-02-13  Jaroslav Hajek  <highegg@gmail.com>

	* mx-inlines.cc (OP_RED_SUM, OP_RED_PROD, OP_RED_SUMSQ, OP_RED_SUMSQC,
	OP_RED_FCN, OP_RED_FCN2, OP_RED_FCNN, OP_CUM_FCN, OP_CUM_FCN2,
	OP_CUM_FCNN): New macros.
	(mx_inline_sum, mx_inline_prod, mx_inline_sumsq, mx_inline_cumsum,
	mx_inline_cumprod, get_extent_triplet, do_mx_red_op, do_mx_cum_op):
	New template functions.
	* dMatrix.cc (Matrix::cumprod, Matrix::cumsum, Matrix::prod,
	Matrix::sum, Matrix::sumsq): Use do_mx_red_op and do_mx_cum_op.
	* fMatrix.cc (FloatMatrix::cumprod, FloatMatrix::cumsum,
	FloatMatrix::prod, FloatMatrix::sum, FloatMatrix::sumsq): Use
	do_mx_red_op and do_mx_cum_op.
	* CMatrix.cc (ComplexMatrix::cumprod, ComplexMatrix::cumsum,
	ComplexMatrix::prod, ComplexMatrix::sum, ComplexMatrix::sumsq): Use
	do_mx_red_op and do_mx_cum_op.
	* fCMatrix.cc (FloatComplexMatrix::cumprod,
	FloatComplexMatrix::cumsum, FloatComplexMatrix::prod,
	FloatComplexMatrix::sum, FloatComplexMatrix::sumsq): Use do_mx_red_op
	and do_mx_cum_op.

2009-02-12  Jaroslav Hajek  <highegg@gmail.com>

	* oct-inttypes.h (if_else_type): Remove
	(octave_int_base::truncate_int): Use if_then_else.

2009-02-12  John W. Eaton  <jwe@octave.org>

	* lo-traits.h: New file.
	* Makefile.in (INCLUDES): Add it to the list.

	* Array.h (compare_fcn_type): New typedef.
	* oct-sort.h (compare_fcn_type): Ditto.

	* oct-sort.h, oct-sort.cc (octave_sort<T>::octave_sort,
	octave_sort<T>::set_compare, octave_sort<T>::compare):
	Use typedef to simplify decl.
	(octave_sort<T>::ascending_compare,
	octave_sort<T>::descending_compare):
	Use ref_param<T>::type for parameter decl.

	* Array.cc (sort_isnan): Use ref_param<T>::type for parameter decl.
	(Array<T>::sort): Use explicit template parameter for sort_isnan calls.

	* Array.cc, Array-C.cc, Array-fC.cc, Array-d.cc, Array-f.cc
	(sortrows_comparator): Rename from _sortrows_comparator.  Change
	all uses.  Use typedef for return value to simplify decl.
	(sort_isnan): Rename from _sort_isnan.  Change all uses.
	(NO_INSTANTIATE_ARRAY_SORT): Use typedef to simplify instantiation
	of sortrows_comparator.

	* Array-C.cc, Array-fC.cc (sort_isnan, ascending_compare,
	descending_compare, nan_ascending_compare,
	nan_descending_compare):

2009-02-11  Jaroslav Hajek  <highegg@gmail.com>

	* oct-sort.cc (octave_sort<T>::is_sorted, octave_sort<T>::sort_rows,
	octave_sort<T>::is_sorted_rows): New methods.
	* oct-sort.h: Declare them.

	* Array.cc (Array<T>::is_sorted): New method.
	(INSTANTIATE_ARRAY_SORT, NO_INSTANTIATE_ARRAY_SORT,
	INSTANTIATE_ARRAY_AND_ASSIGN, INSTANTIATE_ARRAY): Move macros here.
	* Array.h: Reflect changes.

	* dim-vector.h (dim_vector::is_vector): New method.
	* Array-C.cc, Array-fC.cc: Override _sort_isnan, don't check for
	NaN in default comparators. Provide NaN-safe comparators, override
	_sortrows_comparator.
	* Array-d.cc, Array-f.cc: Provide NaN-safe comparators, override
	_sortrows_comparator.
	* Range.cc (Range::is_sorted): New method.
	* Range.h: Declare it.

2009-02-09  Jaroslav Hajek  <highegg@gmail.com>

	* oct-sort.cc (octave_sort<T>): Rewrite for optimizations. Allow
	inlined comparison functor and by-the-way indexed sorting.
	* oct-sort.h (octave_sort<T>): Update interface.
	* Array.cc (Array<T>::sort): Reflect changes. Use copy & partition
	mechanism.
	* Array-d.cc, Array-f.cc, Array-C.cc, Array-fC.cc, Array-s.cc,
	Array-i.cc: Reflect changes.

2009-02-05  John W. Eaton  <jwe@octave.org>

	* file-stat.cc (base_file_stat::is_sock):
	Use EXISTS instead of OK in previous change.

	* file-stat.cc (base_file_stat::is_blk, base_file_stat::is_chr,
	base_file_stat::is_dir, base_file_stat::is_fifo,
	base_file_stat::is_lnk, base_file_stat::is_reg,
	base_file_stat::is_sock): Return false if object is not initialized.
	From Rafael Laboissiere <rafael@debian.org>.

2009-02-05  Jaroslav Hajek  <highegg@gmail.com>

	* idx-vector.h (idx_vector::idx_colon_rep,
	idx_vector::idx_scalar_rep, idx_vector::idx_range_rep,
	idx_vector::idx_vector_rep): Declare allocators.
	* idx-vector.cc: Define them.

2009-02-05  Jaroslav Hajek  <highegg@gmail.com>

	* str-vec.h (string_vector::sort): Remove implementation.
	* str-vec.cc (string_vector::sort): Move here. Use in-place sorting.
	* Array-str.cc: Fix order of header files.
	* oct-sort.cc (octave_sort<T>::merge_hi): std::copy ->
	std::copy_backward where appropriate.

2009-02-05  John W. Eaton  <jwe@octave.org>

	* Array-util.cc (zero_dims_inquire): Eliminate unused variable MATCH.

	* Sparse.cc (assign (Sparse<LT>& lhs, const Sparse<RT>& rhs)):
	Eliminate unused variable N.

	* MArray-f.cc (MArray<float>::norm (float p) const,
	MArray<FloatComplex>::norm (float p) const): Pass P to xnorm.

	* eigs-base.cc (EigsRealNonSymmetricFunc, EigsRealSymmetricFunc)
	(EigsComplexNonSymmetricFunc): Avoid unused parameter warning.
	* idx-vector.cc (idx_vector::freeze): Likewise.

2009-02-04  Jaroslav Hajek  <highegg@gmail.com>

	* oct-locbuf.h: Specialize OCTAVE_LOCAL_BUFFER to use chunked
	allocation for pointers and const pointers.

2009-02-03  Benjamin Lindner  <lindnerben@gmx.net>

	* Makefile.in: Add missing library reference.

2009-02-03  Jaroslav Hajek  <highegg@gmail.com>

	* Array.cc (Array<T>::sort (octave_idx_type, sortmode)):
	Copy array on-the-fly.
	(Array<T>::sort (Array<octave_idx_type> &, octave_idx_type, sortmode)):
	Copy array on-the-fly, use bare pointers rather than vec_index.

	* Array-d.cc (Array<double>::sort (octave_idx_type, sortmode)):
	Copy array on-the-fly.
	(Array<double>::sort (Array<octave_idx_type> &, octave_idx_type, sortmode)):
	Copy array on-the-fly, use bare pointers rather than vec_index.

	* Array-f.cc (Array<float>::sort (octave_idx_type, sortmode)):
	Copy array on-the-fly.
	(Array<float>::sort (Array<octave_idx_type> &, octave_idx_type, sortmode)):
	Copy array on-the-fly, use bare pointers rather than vec_index.

2009-02-02  Jaroslav Hajek  <highegg@gmail.com>

	* mx-inlines.cc (mx_inline_fabs_dup, mx_inline_cabs_dup): New funcs.

	* dMatrix.cc (real, imag, Matrix::abs): Simplify.
	* fMatrix.cc (real, imag, FloatMatrix::abs): Simplify.
	* CMatrix.cc (ComplexMatrix::abs, ComplexMatrix::conj): Simplify.
	* fCMatrix.cc (FloatComplexMatrix::abs, FloatComplexMatrix::conj): Simplify.

	* CMatrix.h, fCMatrix.h (conj): Add missing decl.

	* dNDArray.cc (real, imag, NDArray::abs): Simplify.
	* fNDArray.cc (real, imag, FloatNDArray::abs): Simplify.
	* CNDArray.cc (ComplexNDArray::abs, ComplexNDArray::conj): Simplify.
	* fCNDArray.cc (FloatComplexNDArray::abs, FloatComplexNDArray::conj): Simplify.

	* CMatrix.h, fCMatrix.h (conj): New decl.

2009-01-29  John W. Eaton  <jwe@octave.org>

	* intNDArray.h (intNDArray<T>:any_element_is_nan): New function.
	* boolNDArrah.h (boolNDArray::any_element_is_nan): New function.
	* chNDArray.h (charNDArray::any_element_is_nan): New function.

2009-01-28  John W. Eaton  <jwe@octave.org>

	* Makefile.in (LIBRARIES, install, uninstall): Use SHLLIBPRE
	and SHLBINPRE library prefixes.
	From Marco Atzeri <marco_atzeri@yahoo.it>.

2009-01-28  Jaroslav Hajek  <highegg@gmail.com>

	* dMatrix.cc (Matrix::Matrix (const RowVector&)): Use shallow copy.
	(Matrix::Matrix (const ColumnVector&)): Ditto.
	(Matrix::row): Ditto.
	(Matrix::column): Ditto.

	* fMatrix.cc (FloatMatrix::FloatMatrix (const FloatRowVector&)): Use
	shallow copy.
	(FloatMatrix::FloatMatrix (const FloatColumnVector&)): Ditto.
	(FloatMatrix::row): Ditto.
	(FloatMatrix::column): Ditto.

	* CMatrix.cc (ComplexMatrix::ComplexMatrix (const ComplexRowVector&)):
	Use shallow copy.
	(ComplexMatrix::ComplexMatrix (const ComplexColumnVector&)): Ditto.
	(ComplexMatrix::row): Ditto.
	(ComplexMatrix::column): Ditto.

	* fCMatrix.cc (FloatComplexMatrix::FloatComplexMatrix (const FloatComplexRowVector&)):
	Use shallow copy.
	(FloatComplexMatrix::FloatComplexMatrix (const FloatComplexColumnVector&)): Ditto.
	(FloatComplexMatrix::row): Ditto.
	(FloatComplexMatrix::column): Ditto.

2009-01-27  Benjamin Lindner  <lindnerb@users.sourceforge.net>

	* Makefile.in (LINK_DEPS): Include ARPACK_LIBS and REGEX_LIBS in
	the list.

2009-01-27  Jaroslav Hajek  <highegg@gmail.com>

	* dbleQR.cc (QR::init): Use form. Use local buffers.
	Query for optimal block size.
	(QR::form): New function.
	* dbleQR.h: Declare it.
	* dbleQRP.cc (QRP::init):Use form. Use local buffers.
	Query for optimal block size.

	* floatQR.cc (FloatQR::init): Use form. Use local buffers.
	Query for optimal block size.
	(FloatQR::form): New function.
	* floatQR.h: Declare it.
	* floatQRP.cc (FloatQRP::init):Use form. Use local buffers.
	Query for optimal block size.

	* CmplxQR.cc (ComplexQR::init): Use form. Use local buffers.
	Query for optimal block size.
	(ComplexQR::form): New function.
	* CmplxQR.h: Declare it.
	* CmplxQRP.cc (ComplexQRP::init):Use form. Use local buffers.
	Query for optimal block size.

	* fCmplxQR.cc (FloatComplexQR::init): Use form. Use local buffers.
	Query for optimal block size.
	(FloatComplexQR::form): New function.
	* fCmplxQR.h: Declare it.
	* fCmplxQRP.cc (FloatComplexQRP::init):Use form. Use local buffers.
	Query for optimal block size.

2009-01-23  Jaroslav Hajek  <highegg@gmail.com>

	* Array.cc (Array<T>::assign (const idx_vector&, const Array<T>&)):
	Optimize assignment to an empty array.
	(Array<T>::assign (const idx_vector&, const idx_vector&, const Array<T>&)):
	Optimize assignment to an empty array.

2009-01-22  Jaroslav Hajek  <highegg@gmail.com>

	* Array2.h (Array2<T>::index): Declare resize_ok as bool.
	* ArrayN.h (ArrayN<T>::index): Ditto. Declare index vectors as const
	refs.

2009-01-22  Jaroslav Hajek  <highegg@gmail.com>

	* Range.cc (sort_internal): Add missing test.

2009-01-22  Jaroslav Hajek  <highegg@gmail.com>

	* Array.cc (Array<T>::index (..., bool resize_ok)):
	Optimize the all-scalar-indices cases.

2009-01-22  Jaroslav Hajek  <highegg@gmail.com>

	* dbleQR.h: Optionally declare warn_qrupdate_once.
	* dbleQR.cc: Define it.
	* (CmplxQR.h, dbleQR.h, fCmplxQR.h, floatQR.h): Declare replacement
	methods unconditionally.
	* (CmplxQR.cc, dbleQR.cc, fCmplxQR.cc, floatQR.cc): Define
	updating replacement methods.
	* (CmplxCHOL.h, dbleCHOL.h, fCmplxCHOL.h, floatCHOL.h): Declare
	replacement methods unconditionally.
	* (CmplxCHOL.cc, dbleCHOL.cc, fCmplxCHOL.cc, floatCHOL.cc): Define
	updating replacement methods.

2009-01-21  Jaroslav Hajek  <highegg@gmail.com>

	* Range.cc ( operator + (double x, const Range& r),
	operator + (const Range& r, double x),
	operator - (double x, const Range& r),
	operator - (const Range& r, double x),
	operator * (double x, const Range& r),
	operator * (const Range& r, double x)): New operators.
	* Range.h: Declare them.

2009-01-20  John W. Eaton  <jwe@octave.org>

	* file-stat.h, file-stat.cc (class base_file_stat): New base class.
	(class file_stat): Derive from base_file_stat.
	(class file_fstat): New class, derived from base_file_stat.

2009-01-17  Jaroslav Hajek  <highegg@gmail.com>

	* floatQR.h (FloatQR::update, FloatQR::insert_col,
	FloatQR::insert_row, FloatQR::delete_col, FloatQR::delete_row,
	FloatQR::shift_col): Update interfaces.

	* floatQR.cc: Update external decls for qrupdate routines.
	(FloatQR::update, FloatQR::insert_col, FloatQR::insert_row,
	FloatQR::delete_col, FloatQR::delete_row, FloatQR::shift_col): Reflect
	changes in qrupdate interfaces, implement batch updates.

	* dbleQR.h (QR::update, QR::insert_col, QR::insert_row,
	QR::delete_col, QR::delete_row, QR::shift_col): Update interfaces.

	* dbleQR.cc: Update external decls for qrupdate routines.
	(QR::update, QR::insert_col, QR::insert_row, QR::delete_col,
	QR::delete_row, QR::shift_col): Reflect changes in qrupdate
	interfaces, implement batch updates.

	* fCmplxQR.h (FloatComplexQR::update, FloatComplexQR::insert_col,
	FloatComplexQR::insert_row, FloatComplexQR::delete_col,
	FloatComplexQR::delete_row, FloatComplexQR::shift_col): Update
	interfaces.

	* fCmplxQR.cc: Update external decls for qrupdate routines.
	(FloatComplexQR::update, FloatComplexQR::insert_col,
	FloatComplexQR::insert_row, FloatComplexQR::delete_col,
	FloatComplexQR::delete_row, FloatComplexQR::shift_col): Reflect
	changes in qrupdate interfaces,
	implement batch updates.

	* CmplxQR.h (ComplexQR::update, ComplexQR::insert_col,
	ComplexQR::insert_row, ComplexQR::delete_col, ComplexQR::delete_row,
	ComplexQR::shift_col): Update interfaces.

	* CmplxQR.cc: Update external decls for qrupdate routines.
	(ComplexQR::update, ComplexQR::insert_col,
	ComplexQR::insert_row, ComplexQR::delete_col, ComplexQR::delete_row,
	ComplexQR::shift_col): Reflect changes in qrupdate interfaces,
	implement batch updates.

	* floatCHOL.h (FloatCHOL::update, FloatCHOL::downdate,
	FloatCHOL::insert_sym): Update interfaces.
	* floatCHOL.cc: Update external decls for qrupdate routines.
	(FloatCHOL::update, FloatCHOL::downdate, FloatCHOL::insert_sym,
	FloatCHOL::delete_sym, FloatCHOL::shift_sym): Reflect changes in
	qrupdate interfaces,

	* CHOL.h (CHOL::update, CHOL::downdate, CHOL::insert_sym): Update
	interfaces.
	* CHOL.cc: Update external decls for qrupdate routines.
	(CHOL::update, CHOL::downdate, CHOL::insert_sym, CHOL::delete_sym,
	CHOL::shift_sym): Reflect changes in qrupdate interfaces,

	* fCmplxCHOL.h (FloatComplexCHOL::update, FloatComplexCHOL::downdate,
	FloatComplexCHOL::insert_sym): Update interfaces.
	* fCmplxCHOL.cc: Update external decls for qrupdate routines.
	(FloatComplexCHOL::update, FloatComplexCHOL::downdate,
	FloatComplexCHOL::insert_sym, FloatComplexCHOL::delete_sym,
	FloatComplexCHOL::shift_sym): Reflect changes in qrupdate interfaces,

	* CmplxCHOL.h (ComplexCHOL::update, ComplexCHOL::downdate,
	ComplexCHOL::insert_sym): Update interfaces.
	* CmplxCHOL.cc: Update external decls for qrupdate routines.
	(ComplexCHOL::update, ComplexCHOL::downdate, ComplexCHOL::insert_sym,
	ComplexCHOL::delete_sym, ComplexCHOL::shift_sym): Reflect changes in
	qrupdate interfaces,

2009-01-17  Jaroslav Hajek  <highegg@gmail.com>

	* Array.h (Array<T>): Document internal use of slice_data and
	slice_len.

2009-01-15  John W. Eaton  <jwe@octave.org>

	* Sparse.cc (Sparse<T>::reshape): Include mismatched dimensions in
	error message.
	* Array.cc (Array<T>::reshape): Likewise.
	From Robert Millan <rmh@aybabtu.com>.

2009-01-14  Jaroslav Hajek  <highegg@gmail.com>

	* Array.h (Array<T>::rep, Array<T>::dimensions): Make protected.
	* Array.cc (Array<T>::make_unique): Move implementation here.
	(Array<T>::fill): Ditto.
	* DiagArray2.h (DiagArray2<T>): Reimplement without abusing
	Array<T> internals.
	(DiagArray2<T>::operator Array2<T>): New method.
	* DiagArray2.cc (DiagArray2<T>): Update methods.
	* MDiagArray2.h (MDiagArray2<T>::operator Array2<T>): Simplify.
	* PermMatrix.h (PermMatrix): Reimplement without abusing
	Array<T> internals.
	* PermMatrix.cc (PermMatrix): Update methods.

2009-01-14  Jaroslav Hajek  <highegg@gmail.com>

	* Array.cc, Array.h (all Array<T> constructors): Handle slice_data and
	slice_len.
	(Array<T>::Array<T> (const Array<T>&, const dim_vector&,
	octave_idx_type, octave_idx_type)): New constructor.
	(Array<T>::index): Use shallow copy when index reduces to a contiguous
	range.
	(Array<T>::make_unique): Rewrite.
	(Array<T>::ArrayRep): Delete redundant methods.
	(rec_index_helper::is_cont_range): New method.
	(Array<T>::maybe_economize): New method.
	* DiagArray2.cc (DiagArray2<T>::resize): Fix the mess.

2008-01-15  Rafael Laboissiere  <rafael@debian.org>

	* oct-md5.cc: Include <cstdio>.

2009-01-13  Jaroslav Hajek  <highegg@gmail.com>

	* Array.h (Array::ArrayRep::qsort): Remove.
	(Array::qsort): Remove.
	* glob-match.cc (glob_match::glob): qsort -> sort.
	* str-vec.cc (string_vector::compare): Remove.
	* str-vec.h (string_vector::compare): Remove decl.
	(string_vector::qsort): Rename to sort, call Array::sort.

2008-12-23  David Bateman  <dbateman@free.fr>

	* eigs-base.cc: New file with template wrapper for ARPACK.
	* Makefile.in (TEMPLATE_SRC): Add it here.

2008-12-16  Jaroslav Hajek  <highegg@gmail.com>

	* Array.cc (rec_permute_helper): New class.
	(Array<T>::permute): Rewrite using the recursive algorithm.

2008-12-12  David Bateman  <dbateman@free.fr>

	* sparse-base-chol.cc (inverse): Fix inversion based on cholesky
	factorization.

2008-12-12  Jaroslav Hajek  <highegg@gmail.com>

	* oct-locbuf.cc: New source.
	* oct-locbuf.h (octave_chunk_buffer): New class.
	(octave_local_buffer): Subclass from octave_chunk_buffer for selected
	POD types.

2008-12-11  Jaroslav Hajek  <highegg@gmail.com>

	* mx-op-defs.h (DMDM_BIN_OP): Fix invalid buffer length.

2008-12-10  Jaroslav Hajek  <highegg@gmail.com>

	* dMatrix.h, dMatrix.cc (Matrix::expm): Remove.
	* fMatrix.h, fMatrix.cc (FloatMatrix::expm): Remove.
	* CMatrix.h, CMatrix.cc (ComplexMatrix::expm): Remove.
	* fCMatrix.h, fCMatrix.cc (FloatComplexMatrix::expm): Remove.

2008-12-09  Jaroslav Hajek  <highegg@gmail.com>

	* base-aepbal.h: New source.
	* dbleAEPBAL.h, dbleAEPBAL.cc: Rebase AEPBAL on base_aepbal.
	* floatAEPBAL.h, floatAEPBAL.cc: Rebase FloatAEPBAL on base_aepbal.
	* CmplxAEPBAL.h, CmplxAEPBAL.cc: Rebase ComplexAEPBAL on base_aepbal.
	* fCmplxAEPBAL.h, fCmplxAEPBAL.cc: Rebase FloatComplexAEPBAL on base_aepbal.

2008-12-08  Jaroslav Hajek  <highegg@gmail.com>

	* idx-vector.cc (idx_vector::idx_vector_rep::idx_vector_rep (const
	Sparse<bool>&)): New constructor.
	* idx_vector.h: Declare it.
	(idx_vector::idx_vector (const Sparse<bool>&)): New constructor.
	* idx-vector.cc (idx_vector::idx_vector_rep::idx_vector_rep (const
	Array<bool>&)): Fix extent calculation.

2008-12-09  David Bateman  <dbateman@free.fr>

	* Makefile.in (INCLUDES): Add oct-locbuf.h

2008-12-07  Jaroslav Hajek  <highegg@gmail.com>

	* mx-inlines.cc (mx_inline_fill_vs): New template function.
	* mx-op-defs.h (everywhere): Replace int by octave_idx_type.
	(MDM_MULTIPLY_OP): Use mx_inline_mul_vs and mx_inline_fill_vs.
	(DMM_MULTIPLY_OP): Ditto.
	* fDiagMatrix.cc (operator *): Remove redundant ifs.
	* fCDiagMatrix.cc (operator *): Remove redundant ifs.

2008-12-06  Jaroslav Hajek  <highegg@gmail.com>

	* oct-locbuf.h (OCTAVE_LOCAL_BUFFER_INIT): New macro.

2008-10-29  Jaroslav Hajek  <highegg@gmail.com>

	* oct-locbuf.h: New header file.
	* Array-d.cc, Array-f.cc, Array.cc, CMatrix.cc, CNDArray.cc,
	CSparse.cc, CmplxCHOL.cc, CmplxGEPBAL.cc, MatrixType.cc,
	Sparse-op-defs.h, Sparse.cc, SparseCmplxLU.cc, SparseCmplxQR.cc,
	SparseQR.cc, SparsedbleLU.cc, dMatrix.cc, dNDArray.cc, dSparse.cc,
	data-conv.cc, dbleCHOL.cc, dbleGEPBAL.cc, fCMatrix.cc, fCNDArray.cc,
	fCmplxCHOL.cc, fCmplxGEPBAL.cc, fMatrix.cc, fNDArray.cc, file-ops.cc,
	floatCHOL.cc, floatGEPBAL.cc, lo-sysdep.cc, oct-fftw.cc, oct-md5.cc,
	oct-rand.cc, regex-match.cc, sparse-dmsolve.cc: Include oct-locbuf.h.

2008-12-04  Jaroslav Hajek  <highegg@gmail.com>

	* DiagArray2.h (DiagArray2<T>): Inherit Array<T> privately.
	(DiagArray2<T>::dim1, dim2, rows, columns, cols, length,
	nelem, numel, byte_size, dims): New methods.
	(DiagArray2<T>::diag): New method decl.
	* DiagArray2.cc (DiagArray2<T>::diag): New method.
	* MDiagArray2.h (MDiagArray2<T>::diag): New method.
	* dDiagMatrix.cc (DiagMatrix::diag): Remove.
	* fDiagMatrix.cc (FloatDiagMatrix::diag): Remove.
	* CDiagMatrix.cc (ComplexDiagMatrix::diag): Remove.
	* fCDiagMatrix.cc (FloatComplexDiagMatrix::diag): Remove.

	* PermMatrix.h (PermMatrix): Inherit Array<octave_idx_type> privately.
	(PermMatrix::dim1, dim2, rows, columns, cols, length,
	nelem, numel, byte_size, dims): New methods.


2008-12-04  Jaroslav Hajek  <highegg@gmail.com>

	* dDiagMatrix.cc (DiagMatrix::determinant, DiagMatrix::rcond): New
	method.
	* dDiagMatrix.h: Declare them.
	* fDiagMatrix.cc (FloatDiagMatrix::determinant,
	FloatDiagMatrix::rcond): New methods.
	* fDiagMatrix.h: Declare them.
	* CDiagMatrix.cc (ComplexDiagMatrix::determinant,
	ComplexDiagMatrix::rcond): New methods.
	* CDiagMatrix.h: Declare them.
	* fCDiagMatrix.cc (FloatComplexDiagMatrix::determinant,
	FloatComplexDiagMatrix::rcond): New methods.
	* fCDiagMatrix.h: Declare them.

2008-12-04  Jaroslav Hajek  <highegg@gmail.com>

	* idx-vector.cc (idx-vector::complement): Add missing delete.

2008-12-04  Jaroslav Hajek  <highegg@gmail.com>

	* dbleQRP.cc (QRP::QRP): Call DGEQP3 rather than DGEQPF.
	* floatQRP.cc (FloatQRP::FloatQRP): Call SGEQP3 rather than SGEQPF.
	* CmplxQRP.cc (ComplexQRP::ComplexQRP): Call ZGEQP3 rather than ZGEQPF.
	* fCmplxQRP.cc (FloatComplexQRP::FloatComplexQRP): Call CGEQP3 rather than CGEQPF.

2008-12-03  Jaroslav Hajek  <highegg@gmail.com>

	* PermMatrix.h, PermMatrix.cc: New sources.
	* MDiagArray2.cc (MDiagArray2<T>::is_multiple_of_identity): New method.
	* MDiagArray2.h (MDiagArray2<T>::is_multiple_of_identity): Declare it.
	* idx-vector.cc (idx_vector::is_permutation): New method.
	* idx-vector.h (idx_vector::is_permutation): Declare it.
	* base-lu.cc (base_lu::getp): New method.
	(base_lu::P): Call getp.
	(base_lu::Pvec): Call getp.
	* base-lu.h (base_lu): Delcare P as PermMatrix. Remove unused template
	params.
	* dbleQRP.cc (dbleQRP::dbleQRP): Construct a permutation matrix.
	(dbleQRP::Pvec): New method.
	* dbleQRP.h: Declare new method. Declare P as PermMatrix.
	* CmplxQRP.cc (ComplexQRP): Likewise.
	* CmplxQRP.h (ComplexQRP): Likewise.
	* floatQRP.cc (FloatQRP): Likewise.
	* floatQRP.h (FloatQRP): Likewise.
	* fCmplxQRP.cc (FloatComplexQRP): Likewise.
	* fCmplxQRP.h (FloatComplexQRP): Likewise.

2008-12-01  Jaroslav Hajek  <highegg@gmail.com>

	* DiagArray2.h (DiagArray2<T>::DiagArray2<T> (const DiagArray2<U>&)): New template
	constructor.
	(DiagArray2<T>::elem, xelem, operator ()): Move to header file to
	enable inlining.
	* DiagArray2.cc (DiagArray2<T>::elem, xelem, operator ()): Remove
	implementations.
	* MDiagArray2.h (MDiagArray2<T>::MDiagArray2<T> (const DiagArray2<U>&)): New template
	constructor.
	(MDiagArray2<T>::nnz): New method.
	* MDiagArray2.cc (MDiagArray2<T>::nnz): Implement it.

	* dDiagMatrix.h (DiagMatrix::DiagMatrix (const DiagArray2<U>&)): New template
	constructor.
	(DiagMatrix::abs): New method decl.
	(real (const ComplexDiagMatrix&), imag (const ComplexDiagMatrix&)):
	New decls.
	* dDiagMatrix.cc (DiagMatrix::abs): New method.
	(operator *(const DiagMatrix&, const DiagMatrix&)): Optimize.
	(real (const ComplexDiagMatrix&), imag (const ComplexDiagMatrix&)):
	New functions.

	* fDiagMatrix.h (FloatDiagMatrix::FloatDiagMatrix (const DiagArray2<U>&)): New template
	constructor.
	(FloatDiagMatrix::abs): New method decl.
	(real (const FloatComplexDiagMatrix&), imag (const FloatComplexDiagMatrix&)):
	New decls.
	* fDiagMatrix.cc (FloatDiagMatrix::abs): New method.
	(operator *(const FloatDiagMatrix&, const FloatDiagMatrix&)): Optimize.
	(real (const FloatComplexDiagMatrix&), imag (const FloatComplexDiagMatrix&)):
	New functions.

	* CDiagMatrix.h (ComplexDiagMatrix::ComplexDiagMatrix (const DiagArray2<U>&)): New template
	constructor.
	(ComplexDiagMatrix::abs): New method decl.
	(conj (const ComplexDiagMatrix&)): Add missing decl.
	(ComplexDiagMatrix::all_elements_are_real): New method decl.

	* CDiagMatrix.cc (CDiagMatrix::abs): New method.
	(operator *(const DiagMatrix&, const ComplexDiagMatrix&)): Optimize.
	(operator *(const ComplexDiagMatrix&, const DiagMatrix&)): Optimize.
	(operator *(const ComplexDiagMatrix&, const ComplexDiagMatrix&)): Optimize.
	(ComplexDiagMatrix::all_elements_are_real): New method.

	* fCDiagMatrix.h (FloatComplexDiagMatrix::FloatComplexDiagMatrix (const DiagArray2<U>&)): New template
	constructor.
	(FloatComplexDiagMatrix::abs): New method decl.
	(conj (const FloatComplexDiagMatrix&)): Add missing decl.
	(FloatComplexDiagMatrix::all_elements_are_real): New method decl.

	* fCDiagMatrix.cc (CDiagMatrix::abs): New method.
	(operator *(const FloatDiagMatrix&, const FloatComplexDiagMatrix&)): Optimize.
	(operator *(const FloatComplexDiagMatrix&, const FloatDiagMatrix&)): Optimize.
	(operator *(const ComplexDiagMatrix&, const ComplexDiagMatrix&)): Optimize.
	(FloatComplexDiagMatrix::all_elements_are_real): New method.

	* dSparse.cc (SparseMatrix::SparseMatrix (const DiagMatrix&)): New
	constructor.
	* dSparse.h (SparseMatrix::SparseMatrix (const DiagMatrix&)): Declare
	it.

	* CSparse.cc (SparseComplexMatrix::SparseComplexMatrix (const ComplexDiagMatrix&)):
	New constructor.
	* CSparse.h (SparseComplexMatrix::SparseComplexMatrix (const ComplexDiagMatrix&)):
	Declare it.
	* mx-op-defs.h (DMM_MULTIPLY_OP, MDM_MULTIPLY_OP): Optimize.

2008-11-21  Jarkko Kaleva  <d3roga@gmail.com>

	* EIG.h (EIG::EIG (const Matrix& a, const Matrix& b,
	bool calc_eigenvectors = true)): New constructor.
	(EIG::EIG (const Matrix& a, const Matrix& b, octave_idx_type& info,
	bool calc_eigenvectors = true)): New constructor.
	(EIG::EIG (const ComplexMatrix& a, const ComplexMatrix& b,
	bool calc_eigenvectors = true)): New constructor.
	(EIG::EIG (const ComplexMatrix& a, const ComplexMatrix& b,
	octave_idx_type& info, bool calc_eigenvectors = true)): New
	constructor.
	* EIG.cc (EIG::init (const Matrix& a, const Matrix& b,
	bool calc_eigenvectors)): New function.
	(EIG::init (const ComplexMatrix& a, const ComplexMatrix& b,
	bool calc_eigenvectors)): New function.
	(EIG::symmetric_init (const Matrix& a, const Matrix& b,
	bool calc_eigenvectors)): New function.
	(EIG::hermitian_init (const ComplexMatrix& a, const ComplexMatrix& b,
	bool calc_eigenvectors)): New function.
	* fEIG.h (fEIG::fEIG (const FloatMatrix& a, const FloatMatrix& b,
	bool calc_eigenvectors = true)): New constructor.
	(fEIG::fEIG (const FloatMatrix& a, const FloatMatrix& b,
	octave_idx_type& info, bool calc_eigenvectors = true)): New
	constructor.
	(fEIG::fEIG (const FloatComplexMatrix& a, const FloatComplexMatrix& b,
	bool calc_eigenvectors = true)): New constructor.
	(fEIG::fEIG (const FloatComplexMatrix& a, const FloatComplexMatrix& b,
	octave_idx_type& info, bool calc_eigenvectors = true)): New
	constructor.
	(fEIG::init (const FloatMatrix& a, const FloatMatrix& b,
	bool calc_eigenvectors)): New function.
	(fEIG::init (const FloatComplexMatrix& a, const FloatComplexMatrix& b,
	bool calc_eigenvectors)): New function.
	(fEIG::symmetric_init (const FloatMatrix& a, const FloatMatrix& b,
	bool calc_eigenvectors)): New function.
	(fEIG::hermitian_init (const FloatComplexMatrix& a,
	const FloatComplexMatrix& b, bool calc_eigenvectors)): New function.

2008-11-19  Jaroslav Hajek  <highegg@gmail.com>

	* dMatrix.cc (Matrix::determinant),
	fMatrix.cc (FloatMatrix::determinant),
	CMatrix.cc (ComplexMatrix::determinant),
	fCMatrix.cc (FloatComplexMatrix::determinant):
	Use atmp(i,i) instead of elem(i,i).

2008-11-19  Jaroslav Hajek  <highegg@gmail.com>

	* DET.h (base_det<T>::square): New member function.
	* dMatrix.cc (Matrix::determinant),
	fMatrix.cc (FloatMatrix::determinant),
	CMatrix.cc (ComplexMatrix::determinant),
	fCMatrix.cc (FloatComplexMatrix::determinant):
	Allow taking MatrixType argument.
	* dMatrix.h, fMatrix.h, CMatrix.h, fCMatrix.h: Update decls.

2008-11-19  Jaroslav Hajek  <highegg@gmail.com>

	* DET.h: New source.
	* CmplxDET.cc, CmplxDET.h, dbleDET.cc, dbleDET.h, fCmplxDET.cc,
	fCmplxDET.h, floatDET.cc, floatDET.h: Remove.
	* Makefile.in: Reflect changes.
	* mx-defs.h: Remove DET decls.
	* mx-ext.h, dMatrix.h, fMatrix.h, CMatrix.h, fCMatrix.h,
	dSparse.h, CSparse.h: Include only DET.h.
	* dMatrix.cc (Matrix::determinant),
	fMatrix.cc (FloatMatrix::determinant),
	CMatrix.cc (ComplexMatrix::determinant),
	fCMatrix.cc (FloatComplexMatrix::determinant),
	dSparse.cc (SparseMatrix::determinant),
	CSparse.cc (SparseComplexMatrix::determinant): Use new class.

2008-11-18  David Bateman  <dbateman@free.fr>

	* file-ops.cc (std::string file_ops::tilde_expand (const
	std::string&)): Check if the string contains a tilde and fast
	return if not.

2008-11-17  John W. Eaton  <jwe@octave.org>

	* dir-ops.cc (dir_entry::read): Use std::list<std::string> to
	cache names before converting to string_vector.

2008-11-14  David Bateman  <dbateman@free.fr>

	* Array2.h (Array2<T> Array2<T>::index): Correct use of
	resize_fill_value.

2008-11-12  Michael Goffioul  <michael.goffioul@gmail.com>

	* MArray-C.cc, MArray-d.cc, MArray-f.cc, MArray-fC.cc: Declare
	MArray<T>::norm specialization before implicit MArray<T> implicit
	instantiation.
	* idx-vector.h (class idx_vector::idx_base_rep, class
	idx_vector::idx_range_rep, class idx_vector::idx_colon_rep, class
	idx_vector::idx_scalar_rep, class idx_vector::idx_vector_rep): Add
	OCTAVE_API tag.
	* idx-vector.cc (idx_vector::idx_scalar_rep::idx_scalar_rep(T),
	idx_vector::idx_vector_rep::idx_vector_rep(const Array<T>&)): Ditto.
	* oct-inttypes.cc (octave_int<T>::type_name): Ditto.
	* oct-inttypes.cc (powf(const octave_int<T>&,const float&)): Cast 'b'
	to double.
	* oct-inttypes.h: Undefine min/max.
	* oct-norm.h (xnorm, xfrobnorm, xcolnorms, xrownorms): Add OCTAVE_API
	tag.
	* oct-norm.cc (xnorm, xfrobnorm, xcolnorms, xrownorms): Ditto.

2008-11-12  Jaroslav Hajek  <highegg@gmail.com>

	* DiagArray2.h (DiagArray2<T>::maybe_delete_elements): Remove
	declaration.

2008-11-09  Jaroslav Hajek  <highegg@gmail.com>

	* oct-norm.cc: Don't include Array.cc.
	(column_norms (const MArray2<T>&, ...)): Use std::vector instead of Array<T> for
	accumulator containers. Use empty constructor instead of
	Array<T>::resize.
	(row_norms (const MArray2<T>&, ...)): Ditto.
	(column_norms (const MSparse2<T>&, ...)): Ditto.
	(row_norms (const MSparse2<T>&, ...)): Ditto.

2008-10-31  Jaroslav Hajek  <highegg@gmail.com>

	* oct-norm.h: New header file.
	* oct-norm.cc: New source.
	* CSparse.cc (SparseComplexMatrix::row, SparseComplexMatrix::column):
	New member functions.
	* CSparse.h (SparseComplexMatrix): Declare them.
	* dSparse.cc (SparseMatrix::row, SparseMatrix::column):
	New member functions.
	* dSparse.h (SparseMatrix): Declare them.
	* MArray-C.cc (MArray<Complex>::norm),
	MArray-d.cc (MArray<double>::norm),
	MArray-fC.cc (MArray<FloatComplex>::norm),
	MArray-f.cc (MArray<float>::norm): Wrap a call to xnorm.

	* MArray-defs.h (MARRAY_NORM_BODY): Remove.

2008-11-02  Jaroslav Hajek  <highegg@gmail.com>

	* idx-vector.cc (idx_vector::is_complement): Set resulting extent
	correctly.
	* Array.cc (Array<T>::delete_elements (int, const idx_vector&)):
	Fix check for invalid dim.

2008-10-31  Jaroslav Hajek  <highegg@gmail.com>

	* idx-vector.h (idx_vector::idx_range_rep::extent): Don't change
	extent when len is zero.
	* idx-vector.h (idx_vector::idx_range_rep::idx_range_rep (void)):
	Create empty range by default.

2008-10-30  Jaroslav Hajek  <highegg@gmail.com>

	* oct-inttypes.h (octave_int_abs): New function.
	(octave_int_arith_base<T, true>::div): Use octave_int_abs instead of
	std::abs.
	* oct-inttypes.cc (octave_int_arith_base<int64_t, true>): Ditto.

2008-10-28  Jaroslav Hajek  <highegg@gmail.com>

	* Array-C.cc Array-d.cc Array-f.cc Array-fC.cc Array-i.cc Array-s.cc:
	Don't use semicolon after INSTANTIATE_ARRAY_ASSIGN.
	* Array-util.h (zero_dims_inquire): New declarations.
	(is_in, how_many_lgt, short_freeze): Remove declarations.
	* Array-util.cc (zero_dims_inquire): New functions.
	(is_in, how_many_lgt, short_freeze): Remove functions.
	* Array.cc (Array<T>::index, Array<T>::resize_fill, Array<T>::resize,
	Array<T>::assign, Array<T>::delete_elements):
	Rewrite.
	* Array.h (Array<T>::index, Array<T>::resize_fill, Array<T>::resize,
	Array<T>::assign, Array<T>::delete_elements):
	Rewrite interfaces.
	* Array2.h (Array2<T>::resize): Call Array<T>::resize_fill.
	* Array3.h (Array3<T>::resize): Call Array<T>::resize_fill.
	* ArrayN.h (ArrayN<T>::resize): Remove declarations.
	(ArrayN<T>::index): Fix call to resize_fill_value.
	* Sparse.cc (assign, assign1): Use zero-based indices.
	* chMatrix.h: Include mx-op-defs.h
	* dim-vector.h (dim_vector::any_neg, dim_vector::chop_all_singletons,
	dim_vector::redim): New member functions.
	* idx-vector.cc: Mostly rewrite.
	* idx-vector.h: Mostly rewrite.

2008-10-29  Michael Goffioul  <michael.goffioul@gmail.com>

	* lo-specfun.cc (cbesj, cbesy, cbesi, cbesk, cbesh1, cbesh2): Do not
	use std::complex::real() and std::complex::imag() as l-value, this is
	not supported under MSVC.

2008-10-28  John W. Eaton  <jwe@octave.org>

	* lo-specfun.cc: Fix prototypes for the Fortran subroutines cbesh,
	cbesi, cbesj, cbesk, and cbesy.
	(cbesh, cbesi, cbesj, cbesk, cbesy): Fix calls to Fortran
	subroutines.

2008-10-28  Brian Gough  <bjg@gnu.org>

	* lo-specfun.cc (zbesi): Fix scaling factor for negative alpha.
	(cbesi): Likewise.

2008-10-23  John Swensen  <jpswensen@comcast.net>

	* oct-shlib.cc (octave_dyld_shlib::open): Call NSLinkEditError to
	get better diagnostic if NSLinkModule fails.

2008-10-23  John W. Eaton  <jwe@octave.org>

	* oct-shlib.cc (octave_dlopen_shlib::open): Use RTLD_NOW instead
	of RTLD_LAZY.

2008-10-12  Jaroslav Hajek  <highegg@gmail.com>

	* CSparse.cc (ComplexMatrix::expm): Improve inverse preconditioning
	according to Marco Caliari.
	* dSparse.cc (Matrix::expm): Likewise.
	* fCSparse.cc (FloatComplexMatrix::expm): Likewise.
	* fSparse.cc (FloatMatrix::expm): Likewise.

2008-10-10  Jaroslav Hajek  <highegg@gmail.com>

	* sparse-util.h (SparseCholPrint): Change char * argument to const
	char *.
	* sparse-util.cc (SparseCholPrint): Likewise.

2008-10-09  Jaroslav Hajek  <highegg@gmail.com>

	* oct-sort.cc (octave_sort<T>::merge_getmem,
	octave_sort<T>::merge_freemem): Replace malloc -> new [], free ->
	delete [].
	(octave_sort<T>::merge_lo, octave_sort<T>::merge_hi): Replace
	std::memcpy and std::memmove with std::copy.

2008-10-08  John W. Eaton  <jwe@octave.org>

	* Sparse-op-defs.h (SPARSE_SMSM_BOOL_OPS): Duplicate code for scalar
	sparse arguments rather than rely on extern function.

2008-10-08  Jaroslav Hajek  <highegg@gmail.com>

	* oct-inttypes.h (octave_base_int<T>::compute_threshold): Return
	exclusive bounds rather than inclusive, be resistant to compiler
	optimizations.
	(octave_base_int<T>::convert_real): Use exclusive bounds.

2008-10-07  Jaroslav Hajek  <highegg@gmail.com>

	* oct-inttypes.h (OCTAVE_INT_DOUBLE_BIN_OP): Change octave_int64 to
	octave_uint64 where appropriate.

2008-10-06  David Bateman  <dbateman@free.fr>

	* Sparse-op-defs.h (SPARSE_SMSM_CMP_OPS): Duplicate code for scalar
	sparse arguments rather than rely on extern function.

2008-10-06  John W. Eaton  <jwe@octave.org>

	* Spasre-op-defs.h: Undo previous change.

2008-10-01  Jaroslav Hajek  <highegg@gmail.com>

	* oct-inttypes.h (octave_int<T>::one, octave_int<T>::zero): Declare
	constants.
	* oct-inttypes.cc: Define them.
	* oct-inttypes.h: Define mixed operations via long double if possible.
	* oct-inttypes.cc: Define alternative implementations for 64-bit
	multiplication and mixed operations.
	* mx-ops: Instantiate all 64-bit integer operations.

2008-10-06  Jaroslav Hajek  <highegg@gmail.com>

	* oct-lookup.h: Mark functions inline. Add missing std:: qualifiers.

2008-10-06  John W. Eaton  <jwe@octave.org>

	* Sparse.h (Sparse<T>::elt_type): New typedef.
	* Sparse-op-defs.h (SPARSE_SMSM_BOOL_OP, SPARSE_MSM_CMP_OP):
	Use it to call sparse-matrix/scalar operator instead of attempting
	to instantiate mixed-type sparse-matrix/scalar operators.

2008-10-03  Jaroslav Hajek  <highegg@gmail.com>

	* Array.h (Array<T>::maybe_delete_elements): Remove rfv argument from
	declaration.
	* Array.cc (Array<T>::maybe_delete_elements): Remove all usages of
	rfv.

2008-10-03  Jaroslav Hajek  <highegg@gmail.com>

	* Array.cc (assignN): Do not call maybe_delete_elements when
	for empty matrix.

2008-09-30  Jaroslav Hajek  <highegg@gmail.com>

	* oct-inttypes.h: Mostly rewrite.
	* oct-inttypes.cc: Modstly rewrite.

2008-09-29  Jaroslav Hajek  <highegg@gmail.com>

	* Array.cc (Array<T>::maybe_delete_elements_2(idx_vector&)): Return on
	empty index vector.

2008-09-26  Jaroslav Hajek  <highegg@gmail.com>

	* Array.cc (assign1, assign2, assignN): Do not call
	maybe_delete_elements.
	(maybe_delete_elements (Array<idx_vector>&)): Call the 1D and 2D
	special handlers if possible.
	* Sparse.cc (assign1, assign2, assignN): Do not call
	maybe_delete_elements.

2008-09-22  Brian Gough  <bjg@gnu.org>

	* oct-rand.cc (initialize_mersenne_twister): Use separate
	initializations for each generator to avoid correlation.

2008-09-12  Jaroslav Hajek  <highegg@gmail.com>

 	* oct-inttypes.h (pow (const octave_int<T>&, const octave_int<T>&)):

2008-09-19  John W. Eaton  <jwe@octave.org>

	* Array.cc (assign1, assign2, assignN):
	Clear lhs index before throwing error.
	(Array<T>::value): Clear index before throwing error.

2008-09-18  Jaroslav Hajek  <highegg@gmail.com>

	* Array.cc (maybe_delete_elements_2 (idx_vector&)): Fix tests to get
	better Matlab compatibility.
	(maybe_delete_elements (idx_vector&, idx_vector&)): Fix tests to get
	better Matlab compatibility, simplify, gripe on invalid 2-D deletion.

2008-09-18  Jaroslav Hajek  <highegg@gmail.com>

	* Array.h (Array<T>::coerce): Use octave_idx_type instead of int.

2008-09-12  Jaroslav Hajek  <highegg@gmail.com>

	* oct-inttypes.h (pow (const octave_int<T>&, const octave_int<T>&)):
	Handle negative exponent correctly.

2008-08-19  David Bateman  <dbateman@free.fr>

	* oct-inttypes.h (template <class T1, class T2> inline T2
	octave_int_fit_to_range (const T1&, const T2&, const T2&),
	template <typename T> inline T octave_int_fit_to_range (const
	double&, const T&, const T&), template <> inline T2
	octave_int_fit_to_range<T1, T2> (const T1&, const T2&, const T2&),
	OCTAVE_S_US_FTR): Check and flag integer trunctation.
	(OCTAVE_INT_FIT_TO_RANGE, OCTAVE_INT_FIT_TO_RANGE2): Adapt for the
	above change.
	(OCTAVE_INT_CONV_FIT_TO_RANGE): New macro for conversion to
	integer types.
	(octave_int<T>::conv_error_type): New enum to flag conversion and
	math warnings.
	(octave_int<T>::octave_int (U i), octave_int<T>::octave_int
	(double i), octave_int<>::octave_int (const octave_int<U>& i)):
	Flag conversion and math errors other than integer truncation.
	(octave_int<T> octave_int<T>::operator - (void)): Flag truncation
	error.
	(static bool get_trunc_flag (void), static bool clear_trunc_flag
	(void, static bool trunc_flag)): Delete.
	(static int get_conv_flag (void), static bool get_trunc_flag (void),
	static bool get_nan_flag (void), static bool get_non_int_flag (void),
	static bool get_math_trunc_flag (void), static void
	clear_conv_flag (void)): New functions to query and reset
	conversion and mathw arning state.
	(static int cov_flag): New parameter holding current conversion
	and math warning state. Set it to zero.
	(template <class T> octave_int<T> powf (float, const
	octave_int<T>&), template <class T> octave_int<T> powf (const
	octave_int<T>&, float)): New functions.

2008-08-12  Jaroslav Hajek  <highegg@gmail.com>

	* lo-ieee.cc (octave_ieee_init): Try to ensure that octave_NaN is
	classified as positive by lo_ieee_signbit.

2008-08-11  Jaroslav Hajek  <highegg@gmail.com>

	* Array.cc (no_op_fcn): New static function.
	(Array<T>::hermitian): If fcn is null, set to no_op_fcn.

2008-08-07  John W. Eaton  <jwe@octave.org>

	* sprse-base-chol.h, oct-sparse.h: Don't include config.h.

	* cmd-edit.cc, file-ops.h, kpse.cc, oct-env.cc, pathsearch.cc:
	Replace all uses of NPOS with std::string::npos.

	* fCmplxLU.h, CmplxLU.h: Fix typo in definition of
	multiple-inclusion guard macro.

2008-08-05  John W. Eaton  <jwe@octave.org>

	* file-ops.h, file-ops.cc (file_ops::static_members):
	New singleton class for static members of file_ops.

	* pathsearch.h, pathsearch.cc (class dir_path::static_members):
	New singleton class for static members of dir_path.

	* pathsearch.cc (dir_path::init): Move octave_kpathsea_initialized
	here from file scope.

2008-08-04  John W. Eaton  <jwe@octave.org>

	* oct-env.cc (octave_env::do_set_program_name,
	octave_env::do_base_pathname): Fix usage of
	file_ops::dir_sep_chars.
	(octave_env::do_make_absolute): Fix usage of
	file_ops::dir_sep_chars and file_ops::dir_sep_str.
	(octave_env::do_get_home_directory): Fix usage of
	file_ops::dir_sep_str.

	* file-ops.h (file_ops::do_is_dir_sep): New function.
	(file_ops_::is_dir_sep): Call it.
	* file-ops.cc (class file_ops): Make it a proper singleton object.
	(file_ops::file_ops): New constructor.
	(file_ops::instance_ok): New function.
	(file_ops::xdir_sep_char): Now private.  No longer static.  Rename
	from dir_sep_char.
	(file_ops::xdir_sep_str): Likewise, from dir_sep_str.
	(file_ops::xdir_sep_chars): Likewise, from dir_sep_chars.
	(file_ops::dir_sep_char, file_ops::dir_sep_str,
	file_ops::dir_sep_chars): New functions.
	(file_ops::recursive_rmdir): Fix usage of file_ops::dir_sep_str.
	(file_ops::concat): Fix usage of file_ops::dir_sep_char.

	* oct-env.cc (octave_env::instance_ok): Fix typo in error message.

2008-07-30  John W. Eaton  <jwe@octave.org>

	* oct-inttypes.h: Style fixes.

2008-07-30  Jaroslav Hajek  <highegg@gmail.com>

	* oct-inttypes.h (octave_int<T>::trunc_flag): New member static field.
	(octave_int<T>::get_trunc_flag, octave_int<T>::clear_trunc_flag): New
	member functions.
	(octave_int<T>::octave_int (const octave_int<U>&)): set trunc_flag
	on truncation.
	(SPECIALIZE_WIDENING_CONVERSION): New macro.
	(DECLARE_OCTAVE_INT_TYPENAME): New macro.

2008-07-29  David Bateman  <dbateman@free.fr>

	* lo-ieee.h (LO_IEEE_NA_HW, LO_IEEE_NA_LW, LO_IEEE_NA_FLOAT):
	Change definition so cast from single to double and visa versa
	maintains NA value.
	(LO_IEEE_NA_HW_OLD, LO_IEEE_NA_LW_OLD): Keep old values.
	(extern OCTAVE_API int __lo_ieee_is_old_NA (double)): Function to
	detect old NA value.
	(extern OCTAVE_API double __lo_ieee_replace_old_NA (double)):
	Function to replace old NA value with new new.
	* lo-cieee.c (int __lo_ieee_is_old_NA (double)): Function to
	detect old NA value.
	(double __lo_ieee_replace_old_NA (double)): Function to replace
	old NA value with new new.
	* data-conv.cc (void read_doubles(std::istream&, double *,
	save_type, int, bool, octave_mach_info::float_format)): Test if
	loaded NA values is the old representation and replace it.

2008-07-28  Jaroslav Hajek  <highegg@gmail.com>

	* lo-math.h: Ensure log2 is undefined from cmath in C++ mode.

2008-07-21  Michael Goffioul  <michael.goffioul@gmail.com>

	* oct-mutex.h (octave_base_mutex::octave_base_mutex): Initialize
	count to 1, not -1.

	* oct-mutex.cc (octave_base_mutex::lock, octave_base_mutex::unlock):
	Replace error calls with (*current_liboctave_error_handler).

2008-07-21  John W. Eaton  <jwe@octave.org>

	* regex-match.cc (regex_match::init): Initialize err to 0.

2008-07-19  John W. Eaton  <jwe@octave.org>

	* oct-mutex.h (class octave_base_mutex): New class.
	(class octave_mutex): Don't use union for rep and count.
	(octave_mutex::rep): Declare as octave_base_mutex.
	(octave_mutex::count): Delete.
	(octave_mutex::lock, octave_mutex::unlock): No longer virtual.
	(octave_mutex::~octave_mutex): No need to check that rep is
	valid or set rep to zero after deleting.
	(octave_mutex::operator =): No need to check that rep is valid.
	* oct-mutex.cc (octave_w32_mutex, octave_pthread_mutex): Derive
	from octave_base_mutex, not octave_mutex.

2008-07-18  John W. Eaton  <jwe@octave.org>

	* oct-mutex.h (octave_mutex::octave_mutex (int)): Initialize rep
	to 0, not count.
	* oct-mutex.cc (octave_mutex::octave_mutex (void)): Set rep->count
	to 1 instead of incrementing it.

2008-07-17  Michael Goffioul  <michael.goffioul@gmail.com>

	* dNDArray.cc: Do not include ctor NDArray(Array<octave_idx_type>,
	bool, bool) into conditional HAVE_FFTW3 preprocessor statement.

2008-07-16  John W. Eaton  <jwe@octave.org>

	* oct-mutex.h (octave_autolock::octave_autolock (void),
	octave_autolock (const octave_autolock&),
	octave_autolock::operator = (const octave_autolock&)):
	Delete definitions.

2008-07-16  Michael Goffioul  <michael.goffioul@gmail.com>

	* cmd-edit.cc (event_hook_lock): New static mutex variable.
	(command_editor::event_handler): Lock and copy event_hook_set before
	executing handlers.
	(command_editor::add_event_hook, command_editor::remove_event_hook):
	Autolock event_hook_lock.

2008-07-15  Michael Goffioul  <michael.goffioul@gmail.com>

	* oct-mutex.h, oct-mutex.cc: New files.
	* Makefile.in: Add them to appropriate lists.

2008-07-15  John W. Eaton  <jwe@octave.org>

	* oct-sort.cc, oct-sort.h (octave_sort<T>::count_run): Declare
	descending arg as bool&.
	(octave_sort<T>::sort): Pass bool to count_run for descending arg.

2008-07-11  John W. Eaton  <jwe@octave.org>

	* dDiagMatrix.cc (DiagMatrix::diag): Return empty ColumnVector if
	number of rows or columns is 0.
	* fDiagMatrix.cc (FloatDiagMatrix::diag): Likewise.

	* Array-util.cc (is_vector): Avoid GCC warning.
	* Array-f.cc (Array<float>::sort): Likewise.
	* Array-d.cc (Array<double>::sort): Likewise.
	* dbleQR.cc (QR::QR (const Matrix&, const Matrix&)): Likewise.
	* CmplxQR.cc (ComplexQR::ComplexQR (const ComplexMatrix&, const
	ComplexMatrix&)): Likewise.
	* floatQR.cc (FloatQR::FloatQR (const FloatMatrix&, const
	FloatMatrix&)): Likewise.
	* fCmplxQR.cc (FloatComplexQR::FloatComplexQR (const
	FloatComplexMatrix&, const FloatComplexMatrix&)): Likewise.
	* Quad.cc (IndefQuad::do_integrate (octave_idx_type&,
	octave_idx_type&, float&), FloatIndefQuad::do_integrate,
	DefQuad::do_integrate octave_idx_type&, octave_idx_type&, float&,
	FloatIndefQuad::do_integrate): Likewise.

	* mx-op-defs.h (MS_BOOL_OP, SM_BOOL_OP, MM_BOOL_OP, NDS_BOOL_OP,
	SND_BOOL_OP, NDND_BOOL_OP): Detect NaN values.
	* Array-util.cc (gripe_nan_to_logical_conversion): New function.
	* Array-util.h: Provide decl.
	* oct-inttypes.h (xisnan (octave_int<T>)): New function.
	* lo-mappers.h (xisnan (bool), xisnan (char)): New inline functions.

	* CMatrix.cc, CNDArray.cc, CSparse.cc, dMatrix.cc, dNDArray.cc,
	dSparse.cc, fCMatrix.cc, fCNDArray.cc, fMatrix.cc, fNDArray.cc:
	New member function, any_element_is_nan.
	* CMatrix.h, CNDArray.h, CSparse.h, dMatrix.h, dNDArray.h,
	dSparse.h, fCMatrix.h, fCNDArray.h, fMatrix.h, fNDArray.h:
	Provide decl.

2008-07-10  David Bateman  <dbateman@free.fr>

	* dNDArray.cc (NDArray::NDArray (const Array<octave_idx_type>&,
	bool, bool)): New constructor.
	* dNDArray.h: Provide decl.

2008-07-10  Michael Goffioul  <michael.goffioul@gmail.com>

	* lo-specfun.h: Fix typo in erff/erfcf declaration.
	* lo-specfun.cc: Ditto. Add atanhf implementation.

2008-06-20  Jaroslav Hajek  <highegg@gmail.com>

	* MatrixType.h: Add missing include statement.

2008-06-13  Michael Goffioul  <michael.goffioul@gmail.com>

	* lo-mappers.cc (arg): Remove ambiguity about atan2(float,float) usage.
	* fCmplxDET.cc (FloatComplexDET::initialize10): Likewise, for pow.

2008-06-11  John W. Eaton  <jwe@octave.org>

	* so-array.h, so-array.cc, Array-so.cc: Delete.
	* Makefile.in: Remove them from the lists.

2008-06-05  John W. Eaton  <jwe@octave.org>

	* oct-shlib.cc (octave_base_shlib::remove): Only dereference
	counter if iterator is valid.

2008-06-02  David Bateman  <dbateman@free.fr>

	* fCmplxDET.cc (FloatComplexDET::value_will_overflow,
	FloatComplexDET:value_will_underflow): Replace DBL_MIN and DBL_MAX
	with FLT_MIN and FLT_MAX.
	* floatDET.cc ((FloatDET::value_will_overflow,
	FloatDET:value_will_underflow): Ditto.
	* lo-cieee.c (__lo_ieee_float_is_NA): Check only a sngle word for
	float NA value.
	(lo_ieee_float_inf_value): Return correct float Infinity value.
	(lo_ieee_float_NA_value): Return correct float NA value.
	(lo_ieee_float_NaN_value): Return correct float NaN value.
	* lo-ieee.cc (octave_ieee_init): Set float NA value correctly.
	* lo-ieee.h (lo_ieee_float): value of union is of type float.
	(LO_IEEE_NA_FLOAT): Make NA value a valid float NaN.
	(LO_IEEE_NA_FLOAT_LW): Delete.

2008-06-02  David Bateman  <dbateman@free.fr>

	* fCmplxLU.cc (class FloatComplexLU): Correct error in instantiation.
	* floatLU.cc (class FloatLU): ditto.
	* floatLU.h (class FloatLU): ditto.

	* floatAEPBAL.cc (octave_idx_type FloatAEPBALANCE::init (const
	FloatMatrix&, const std::string&)): Use FloatMatrix to initialize
	balancing_mat.

	* Makefile.in (MATRIX_INC): Add fCmplxAEPBAL.h and floatAEPBAL.h.
	(MATRIX_SRC): Add fCmplxAEPBAL.cc and floatAEPBAL.cc.

2008-05-21  David Bateman  <dbateman@free.fr>

	* Quad-opts.in: Handle single precision tolerances.
	* Quad.cc (float_user_fcn): New static variable.
	(quad_float_fcn_ptr): New typedef.
	(qagp, quagi): New QUADPACK decls.
	(float_user_function): New function.
	(DefQuad::do_integrate, IndefQuad::do_integrate): Float versions.
	(FloatDefQuad::do_integrate, FloatIndefQuad::do_integrate):
	New functions.
	* Quad.h (class Quad): Handle float type.
	(class FloatDefQuad, class FloatIndefQuad): New classes.

2008-05-21  Jaroslav Hajek  <highegg@gmail.com>

	* fCMatrix.h (xgemm): Provide decl.
	(xcdotc, csyrk, cherk): New F77 decls.
	* fMatrix.cc (xgemm): New function.
	(operator * (const FloatMatrix&, const FloatMatrix&)): Simplify.
	(get_blas_trans_arg): New function.
	* fCMatrix.h (xgemm): Provide decl.
	(ssyrk): New F77 decl.
	* fCMatrix.cc (xgemm): New function.
	(operator * (const FloatComplexMatrix&, const
	FloatComplexMatrix&)): Simplify.
	(get_blas_trans_arg): New function.

	* dMatrix.cc, CMatrix.cc, Sparse-op-defs.h: Add missing copyright.

	* Sparse-op-defs.h (SPARSE_FULL_MUL): Simplify scalar*matrix case.
	Correct indenting.
	(SPARSE_FULL_TRANS_MUL): New macro.
	(FULL_SPARSE_MUL): Simplify scalar*matrix case. Correct indenting.
	Move OCTAVE_QUIT one level up.
	(FULL_SPARSE_MUL_TRANS): New macro.
	* dSparse.h (mul_trans, trans_mul): Provide decl.
	* dSparse.cc (mul_trans, trans_mul): New functions.
	* CSparse.h (mul_trans, trans_mul, mul_herm, herm_mul): Provide decl.
	* CSparse.cc (mul_trans, trans_mul, mul_herm, herm_mul): New functions.

	* dMatrix.h (xgemm): Provide decl.
	* dMatrix.cc (xgemm): New function.
	(operator * (const Matrix&, const Matrix&)): Simplify.
	(get_blas_trans_arg): New function.
	* CMatrix.h (xgemm): Provide decl.
	* CMatrix.cc (xgemm): New function.
	(operator * (const ComplexMatrix&, const ComplexMatrix&)): Simplify.
	(get_blas_trans_arg): New function.

	* MatrixType.cc (matrix_real_probe, matrix_complex_probe):
	New template functions.
	(MatrixType::MatrixType (const Matrix&),
	MatrixType::MatrixType (const FloatMatrix&)):
	just call matrix_real_probe.
	(MatrixType::MatrixType (const ComplexMatrix&),
	MatrixType::MatrixType (const FloatComplexMatrix&)):
	just call matrix_complex_probe.

	* MatrixType.cc (MatrixType::MatrixType (matrix_type, bool)):
	add missing test for Unknown.

2008-05-21  David Bateman  <dbateman@free.fr>

	* fCMatrix.cc (float rcond): Replace with float rcon everywhere
	to avoid shadowed variable warning
	(float ComplexMatrix::rcond (void) const): New method for
	reciprocal condition number calculation.
	(float ComplexMatrix::rcond (MatrixType &mattype) const): ditto.
	* fCMatrix.h (float rcond):  Replace with float rcon everywhere
	to avoid shadowed variable warning
	(float ComplexMatrix::rcond (void) const): New method for
	reciprocal condition number calculation.
	(float ComplexMatrix::rcond (MatrixType &mattype) const): ditto.
	* fMatrix.cc (float rcond): Replace with float rcon everywhere
	to avoid shadowed variable warning
	(float Matrix::rcond (void) const): New method for
	reciprocal condition number calculation.
	(float Matrix::rcond (MatrixType &mattype) const): ditto.
	* fMatrix.h (float rcond):  Replace with float rcon everywhere
	to avoid shadowed variable warning
	(float Matrix::rcond (void) const): New method for
	reciprocal condition number calculation.
	(float Matrix::rcond (MatrixType &mattype) const): ditto.

	* Array.cc: Fix transpose tests.

	* CmplxGEBAL.cc (ComplexGEPBALANCE), dbleGEPBAL.cc (GEPBALANCE),
	fCmplxGEPBAL.cc (FloatComplexGEPBALANCE), floatGEPBAL.cc
	(FloatGEPBALANCE): New class for generalized eigenvalue balancing.
	* CmplxGEBAL.h (ComplexGEPBALANCE), dbleGEPBAL.h (GEPBALANCE),
	fCmplxGEPBAL.h (FloatComplexGEPBALANCE), floatGEPBAL.h
	(FloatGEPBALANCE): Declare them.
	* Makefile.in (MATRIX_INC): Include them here.
	(MATRIX_SRC): and here.

	* floatAEPBAL.cc (FloatAEPBALANCE), fCmplxAEPBAL.cc
	(FloatComplexAEPBALANCE): New classes for single precision
	Algebraic eignvalue balancing.
	* floatAEPBAL.h (FloatAEPBALANCE), fCmplxAEPBAL.h
	(FloatComplexAEPBALANCE): Declare them.
	* Makefile.in (MATRIX_INC): Include them here.
	(MATRIX_SRC): and here.

	* floatHESS.cc (FloatHESS), fCmplxHESS.cc (FloatComplexHESS):  New
	classes for single precision Hessenberg decomposition.
	* floatHESS.h (FloatHESS), fCmplxHESS.h (FloatComplexHESS):
	Declare them.
	* Makefile.in (MATRIX_INC): Include them here.
	(MATRIX_SRC): and here.

	* floatQR.cc (FloatQR), fCmplxQR.cc (FloatComplexQR):  New
	classes for single precision QR decomposition.
	* floatQR.h (FloatQR), fCmplxQR.h (FloatComplexQR):
	Declare them.
	* Makefile.in (MATRIX_INC): Include them here.
	(MATRIX_SRC): and here.

	* floatQRP.cc (FloatQRP), fCmplxQRP.cc (FloatComplexQRP):  New
	classes for single precision permuted QR decomposition.
	* floatQRP.h (FloatQRP), fCmplxQRP.h (FloatComplexQRP):
	Declare them.
	* Makefile.in (MATRIX_INC): Include them here.
	(MATRIX_SRC): and here.

	* mx-defs (FloatAEPBALANCE, FloatComplexAEPBALANCE,
	ComplexGEPBALANCE, FloatGEPBALANCE,FloatComplexGEPBALANCE,
	FloatHESS, FloatComplexHESS, FloatQR, FloatComplexQR, QRP,
	ComplexQRP, FloatQRP, FloatComplexQRP):	Declare classes.

2008-05-20  David Bateman  <dbateman@free.fr>

	* Array.cc (Array<T> Array<T>::transpose () const): Modify for tiled
	transpose to limit the number of cache misses.
	(Array<T> Array<T>::hermitian (T (*)(const&)) const): New method
	for matrix conjugate transpose.
	* Array.h (Array<T> hermitian (T (*)(const&)) const): Declare it.

	* DiagArray2.cc (DiagArray2<T> DiagArray2<T>::transpose () const):
	Specialization for diagonal arrays.
	(DiagArray2<T> DiagArray2<T>::transpose (T (*) (const&)) const):
	Ditto.

	* MArray.h (MArray<T> hermitian <T (*) (const&)) const): New method.
	(MArray<T> transpose () const): Ditto.
	* MArray2.h (MArray2<T> hermitian <T (*) (const&)) const): Ditto.
	* Array2.h (Array2<T> hermitian <T (*) (const&)) const): Ditto.
	* ArrayN.h (ArrayN<T> hermitian <T (*) (const&)) const): Ditto.
	* MDiagArray2.h (MDiagArray2<T> transpose () const): Ditto.
	(MDiagArray<T> hermitian <T (*) (const&)) const): Ditto.

	* CColVector.cc (transpose, hermitian): Define in terms of base class.
	* CRowVector.cc (transpose, hermitian): Ditto.
	* dColVector.cc (transpose): Ditto.
	* dRowVector.cc (transpose): Ditto.
	* CDiagMatrix.h (transpose, hermitian): Ditto.
	* dDiagMatrix.h (transpose): Ditto.

	* fCColVector.cc (transpose, hermitian): Define in terms of base class.
	* fCRowVector.cc (transpose, hermitian): Ditto.
	* fColVector.cc (transpose): Ditto.
	* fRowVector.cc (transpose): Ditto.
	* fCDiagMatrix.h (transpose, hermitian): Ditto.
	* fDiagMatrix.h (transpose): Ditto.

	* CDiagMatrix.cc (ComplexDiagMatrix::transpose,
	ComplexDiagMatrix::hermitian): Delete.
	* dDiagMatrix.cc (DiagMatrix::transpose): Ditto.
	* CMatrix.cc (ComplexMatrix::hermitian): Ditto.

	* fCDiagMatrix.cc (FloatComplexDiagMatrix::transpose,
	FloatComplexDiagMatrix::hermitian): Delete.
	* fDiagMatrix.cc (FloatDiagMatrix::transpose): Ditto.
	* fCMatrix.cc (FloatComplexMatrix::hermitian): Ditto.

	* lo-mappers.cc (FloatComplex xlog2(const FloatComplex&), float
	xlog2 (flot, int&), FloatComplex xlog2(const FloatComplex&, int&)):
	New mapper functions for single precion values.
	* lo-mappers.h (FloatComplex xlog2(const FloatComplex&), float
	xlog2 (flot, int&), FloatComplex xlog2(const FloatComplex&, int&)):
	Declare them.

	* CmplxGEBAL.cc (ComplexGEPBALANCE), dbleGEPBAL.cc (GEPBALANCE),
	fCmplxGEPBAL.cc (FloatComplexGEPBALANCE), floatGEPBAL.cc
	(FloatGEPBALANCE): New class for generalized eigenvalue balancing.
	* CmplxGEBAL.h (ComplexGEPBALANCE), dbleGEPBAL.h (GEPBALANCE),
	fCmplxGEPBAL.h (FloatComplexGEPBALANCE), floatGEPBAL.h
	(FloatGEPBALANCE): Declare them.
	* Makefile.in (MATRIX_INC): Include them here.
	(MATRIX_SRC): and here.

	* floatAEPBAL.cc (FloatAEPBALANCE), fCmplxAEPBAL.cc
	(FloatComplexAEPBALANCE): New classes for single precision
	Algebraic eignvalue balancing.
	* floatAEPBAL.h (FloatAEPBALANCE), fCmplxAEPBAL.h
	(FloatComplexAEPBALANCE): Declare them.
	* Makefile.in (MATRIX_INC): Include them here.
	(MATRIX_SRC): and here.

	* floatHESS.cc (FloatHESS), fCmplxHESS.cc (FloatComplexHESS):  New
	classes for single precision Hessenberg decomposition.
	* floatHESS.h (FloatHESS), fCmplxHESS.h (FloatComplexHESS):
	Declare them.
	* Makefile.in (MATRIX_INC): Include them here.
	(MATRIX_SRC): and here.

	* floatQR.cc (FloatQR), fCmplxQR.cc (FloatComplexQR):  New
	classes for single precision QR decomposition.
	* floatQR.h (FloatQR), fCmplxQR.h (FloatComplexQR):
	Declare them.
	* Makefile.in (MATRIX_INC): Include them here.
	(MATRIX_SRC): and here.

	* floatQRP.cc (FloatQRP), fCmplxQRP.cc (FloatComplexQRP):  New
	classes for single precision permuted QR decomposition.
	* floatQRP.h (FloatQRP), fCmplxQRP.h (FloatComplexQRP):
	Declare them.
	* Makefile.in (MATRIX_INC): Include them here.
	(MATRIX_SRC): and here.

	* mx-defs (FloatAEPBALANCE, FloatComplexAEPBALANCE,
	ComplexGEPBALANCE, FloatGEPBALANCE,FloatComplexGEPBALANCE,
	FloatHESS, FloatComplexHESS, FloatQR, FloatComplexQR, QRP,
	ComplexQRP, FloatQRP, FloatComplexQRP):	Declare classes.

	* Array-f.cc, Array-fC.cc, MArray-f.cc, MArray-fC.cc,
	fCColVector.cc, fCColVector.h, fCDiagMatrix.cc, fCDiagMatrix.h,
	fCMatrix.cc, fCMatrix.h, fCNDArray.cc, fCNDArray.h,
	fCRowVector.cc, fCRowVector.h, fCmplxCHOL.cc, fCmplxCHOL.h,
	fCmplxDET.cc, fCmplxDET.h, fCmplxLU.cc, fCmplxLU.h,
	fCmplxSCHUR.cc, fCmplxSCHUR.h, fCmplxSVD.cc, fCmplxSVD.h,
	fColVector.cc, fColVector.h, fDiagMatrix.cc, fDiagMatrix.h,
	fEIG.cc, fEIG.h, fMatrix.cc, fMatrix.h, fNDArray.cc, fNDArray.h,
	fRowVector.cc, fRowVector.h, floatCHOL.cc, floatCHOL.h,
	floatDET.cc, floatDET.h, floatLU.cc, floatLU.h, floatSCHUR.cc,
	floatSCHUR.h, floatSVD.cc, floatSVD.h: New files.
	* Makefile.in (MATRIC_INC, TI_SRC, MATRIX_SRC): Add them.

	* CMatrix.cc, CMatrix.h, CNDArray.cc, CNDArray.h, CmplxDET.cc,
	MArray-C.cc, MArray-d.cc, MArray-defs.h, MArray.cc, MArray.h,
	MatrixType.cc, MatrixType.h, SparseCmplxQR.cc, SparseCmplxQR.h,
	SparseQR.cc, SparseQR.h, dMatrix.cc, dMatrix.h, dNDArray.cc,
	dNDArray.h, data-conv.cc, data-conv.h, dbleDET.cc, dbleSVD.cc,
	lo-cieee.c, lo-ieee.cc, lo-ieee.h, lo-mappers.cc, lo-mappers.h,
	lo-specfun.cc, lo-specfun.h, lo-utils.cc, lo-utils.h, mx-base.h,
	mx-defs.h, mx-ext.h, mx-inlines.cc, mx-op-defs.h, mx-ops,
	oct-cmplx.h, oct-fftw.cc, oct-fftw.h, oct-inttypes.h, vx-ops:
	Allow single precision types.

2008-05-20  David Bateman  <dbateman@free.fr>

	* CMatrix.cc (double rcond): Replace with double rcon everywhere
	to avoid shadowed variable warning
	(double ComplexMatrix::rcond (void) const): New method for
	reciprocal condition number calculation.
	(double ComplexMatrix::rcond (MatrixType &mattype) const): ditto.
	* CMatrix.h (double rcond):  Replace with double rcon everywhere
	to avoid shadowed variable warning
	(double ComplexMatrix::rcond (void) const): New method for
	reciprocal condition number calculation.
	(double ComplexMatrix::rcond (MatrixType &mattype) const): ditto.
	* dMatrix.cc (double rcond): Replace with double rcon everywhere
	to avoid shadowed variable warning
	(double Matrix::rcond (void) const): New method for
	reciprocal condition number calculation.
	(double Matrix::rcond (MatrixType &mattype) const): ditto.
	* dMatrix.h (double rcond):  Replace with double rcon everywhere
	to avoid shadowed variable warning
	(double Matrix::rcond (void) const): New method for
	reciprocal condition number calculation.
	(double Matrix::rcond (MatrixType &mattype) const): ditto.

	* regex-match.cc, regex-match.h: New class for simple regular
	expression matching
	* Makefile.in (INCLUDES): Add regex-match.h here, and
	(LIBOCTAVE_CXX_SOURCES): regex-match.cc here.

2008-05-19  David Bateman  <dbateman@free.fr>

	* dSparse.cc: Replace some DGBCON with GPBCON where they are
	incorrectly used.

2008-05-13  David Bateman  <dbateman@free.fr>

	* idx-vector.cc (IDX_VEC_REP::idx_vector_rep (const boolNDArray&)):
	If len is zero size the index vector in the same manner as if len
	is not zero.

2008-05-05  John W. Eaton  <jwe@octave.org>

	* cmd-edit.cc (command_editor::re_read_init_file,
	gnu_readline::do_re_read_init_file): New functions.
	* cmd-edit.h (command_editor::re_read_init_file): Provide decl.
	(command_editor::do_re_read_init_file): New function.
	* oct-rl-edit.c (octave_rl_re_read_init_file): New function.
	* oct-rl-edit.h: Provide decl.

2008-05-05  Rafael Laboissiere  <rafael@debian.org>

	* oct-rl-edit.c (octave_read_init_file): Simply call rl_read_init_file.

2008-05-01  John W. Eaton  <jwe@octave.org>

	* oct-shlib.h (octave_shlib::number_of_functions_loaded):
	Return size_t instead of int value.
	* oct-shlib.cc (octave_base_shlib::number_of_functions_loaded):
	Likewise.
	(octave_base_shlib::fcn_names): Now a std::map object.
	Adjust all uses.
	(octave_base_shlib::fcn_names_iterator,
	octave_base_shlib::fcn_names_const_iterator): New typedefs.
	(octave_base_shlib::add_to_fcn_names, octave_base_shlib::remove):
	Perform reference counting for functions accessed.

2008-04-30  Jaroslav Hajek  <highegg@gmail.com>

	* lo-mappers.cc (xlog2 (double)): Compute log (2), not log2 (2).
	(xlog2 (Complex), xlog2 (double, int&), xlog2 (Complex, int&)):
	New functions.
	* lo-mappers.h: Provide decls.

2008-04-25  Michael Goffioul  <michael.goffioul@gmail.com>

	* oct-lookup.h (seq_lookup): Do not use output value of fill_n (MSVC
	does not support it).

2008-04-24  Michael Goffioul  <michael.goffioul@gmail.com>

	* lo-sysdep.cc (octave_popen2): Don't set PIPE_NOWAIT for parentWrite.

2008-04-21  John W. Eaton  <jwe@octave.org>

	* idx-vector.cc (IDX_VEC_REP::idx_vector_rep (const boolNDArray&)):
	Fix for-loop condition.

2008-04-19  Jaroslav Hajek  <highegg@gmail.com>

	* CmplxCHOL.cc, CmplxQR.cc, dbleCHOL.cc, dbleQR.cc: Fix calls to error()

2008-04-16  David Bateman  <dbateman@free.fr>

	* Sparse.h (Sparse<T>& operator = (Sparse<T>&)): Move definition
	of the operator for here
	* Sparse.cc (Sparse<T>& Sparse<T>::operator = (Sparse<T>&)): To
	here. Also delete idx.
	* Array.h (Array<T>& operator = (Array<T>&)): Move definition
	of the operator for here
	* Array.cc (Array<T>& Array<T>::operator = (Array<T>&)): To
	here. Also delete idx.

2008-04-09  Michael Goffioul  <michael.goffioul@gmail.com>

	* lo-mappers.cc (xround): Avoid floating-point overflow when input
	value is equal to bitmax implementation taken from gnulib).

	* file-stat.cc (file_stat::update_internal): Do not strip trailing
	file separator when path length is equal to 1 (handle case '\') under
	__WIN32__ platforms.

2008-04-07  Jaroslav Hajek  <highegg@gmail.com>

	* dbleQR.h, dbleQR.cc (QR::shift_cols): New method.
	* CmplxQR.h, CmplxQR.cc (ComplexQR::shift_cols): New method.
	* dbleCHOL.h, dbleCHOL.cc (CHOL::insert_sym, CHOL::delete_sym,
	CHOL::shift_sym): New methods.
	* CmplxCHOL.h, CmplxCHOL.cc (ComplexCHOL::insert_sym,
	ComplexCHOL::delete_sym, ComplexCHOL::shift_sym): New methods.

2008-04-03  John W. Eaton  <jwe@octave.org>

	* lo-sysdep.cc [__WIN32__ && ! __CYGWIN__]: Include windows.h.

2008-03-27  Jaroslav Hajek  <highegg@gmail.com>

	* oct-lookup.h: New file.

2008-03-26  David Bateman  <dbateman@feee.fr>

	* Array.cc (assignN): Additional fix for vector assignments.

2008-03-25  David Bateman  <dbateman@feee.fr>

	* Array.cc (assignN): refactor calculation of new dimensions when
	original matrix is empty.
	* Array-util.cc (bool is_vector (const dim_vector&)): New
	function.
	* Array-util.h (bool is_vector (const dim_vector&)): declare it.

2008-03-25  David Bateman  <dbateman@free.fr>

	* sparse-base-chol.h (sparse_base_chol_rep::~sparse_base_chol_rep
	(void)): Only free the factorization if it was created
	* spase-base-chol.cc (sparse_base_chol_rep::init): Don't attempt
	to factorize a matrix that has been flagged as not being positive
	definite.

2008-03-25  John W. Eaton  <jwe@octave.org>

	* lo-mappers.cc (xtrunc): New function.
	* lo-mappers.h: Provide decl.

2008-03-25  Jaroslav Hajek  <highegg@gmail.com>

	* lo-specfun.cc (expm1, log1p): New functions.
	* lo-specfun.h: Provide decls.

	* lo-mappers.cc (xroundb): New function.
	* lo-mappers.h: Provide decl.

2008-03-23  David Bateman  <dbateman@free.fr>

	* mx-ops: Definite binary operators for mixed integer array +
	array case, except for 64bit cases.

2008-03-21  David Bateman  <dbateman@free.fr>

	* oct-sparse.h: Add headers for amd.h.

2008-03-20  David Bateman  <dbateman@free.fr>

	* Array.cc (Array<T> Array<T>::diag (octave_idx_type) const): New
	method for diag function.
	* Array.h  (Array<T> diag (octave_idx_type) const): Declare it.
	* Array2.h (Array2<T> diag (octave_idx_type) const): New method.
	* MArray2.h (MArray2<T> diag (octave_idx_type) const): ditto.
	* ArrayN.h (ArrayN<T> diag (octave_idx_type) const): ditto.
	* MArrayN.h (MArrayN<T> diag (octave_idx_type) const): ditto.

	* Sparse.cc (Sparse<T> Sparse<T>::diag (octave_idx_type) const):
	New method for the diag function.
	* Sparse.h  (Sparse<T> diag (octave_idx_type) const): Declare it.
	* MSparse.h (MSparse<T> diag (octave_idx_type) const): New method.

	* Range.cc (Matrix Range::diag (octave_idx_type) const):
	New method for the diag function.
	* Range.h  (Matrix diag (octave_idx_type) const): Declare it.

	* CDiagMatrix.cc (ComplexColumnVector ComplexDiagMatrix::diag
	(void) const): delete.
	* dDiagMatrix.cc (ColumnVector DiagMatrix::diag (void) const): delete.
	* dDiagMatrix.h (ColumnVector diag (void) const): ditto.
	* CMatrix.cc (ComplexColumnVector ComplexMatrix::diag (void) const):
	delete.
	* CMatrix.h (ComplexColumnVector diag (void) const): ditto.
	* dMatrix.cc (ColumnVector Matrix::diag (void) const): ditto.
	* dMatrix.h (ColumnVector diag (void) const): ditto.
	* boolMatrix.cc (boolMatrix boolMatrix::diag (void) const): ditto.
	* boolMatrix.h (boolMatrix diag (void) const): ditto.
	* chMatrix.cc (charMatrix charMatrix::diag (void) const): ditto.
	* chMatrix.h (charMatrix diag (void) const): ditto.
	* intNDArray.cc (intNDArray<T> intNDArray<T>::diag (void) const): ditto.
	* intNDArray.h (intNDArray<T> diag (void) const): ditto.

	* CMatrix.cc (ComplexMatrix ComplexMatrix::diag (octave_idx_type)
	const): Rewrite in terms of template classes function.
	* CMatrix.h (ComplexMatrix diag (octave_idx_type)const ): Change
	return type.
	* dMatrix.cc (Matrix Matrix::diag (octave_idx_type) const): Rewrite in
	terms of template classes function.
	* dMatrix.h (Matrix diag (octave_idx_type) const): Change return type.
	* boolMatrix.cc (boolMatrix boolMatrix::diag (octave_idx_type) const):
	Rewrite in terms of template classes function.
	* boolMatrix.h (boolMatrix diag (octave_idx_type) const): Change
	return type.
	* chMatrix.cc (charMatrix charMatrix::diag (octave_idx_type)
	const): Rewrite in terms of template classes function.

	* dSparse.cc (SparseMatrix SparseMatrix::diag (octave_idx_type) const):
	Rewrite in terms of template classes function.
	* CSparse.cc (SparseComplexMatrix SparseComplexMatrix::diag
	(octave_idx_type) const): ditto.
	* boolSparse.cc (SparseBoolMatrix SparseBoolMatrix::diag
	(octave_idx_type) const): ditto.
	* intNDArray.cc (intNDArray<T> intNDArray<T>::diag
	(octave_idx_type) const): ditto.

	* CNDArray.cc (ComplexNDArray ComplexNDArray::diag
	(octave_idx_type) const): New method.
	* CNDArray.h (ComplexNDArray diag (octave_idx_type) const):
	Declare it.
